--             ͻ
--                             J. E. ROMBALDI               
--                      E.N.S.A.M. CHALONS SUR MARNE        
--                           COPYRIGHT (C) 1993             
--                    SPECIFICATION DU PAQUETAGE ALGEBLIN   
--             ͼ

--ͻ
--                        Utilite du paquetage.                           
--                                                                        
-- Dans ce paquetage, on trouvera des procedures et fonctions permettant  
-- de resoudre des systemes lineaires par les methodes classiques         
-- et de calculer les elements propres d'une matrice.                     
--ͼ

with COMMON_MATRIX, MATRIX;
use COMMON_MATRIX, MATRIX;

package ALGEBLIN is
ERREUR_DIAGONALE_NON_DOMINANTE, ERREUR_NON_CONVERGENCE: exception;

procedure SYSTEME_TRIANGULAIRE_SUPERIEUR(A: in MATRICE; b: in VECTEUR;
					 x: out VECTEUR);
procedure PIVOTAGE(A: in out MATRICE; b: in out VECTEUR);
function DET_MATRICE_TRIANGULAIRE(A: in MATRICE) return FLOAT;
function INV_MATRICE_TRIANG_INF(A: in MATRICE) return MATRICE;
function INV_MATRICE_TRIANG_SUP(A: in MATRICE) return MATRICE;
procedure DECOMPOSITION_LR(A: in MATRICE; L, R: in out MATRICE);
function DETERMINANT_LR(A: in MATRICE) return FLOAT;
function INVERSE_LR(A: in MATRICE) return MATRICE;
procedure GAUSS_JORDAN(A: in out MATRICE; b: in out VECTEUR);
function INVERSE_GAUSS_JORDAN(A: in MATRICE) return MATRICE;
procedure SYSTEME_TRIDIAGONAL(A: in out MATRICE_TRIDIAGONALE;
			      b: in out VECTEUR);
procedure CHOLESKY(A: in MATRICE; C: in out MATRICE);
function INVERSE_VAN_DER_MONDE(x: in VECTEUR) return MATRICE;
procedure DECOMPOSITION_QR(A: in MATRICE; Q, R: in out MATRICE);
procedure JACOBI(A: in MATRICE; b: in VECTEUR; x: in out VECTEUR);
procedure RELAXATION(A: in MATRICE; b: in VECTEUR; OMEGA: in FLOAT := 1.0;
		 x: in out VECTEUR);
end ALGEBLIN;

