--             ͻ
--                             J. E. ROMBALDI               
--                      E.N.S.A.M. CHALONS SUR MARNE        
--                           COPYRIGHT (C) 1993             
--                 SPECIFICATION DU PAQUETAGE B_SPLINE      
--             ͼ

--ͻ
--                        Utilite du paquetage.                           
--                                                                        
-- Dans ce paquetage, on trouvera des procedures permettant de realiser   
-- une approximation B_Spline.                                            
--ͼ

with CURVE, COMMON_MATRIX;
use CURVE, COMMON_MATRIX;

package B_SPLINE is

type VECTEUR_NODAL is array(NATURAL range <>) of NATURAL;
-- L'ordre j d'une courbe B_Spline verifie 2 <= j <= n + 1, ou n + 1
-- est le nombre de points de controle.
-- Le vecteur nodal est note Ne = (Ne(0), Ne(1), ...,Ne(m)), avec
-- m = n + j <= 2*n + 1.

function BASE_BSPLINE(i, j: NATURAL; Ne: VECTEUR_NODAL; t: FLOAT)
	 return FLOAT;
procedure CALCUL_BSPLINE(j: in NATURAL; Ne: in VECTEUR_NODAL;
			 x, y: in VECTEUR; t: in FLOAT; Bx, By: out FLOAT);
procedure COURBE_BSPLINE(j: in NATURAL; x, y: in VECTEUR; C: in out COURBE);
procedure TRACE_BASE_BSPLINE(n, j: in NATURAL);

end B_SPLINE;
