with TEXT_IO, FIO, MATH1;
use TEXT_IO, FIO, MATH1;
package body NOMBRES_COMPLEXES is

function "+"(A, B : COMPLEXE) return COMPLEXE is
begin
    return (A(REEL) + B(REEL), A(IMAGINAIRE) + B(IMAGINAIRE));
end "+";

function "-"(A, B : COMPLEXE) return COMPLEXE is
begin
   return (A(REEL) - B(REEL), A(IMAGINAIRE) - B(IMAGINAIRE));
end "-";

function "*"(A, B : COMPLEXE) return COMPLEXE is
begin
   return (A(REEL) * B(REEL) - A(IMAGINAIRE) * B(IMAGINAIRE),
           A(REEL) * B(IMAGINAIRE) + A(IMAGINAIRE) * B(REEL));
end "*";

function "*"(A: FLOAT;B : COMPLEXE) return COMPLEXE is
begin
   return (A*B(REEL), A*B(IMAGINAIRE));
end "*";

function "/"(A, B : COMPLEXE) return COMPLEXE is
D : constant FLOAT := (B(REEL) ** 2 + B(IMAGINAIRE) ** 2);
begin
   return ((A(REEL) * B(REEL) + A(IMAGINAIRE) * B(IMAGINAIRE)) / D,
           (A(IMAGINAIRE) * B(REEL) - A(REEL) * B(IMAGINAIRE)) / D);
end "/";

function MODULE(A : COMPLEXE) return FLOAT is
begin
      return SQRT(A(REEL)**2 + A(IMAGINAIRE)**2);
end MODULE;

procedure PUT(z: in COMPLEXE; FORE: in INTEGER := 3; AFT: in INTEGER := 3;
	      EXP: in INTEGER := 0) is
begin
    FIO.PUT(z(REEL),FORE,AFT,EXP);
    TEXT_IO.PUT(" + i*");
    FIO.PUT(z(IMAGINAIRE),FORE,AFT,EXP);
end PUT;

procedure PUT(FILE: in FILE_TYPE; z: in COMPLEXE; FORE: in INTEGER := 3; AFT: in INTEGER := 3;
	      EXP: in INTEGER := 0) is
begin
    FIO.PUT(FILE,z(REEL),FORE,AFT,EXP);
    TEXT_IO.PUT(FILE," + i*");
    FIO.PUT(FILE,z(IMAGINAIRE),FORE,AFT,EXP);
end PUT;

end NOMBRES_COMPLEXES;

 
