--             ͻ
--                             J. E. ROMBALDI               
--                      E.N.S.A.M. CHALONS SUR MARNE        
--                           COPYRIGHT (C) 1993             
--                    SPECIFICATION DU PAQUETAGE CURVE      
--             ͼ

--ͻ
--                        Utilite du paquetage.                           
--                                                                        
-- Dans ce paquetage, on trouvera des procedures permettant le trace de   
-- courbes dans le plan.                                                  
--ͼ

package CURVE is

NB_POINTS: constant NATURAL := 800;

type  COORDONNEE is array(NATURAL range <>) of FLOAT;
type  COURBE(n: NATURAL) is record
		   uMin, uMax, vMin, vMax: FLOAT;
		   u, v: COORDONNEE(0..n);
                   Rep_Axes, Rep_Grille: BOOLEAN;
                 end record;

-- Le rectangle de travail est [uMin,uMax]x[vMin,vMax], le nombre de points
-- de la courbe est u'LENGTH = v'LENGTH = n + 1, les abscisses sont
-- consignees dans le vecteur u et les ordonnees dans v. Si Rep_Axes = TRUE,
-- on trace les axes et si Rep_Grille = TRUE, on trace une grille pour mieux
-- visualiser les graduations.

procedure CHOIX_AXES(xOrigine , yOrigine , xUnite , yUnite ,
                     xFenMin , xFenMax , yFenMin , yFenMax: out FLOAT);
procedure AXES_PAR_DEFAUT(xMin , yMin , xMax , yMax: in FLOAT;
                           xOrigine , yOrigine , xUnite , yUnite ,
			   xFenMin , xFenMax ,
			   yFenMin , yFenMax: in out FLOAT);
procedure SYSTEME_AXES(xMin , yMin , xMax , yMax: in FLOAT;
                       xOrigine , yOrigine , xUnite , yUnite ,
		       xFenMin , xFenMax , yFenMin , yFenMax: in out FLOAT);
procedure INIT_COURBE(C: in out COURBE; xFenMin, xFenMax, yFenMin, yFenMax,
		      xOrigine, yOrigine, xUnite, yUnite: in out FLOAT);
procedure TRACE_COURBE(C: in COURBE);
procedure TRACE_UNE_COURBE(C: in out COURBE);

end CURVE;



