with TEXT_IO, CRT, COMMON_MATH0, MATH0, MATH2, COMMON_MATRIX,
     EDP_PARABOLIQUES;
use TEXT_IO, CRT, COMMON_MATH0, MATH0, MATH2, COMMON_MATRIX,
    EDP_PARABOLIQUES;

procedure DEM_CHAL is
Eps: constant FLOAT := 1.0E-12;
nx, nt, p: INTEGER;
k, w, L, dx, dt, dtb: FLOAT;
f: FONCTION;
CORRECT_F: BOOLEAN;

procedure PRESENTATION_CHALEUR is
begin
   PUT_LINE("     DIFFUSION DE LA CHALEUR DANS UNE BARRE");
   NEW_LINE;
   PUT_LINE(
   "- la barre est soumise a une temperature egale a zero aux extremites");
   PUT_LINE(
    "- le reste de la barre n'a aucun echange de chaleur avec l'exterieur");
   PUT_LINE("- la longueur de la barre est notee L = (nx + 1)*dx");
   PUT_LINE("tf = nt*dt est la valeur finale du temps.");
   PUT_LINE("- le coefficient de conduction est note k");
   PUT_LINE("w est le coefficient de la methode de relaxation");
   PUT_LINE (" pour w = 0, on a une methode explicite");
   PUT_LINE (" pour w = 1/2 c""est la methode de Crank-Nicholson");
   PUT_LINE (" pour w = 1 on a une methode implicite");
   PUT_LINE (" pour 0 <= w <1/2  la methode est conditionnellement stable");
   PUT_LINE (" pour 1/2 <= w <= 1 la methode est inconditionnellement stable");
   PUT_LINE(
"- la temperature dans la barre a t = 0 en un point d'abscisse x est f(x)");
   PUT_LINE("*** REMARQUE ***");
   PUT_LINE("Pour des raisons de compatibilite, f doit etre nulle en 0 et L");
   NEW_LINE;
end PRESENTATION_CHALEUR;

begin
   MODE_AFFICHAGE;
   PRESENTATION_CHALEUR;
   PAUSE; CLRSCR;
   ENTRER_REEL(L," Entrez L: ");
   ENTRER_ENTIER_BORNE(2,NX_MAX,nx," Nombre de points sur l'axe des x: ");
   dx := L/FLOAT(nx + 1);
   ENTRER_REEL(k," Entrez la valeur de k = ");
   loop
      GET_LINE(f," Entrez f(x): ");
      CORRECT_F := (abs(EVALUE(f,0.0)) <= Eps) and (ABS(EVALUE(f,L)) <= Eps);
      if not Correct_f then
	 BIP;
	 PUT_LINE("* Erreur * f doit etre nulle en 0 et L, recommencer...");
      end if;
      exit when CORRECT_F;
   end loop;
   ENTRER_REEL_BORNE(0.0,1.0,w,"Entrer w: ");
-- Choix du pas de discretisation en t:
-- Si 0 <= w < 1/2, une condition de stabilite est donnee par:
--               r = dt/(dx^2) < 1/(2*k*(1 - 2*w))
-- La valeur maximale de dt est alors dtb = (dx**2)/(2*k*(1 - w))
   if (w < 0.5) then
      dtb := (dx*dx)/(2.0*k*(1.0 - 2.0*w));
   else
      dtb := 10.0;
   end if;
   ENTRER_REEL_BORNE(0.0,dtb,dt,"Entrez la valeur de dt: ");
   ENTRER_ENTIER_BORNE(2,NT_MAX,nt,
		"Entrez le nombre de points sur l'axe des t: ");
   ENTRER_ENTIER_BORNE(1,nt,p," Entrer la periode des traces de courbes: ");
   declare
      U: MATRICE(0..nx + 1,0..nt);
   begin
      if (w = 0.0) then
	 EDP_CHALEUR_EXPLICITE(k,dx,dt,f,U);
      else
	 EDP_CHALEUR_IMPLICITE(w,k,dx,dt,f,U);
      end if;
      if LIRE_REPONSE("Voulez vous l'affichage des resultats? ") then
	 AFFICHER_TEMPERATURES(U,dt,p);
      end if;
      if LIRE_REPONSE("Voulez vous le trace des courbes? ") then
	 COURBES_CHALEUR(U,dx,p);
      end if;
   end;
   CLOSE(IMP);
end DEM_CHAL;

