with TEXT_IO, IIO, CRT, COMMON_MATH0, MATH0, COMMON_MATH1, MATH1,
     MATH2, COMMON_MATRIX, NIVEAUX, EDP_ELLIPTIQUES;
use TEXT_IO, IIO, CRT, COMMON_MATH0, MATH0, COMMON_MATH1, MATH1,
     MATH2, COMMON_MATRIX, NIVEAUX, EDP_ELLIPTIQUES;

procedure DEM_ELLI is

CHOIX: INTEGER range 1..4;

procedure DEMO_EDP_POISSON is
f, g1, g2, g3, g4: FONCTION;
n, m, NB_COURBES: INTEGER;
h, RHO_JACOBI: FLOAT;

begin
   MODE_AFFICHAGE;
   PUT_LINE("    Resolution de l'equation de Poisson: ");
   PUT_LINE("    Delta(u) = f sur un rectangle [0,a]x[o,b];");
   PUT_LINE("    avec les conditions au bord: u(x,y) = g(x,y);");
   PUT_LINE(
  "    ou g(x,0) = g1(x), g(x,b) = g2(x), g(0,y) = g3(y), g(a,y) = g4(y) .");
   NEW_LINE;
   PUT_LINE(
  "On utilise la methode des differences finies avec les notations suivantes: ");
   PUT_LINE(
  " a = (n + 1).h; b = (m + 1).h , ( h > 0 pas de discretisation donne );");
   PUT_LINE("un maillage du rectangle etant defini par: ");
   PUT_LINE(
  " (x(i),y(j)) = (i.h,j.h) pour i = 0, ..., n + 1 et j = 0, ..., m + 1 . ");
   NEW_LINE;
   PAUSE;
   CLRSCR;
   PUT_LINE("ENTREE DES DONNEES POUR L'EQUATION DE POISSON");
   NEW_LINE;
   ENTRER_ENTIER_BORNE(2,DIM_MAX,n,"Nombre de points sur l'axe des x: ");
   ENTRER_ENTIER_BORNE(2,DIM_MAX,m,"Nombre de points sur l'axe des y: ");
   ENTRER_REEL(h,"h = ");
   GET_LINE(f,"f(x,y) = ");
   GET_LINE(g1,"Condition a y = 0 , g1(x) = ");
   GET_LINE(g2,"Condition a y = b , g2(x) = ");
   GET_LINE(g3,"Condition a x = 0 , g3(y) = ");
   GET_LINE(g4,"Condition a x = a , g4(y) = ");
   RHO_JACOBI :=0.5*(COS(PI/FLOAT(n + 1)) + COS(PI/FLOAT(m + 1)));
   CLRSCR;
   declare
      U: MATRICE(0..n + 1,0..m + 1);
   begin
      RESOLUTION_POISSON(f,g1,g2,g3,g4,RHO_JACOBI,h,U);
      if LIRE_REPONSE("Voulez vous l'affichage des resultats? ") then
	 CLRSCR;
	 PUT_LINE(IMP,"Solution de l'equation de Poisson par SurRelaxation ");
	 NEW_LINE(IMP);
	 AFFICHER_SOLUTION(U);
	 PAUSE; CLRSCR;
      end if;
      if LIRE_REPONSE("Voulez vous tracer les equipotentielles? ") then
	 ENTRER_ENTIER(NB_COURBES,"Nombre de courbes a tracer: ");
	 declare
	    xMin, xMax, yMin, yMax: FLOAT;
	    U0: VECTEUR(1..NB_COURBES);
	 begin
	   for i in 1..NB_COURBES
	   loop
	      PUT("   Courbe numero "); PUT(i); NEW_LINE;
	      ENTRER_REEL(U0(i),"Entrer u0: ");
	   end loop;
	   xMin := 0.0;
	   xMax := FLOAT(n + 1)*h;
	   yMin := 0.0;
	   yMax := FLOAT(m + 1)*h;
	   TRACE_EQUIPOTENTIELLES(U,xMin,xMax,yMin,yMax,U0);
	 end;
       end if;
   end;
   CLOSE(IMP);
end DEMO_EDP_POISSON;

procedure DEMO_EDP_POISSON_2 is
f, g1, g2, g3, g4, h1, h2, h3, h4: FONCTION;
n, m, p, q, q, r, s, NB_COURBES: INTEGER;
h, RHO_JACOBI: FLOAT;

begin
   MODE_AFFICHAGE;
   PUT_LINE("  Resolution de l'equation de Poisson: ");
   PUT_LINE(" Delta(u) = f sur un rectangle troue [0,a]x[o,b] - [c,d]x[e,f]");
   PUT_LINE(" avec les conditions au bord: u(x,y) = g(x,y) sur le bord "
	     & "exterieur et u(x,y) = h(x,y) sur le bord interieur.");
   NEW_LINE;
   PUT_LINE("Avec g(x,0) = g1(x), h(x,e) = h1(x), g(x,b) = g2(x), "
	 & "h(x,f) = h2(x), g(0,y) = g3(y), h(c,y) = h3(y), g(a,y) = g4(y),"
	 & " h(d,y) = h4(y).");
   NEW_LINE;
   PUT_LINE(
  "On utilise la methode des differences finies avec les notations suivantes: ");
   PUT_LINE(" a = (n + 1).h; b = (m + 1).h , c = p.h , d = q.h , e = r.h ,"
	   & " f = s.h (h > 0 pas de discretisation donne);");
   NEW_LINE;
   PUT_LINE("un maillage du rectangle etant defini par :");
   PUT_LINE(" (x(i),y(j)) = (i.h,j.h) pour i = 0, ..., n + 1 "
	    & "et j = 0, ..., m + 1 . ");
   NEW_LINE;
   PAUSE;
   CLRSCR;
   PUT_LINE("ENTREE DES DONNEES");
   NEW_LINE;
   ENTRER_ENTIER_BORNE(2,DIM_MAX,n,"Nombre de points sur l'axe des x, n = ");
   ENTRER_ENTIER_BORNE(2,DIM_MAX,m,"Nombre de points sur l'axe des y, m = ");
   ENTRER_ENTIER_BORNE(2,n - 2,p,"Entrer p (entre 2 et n - 2): ");
   ENTRER_ENTIER_BORNE(p + 1,n - 1,q,"Entrer q (entre p + 1 et n - 1): ");
   ENTRER_ENTIER_BORNE(2,m - 2,r,"Entrer r (entre 2 et m - 2): ");
   ENTRER_ENTIER_BORNE(r + 1,m - 1,s,"Entrer s (entre r + 1 et m - 1): ");
   ENTRER_REEL(h,"h = ");
   GET_LINE(f,"f(x,y) = ");
   GET_LINE(g1,"Condition a y = 0 , g1(x) = ");
   GET_LINE(h1,"Condition a y = r.h , h1(x) = ");
   GET_LINE(h2,"Condition a y = s.h , h2(x) = ");
   GET_LINE(g2,"Condition a y = b , g2(x) = ");
   GET_LINE(g3,"Condition a x = 0 , g3(y) = ");
   GET_LINE(h3,"Condition a x = p.h , h3(y) = ");
   GET_LINE(h4,"Condition a x = q.h , h4(y) = ");
   GET_LINE(g4,"Condition a x = a , g4(y) = ");
   RHO_JACOBI := 0.5*(COS(PI/FLOAT(n + 1)) + COS(Pi/FLOAT(m + 1)));
   CLRSCR;
   declare
      U: MATRICE(0..n + 1,0..m + 1);
   begin
      RESOLUTION_POISSON_2(f,g1,g2,g3,g4,h1,h2,h3,h4,p,q,r,s,RHO_JACOBI,h,U);
      if LIRE_REPONSE("Voulez vous l'affichage des resultats? ") then
	 CLRSCR;
	 PUT_LINE(IMP,
	 "Solution de l'equation de Poisson sur un rectangle troue");
	 NEW_LINE(IMP);
	 AFFICHER_SOLUTION_2(p,q,r,s,U);
	 PAUSE;
	 CLRSCR;
      end if;
      if LIRE_REPONSE("Voulez vous tracer les equipotentielles? ") then
	 ENTRER_ENTIER(NB_COURBES,"Nombre de courbes a tracer: ");
	 declare
	    xMin, xMax, yMin, yMax: FLOAT;
	    U0: VECTEUR(1..NB_COURBES);
	 begin
	    for i in 1..NB_COURBES
	    loop
	       PUT("   Courbe numero "); PUT(i); NEW_LINE;
	       ENTRER_REEL(U0(i),"Entrer U0: ");
	    end loop;
	    xMin := 0.0;
	    xMax := FLOAT(n + 1)*h;
	    yMin := 0.0;
	    yMax := FLOAT(m + 1)*h;
	    TRACE_EQUIPOTENTIELLES(U,xMin,xMax,yMin,yMax,U0);
	 end;
      end if;
   end;
   CLOSE(IMP);
end DEMO_EDP_POISSON_2;

procedure DEMO_EDP_ELLIPTIQUE is
Alpha, Beta, Gama, Delt, Epsi, f, g1, g2, g3, g4: FONCTION;
n, m, NB_COURBES: INTEGER;
h, Omega: FLOAT;
begin
   MODE_AFFICHAGE;
   PUT_LINE("    Resolution d'une equation aux derivees partielles "
	    & "de type elliptique: ");
   PUT_LINE("Alpha.u'' + Beta.u' + Gamma.u'' + Delta.u' + Epsilon.u = f ");
   PUT_LINE("       xx         x          yy          y");
   PUT_LINE("sur un rectangle [0,a]x[o,b];");
   PUT_LINE("    avec les conditions au bord: u(x,y) = g(x,y);");
   PUT_LINE(
  "    ou g(x,0) = g1(x), g(x,b) = g2(x), g(0,y) = g3(y), g(a,y) = g4(y) .");
   NEW_LINE;
   PUT_LINE(
  "On utilise la methode des differences finies avec les notations suivantes: ");
   PUT_LINE(
  " a = (n + 1).h; b = (m + 1).h , ( h > 0 pas de discretisation donne );");
   PUT_LINE("un maillage du rectangle etant defini par: ");
   PUT_LINE(
  " (x(i),y(j)) = (i.h,j.h) pour i = 0, ..., n + 1 et j = 0, ..., m + 1 . ");
   NEW_LINE;
   PAUSE;
   CLRSCR;
   PUT_LINE("ENTREE DES DONNEES POUR UNE EQUATION ELLIPTIQUE");
   NEW_LINE;
   ENTRER_ENTIER_BORNE(2,DIM_MAX,n,"Nombre de points sur l'axe des x: ");
   ENTRER_ENTIER_BORNE(2,DIM_MAX,m,"Nombre de points sur l'axe des y: ");
   ENTRER_REEL(h,"h = ");
   GET_LINE(Alpha,"Alpha(x,y) = ");
   GET_LINE(BETA,"Beta(x,y) = ");
   GET_LINE(GAMA,"Gamma(x,y) = ");
   GET_LINE(DELT,"Delta(x,y) = ");
   GET_LINE(EPSI,"Epsilon(x,y) = ");
   GET_LINE(f,"f(x,y) = ");
   GET_LINE(g1,"Condition a y = 0 , g1(x) = ");
   GET_LINE(g2,"Condition a y = b , g2(x) = ");
   GET_LINE(g3,"Condition a x = 0 , g3(y) = ");
   GET_LINE(g4,"Condition a x = a , g4(y) = ");
   ENTRER_REEL(OMEGA,"Coeeficient de relaxation omega (entre 1 et 2) = ");
   CLRSCR;
   declare
      U: MATRICE(0..n + 1,0..m + 1);
   begin
      RESOLUTION_ELLIPTIQUE(f,g1,g2,g3,g4,Alpha,Beta,Gama,Delt,Epsi,Omega,h,U);
      if LIRE_REPONSE("Voulez vous l'affichage des resultats? ") then
	 CLRSCR;
	 PUT_LINE(IMP,"Solution de l'equation elliptique par SurRelaxation ");
	 NEW_LINE(IMP);
	 AFFICHER_SOLUTION(U);
	 PAUSE;
	 CLRSCR;
      end if;
      if LIRE_REPONSE("Voulez vous tracer les equipotentielles? ") then
	 ENTRER_ENTIER(NB_COURBES,"Nombre de courbes a tracer: ");
	 declare
	    xMin, xMax, yMin, yMax: FLOAT;
	    U0: VECTEUR(1..NB_COURBES);
	 begin
	   for i in 1..NB_COURBES
	   loop
	      PUT("   Courbe numero "); PUT(i); NEW_LINE;
	      ENTRER_REEL(U0(i),"Entrer u0: ");
	   end loop;
	   xMin := 0.0;
	   xMax := FLOAT(n + 1)*h;
	   yMin := 0.0;
	   yMax := FLOAT(m + 1)*h;
	   TRACE_EQUIPOTENTIELLES(U,xMin,xMax,yMin,yMax,U0);
	 end;
       end if;
   end;
   CLOSE(IMP);
end DEMO_EDP_ELLIPTIQUE;

begin
    loop
       CLRSCR;
       PUT_LINE("-1- Resolution d'une equation de Poisson: Delta(u) = f");
       PUT_LINE(
	 "-2- Resolution d'une equation de Poisson sur un rectangle troue");
       PUT_LINE("-3- Resolution d'une e.d.p. de type elliptique");
       PUT_LINE("-4- FIN");
       NEW_LINE;
       ENTRER_ENTIER_BORNE(1,4,CHOIX,"Votre choix: ");
       case CHOIX is
	  when 1 => DEMO_EDP_POISSON;
	  when 2 => DEMO_EDP_POISSON_2;
	  when 3 => DEMO_EDP_ELLIPTIQUE;
	  when 4 => exit;
       end case;
    end loop;
end DEM_ELLI;
