with TEXT_IO, IIO, FIO, CRT, COMMON_MATH0, MATH0, MATH1, MATH2,
     EQUATIONS_GENERIQUE;
use TEXT_IO, IIO, FIO, CRT, COMMON_MATH0, MATH0, MATH1, MATH2;

procedure DEM_EQU is

FF: FONCTION;
Choix: INTEGER range 0..2;

function f(x: in FLOAT) return FLOAT is
begin
    return EVALUE(FF,x);
end f;

package EQUATIONS is new EQUATIONS_GENERIQUE(f);
use EQUATIONS;

procedure DEMO_DICHOTOMIE is
a, b, ak, bk, x, y, z, h: FLOAT;
n, k: INTEGER;
begin
    MODE_AFFICHAGE;
    PUT_LINE("  RACINES DE f(x) = 0 SUR [a,b] PAR LA METHODE DE DICHOTOMIE.");
    NEW_LINE;
    PUT_LINE("L'intervalle [a,b] est decoupe en n sous intervalle");
 PUT_LINE("et on cherche une racine dans chaque [ai,bi] si f(ai)*f(bi) <= 0");
    NEW_LINE;
    GET_LINE(FF,"Entrez l'equation: f(x) = ");
    NEW_LINE;
    ENTRER_REEL(a,"Valeur de a: ");
    ENTRER_REEL_BORNE(a,1.0E+6,b,"Valeur de b: ");
    NEW_LINE;
    ENTRER_ENTIER(n,"Nombre de sous intervalles: ");
    NEW_LINE;
    h := (b - a)/FLOAT(n);
    ak := a;
    k := 0;
    FOR i in 0..n - 1
    loop
       y := f(ak);
       z := f(ak + h);
       if (y = 0.0) then
	  k := k + 1;
	  PUT(IMP,"Solution "); PUT(IMP,k,2); PUT(IMP," = ");
	  PUT(IMP,ak,5,6,0);
	  NEW_LINE(IMP);
       end if;
       if (y*z < 0.0) then
	  DICHOTOMIE(ak,ak + h,x);
	  k := k + 1;
	  PUT(IMP,"Solution "); PUT(IMP,k,2); PUT(IMP," = ");
	  PUT(IMP,x,5,6,0);
	  NEW_LINE(IMP);
       end if;
       ak := ak + h;
    end loop;
    CLOSE(IMP);
end DEMO_DICHOTOMIE;

procedure DEMO_NEWTON_RAPHSON is
x0, x: FLOAT;
k: INTEGER;
begin
    MODE_AFFICHAGE;
    PUT_LINE("  RACINE DE f(x) = 0 [a,b] PAR LA METHODE DE NEWTON-RAPHSON.");
    NEW_LINE;
    GET_LINE(FF,"Entrez l'equation: f(x) = ");
    NEW_LINE;
    ENTRER_REEL(x0,"Valeur initiale x0: ");
    NEW_LINE;
    NEWTON_RAPHSON(x0,x);
    PUT("Solution x = "); PUT(x,5,6);
    NEW_LINE;
    CLOSE(IMP);
end DEMO_NEWTON_RAPHSON;


begin
  loop
    CLRSCR;
    PUT_LINE("-0- FIN");
    PUT_LINE("-1- Recherches des racines de f(x) = 0 par dichotomie");
    PUT_LINE("-2- Recherche d'une racine de f(x) = 0 par la methode de Newton");
    NEW_LINE;
    ENTRER_ENTIER_BORNE(0,2,Choix,"Votre choix: ");
    case Choix is
      when 0 => exit;
      when 1 => DEMO_DICHOTOMIE; PAUSE;
      when 2 => DEMO_NEWTON_RAPHSON; PAUSE;
    end case;
  end loop;
end DEM_EQU;

