with TEXT_IO, IIO, FIO, CRT, COMMON_MATH0, MATH0, MATH1, GRAPH, MATH2, MATH3,
     CURVE, NOMBRES_COMPLEXES, COMMON_FOURIER, FOURIER_GENERIQUE,
     COMMON_MATRIX, MATRIX;
use TEXT_IO, IIO, FIO, CRT, COMMON_MATH0, MATH0, MATH1, GRAPH, MATH2, MATH3,
    CURVE, NOMBRES_COMPLEXES, COMMON_FOURIER, COMMON_MATRIX, MATRIX;

procedure DEM_FFT is

MAX_FONCTIONS: constant INTEGER := 10;
subtype INDICE_FONCTION is INTEGER range 0..MAX_FONCTIONS;
type TABLEAU_DE_FONCTIONS is array(INDICE_FONCTION range <>) of FONCTION;

NBR_INT, p, n, m: INTEGER;

procedure AFFICHER_FFT(D: in FLOAT;
		       y: in VECTEUR_COMPLEXE) is
--               ^      ^
-- Affichage des y(k) = f(k/tMax) = D*y(k), ou des c(k) = y(k)/n, ou:
-- n = 2^p, k = -n/2, ..., O, ..., n/2 - 1.

m: INTEGER;
begin
    m := y'LENGTH/2;
    for i in m..y'LENGTH - 1
    loop
	PUT(IMP,"x("); PUT(IMP,i - n,3); PUT(IMP,") = ");
	PUT(D*y(i)); NEW_LINE;
	if (i + 1) mod 20 = 0 then
	   PAUSE;
	end if;
    end loop;
    for i in 0..m - 1
    loop
	PUT(IMP,"x("); PUT(i,3); PUT(") = ");
	PUT(D*y(i));
	NEW_LINE;
	if (i + 1) mod 20 = 0 then
	   PAUSE;
	end if;
    end loop;
end AFFICHER_FFT;

begin
-- DONNEES POUR LE CALCUL D'UNE F.F.T. ET DES COEFFICIENTS DE FOURIER
--     La fonction f(t) est defini comme une fonction continue
--     par morceaux sur un intervalle [0,tn], avec: 0 < t1 < ... < tn
--     et:
--              f(t) = f(k-1)(t), si t dans [t(k-1),t(k)] (k = 1, ..., n),
--     les fonctions f(k) etant continues pour k = 0, ..., n - 1.
    CLRSCR;
    PUT_LINE(
      "Calculs de la FFT et des coefficients de Fourier d'une fonction f");
    NEW_LINE;
    PUT_LINE("La fonction est definie sur [0,tMax], de periode tMax,");
    PUT_LINE("par des fonctions continues fk sur [tk,t(k+1)], avec");
    PUT_LINE("       0 < t1 < ... < tn = tMax");
    NEW_LINE;
    ENTRER_ENTIER_BORNE(1,MAX_FONCTIONS,NBR_INT,
			"Nombre d'intervalles: ");
    NEW_LINE;
    PUT_LINE("Le nombre de points de l'echantillonnage de f est n = 2^p.");
    ENTRER_ENTIER_BORNE(1,p_Max,p,"p = ");
    n := 2**p;
    m := n/2;
    declare
       ff: TABLEAU_DE_FONCTIONS(0..NBR_INT - 1);
       t: VECTEUR(0..NBR_INT);
       x, y: VECTEUR_COMPLEXE(0..n - 1);
       a: VECTEUR(0..m- 1);
       b: VECTEUR(1..m - 1);
       C: COURBE(n);
       PAS, D, xOrigine, yOrigine, xUnite, yUnite,
       xFenMin, xFenMax, yFenMin, yFenMax: FLOAT;

       function f(x: in FLOAT) return FLOAT is
       k: INTEGER := 0;
       begin
	   loop
	      k := k + 1;
	      exit when (t(k) >= x) or (k = NBR_INT);
	   end loop; -- x est dans [t(k-1),t(k)]
	   return EVALUE(ff(k - 1),x);
       end f;

       package FOURIER_F is new FOURIER_GENERIQUE(f);
       use FOURIER_F;

    begin
       t(0) := 0.0;
       PUT_LINE("Entree des bornes des intervalles: t1, t2, ..., tn");
       for k in 1..NBR_INT
       loop
	  ENTRER_REEL_BORNE(t(k-1),1.0E+32,t(k),"t = ");
       end loop;
       NEW_LINE;
       PUT_LINE("Definition de la fonction f = (f0,...,f(n-1))");
       for k in 0..NBR_INT - 1
       loop
	  GET_LINE(ff(k),"f(x) = ");
       end loop;
       NEW_LINE;
       MODE_AFFICHAGE;
       PUT_LINE(IMP,"Calcul de l'echantillonnage: Vecteur x:");
       ECHANTILLONNAGE(t(NBR_INT),x, D);
       for i in x'range
       loop
	 PUT(IMP,"x"); PUT(IMP,i,3); PUT(IMP," = ");
	 PUT(IMP,x(i));
	 NEW_LINE(IMP);
	 if (i + 1) mod 20 = 0 then
	    PAUSE;
	 end if;
       end loop;
       NEW_LINE(IMP);
       PUT_LINE(IMP,"Calcul de la transformee de Fourier discrete");
       NEW_LINE(IMP);
       FFT(x,y);
       PUT_LINE(IMP,"VERIFICATION: FORMULE DE PLANCHEREL");
       PUT(IMP,"Ex = "); PUT(IMP,ENERGIE(x),6,6);
       PUT(IMP,";   Ey/n = "); PUT(IMP,ENERGIE(y)/FLOAT(n),6,6);
       PAUSE;
       CLRSCR;
       PUT_LINE(Imp,"Calcul des coefficients de Fourier trigonometriques");
       CALCUL_COEFFICIENTS_DE_FOURIER(y,a,b);
       CLRSCR;
       PUT_LINE(IMP,"Transformee de Fourier ");
       AFFICHER_FFT(D,y);
       PAUSE;
       CLRSCR;
       PUT_LINE(IMP,"Coefficients de Fourier complexes");
       AFFICHER_FFT(1.0/FLOAT(n),y);
       PAUSE;
       CLRSCR;
       PUT_LINE(IMP,"Coefficients de Fourier trigonometriques");
       PUT_LINE("Coefficients a(k), pour k = 0, ..., n/2 - 1");
       PUT_LINE(a);
       NEW_LINE;
       PUT_LINE("Coefficients b(k), pour k = 1, ..., n/2 - 1");
       PUT_LINE(b);
       NEW_LINE;
       PAUSE;
       CLRSCR;
       C.uMin := 0.0;
       C.uMax := t(NBR_INT);
       PAS := (C.uMax - C.uMin)/FLOAT(C.n);
       C.vMIN := 1.0E+37;
       C.vMAX := -C.vMIN;
       C.u(0) := C.uMin;
       C.v(0) := f(C.u(0));
       for i in 1..C.n loop
	  C.u(i) := C.u(i-1) + PAS;
	  C.v(i) := f(C.u(i));
	  C.vMIN := MIN(C.vMIN,C.v(i-1));
	  C.vMAX := MAX(C.vMAX,C.v(i-1));
       end loop;
       TRACE_UNE_COURBE(C);
       TITRE("Signal initial");
       PAUSE_GRAPHIQUE;
       CLEAR_SCREEN;
       TITRE("Reconstitution par les series de Fourier");
       TRACE_UNE_SERIE_DE_FOURIER(t(NBR_INT),a,b,n);
       XY_AXES(xOrigine,yOrigine,xUnite,yUnite,TRUE);
       PAUSE_GRAPHIQUE;
    end;
    MODE_TEXTE;
end DEM_FFT;
