with TEXT_IO, FIO, CRT, COMMON_MATH0, MATH0, MATH2, INTEGRATION_GENERIQUE;
use TEXT_IO, FIO, CRT, COMMON_MATH0, MATH0, MATH2;

procedure DEM_INT is

CHOIX: NATURAL range 0..7;
ff: FONCTION;

function f(x: in FLOAT) return FLOAT is
begin
    return EVALUE(ff,x);
end f;

package INTEGRATION_F is new INTEGRATION_GENERIQUE(f);
use INTEGRATION_F;

procedure DONNEES_INTEGRATION(a, b: in out FLOAT) is
begin
  PUT_LINE("               Calculs d'integrales definies");
  NEW_LINE;
  GET_LINE(ff,"Donner la fonction a integrer, f(x) = ");
  ENTRER_REEL(a,"Donner la valeur minimale de l'abscisse: ");
  ENTRER_REEL_BORNE(a,1.0E+12,b,"Donner la valeur maximale de l'abscisse: ");
end DONNEES_INTEGRATION;
-- 
procedure DEMO_TRAPEZES is
a, b, T: FLOAT;
begin
    MODE_AFFICHAGE;
    DONNEES_INTEGRATION(a,b);
    T := INTEGRATION_TRAPEZES(a,b);
    PUT(IMP,"  Integrale de f(x) = ");
    PUT(IMP,TEXTE_DE_FONCTION(ff));
    PUT(IMP," sur [");
    PUT(IMP,a,4,2,0);
    PUT(IMP,",");
    PUT(IMP,b,4,2,0);
    PUT(IMP,"] = ");
    PUT(IMP,T,6,4,0);
    NEW_LINE(IMP);
    CLOSE(IMP);
    PAUSE;
end DEMO_TRAPEZES;
-- 
procedure DEMO_SIMPSON is
a, b, S: FLOAT;
begin
    MODE_AFFICHAGE;
    DONNEES_INTEGRATION(a,b);
    S := INTEGRATION_SIMPSON(a,b);
    PUT(IMP,"  Integrale de f(x) = ");
    PUT(IMP,TEXTE_DE_FONCTION(ff));
    PUT(IMP," sur [");
    PUT(IMP,a,4,2,0);
    PUT(IMP,",");
    PUT(IMP,b,4,2,0);
    PUT(IMP,"] = ");
    PUT(IMP,S,6,4,0);
    NEW_LINE(IMP);
    CLOSE(IMP);
    PAUSE;
end DEMO_SIMPSON;
-- 
procedure DEMO_ROMBERG is
a, b, R: FLOAT;
begin
    MODE_AFFICHAGE;
    DONNEES_INTEGRATION(a,b);
    R := INTEGRATION_ROMBERG(a,b);
    PUT(IMP,"  Integrale de f(x) = ");
    PUT(IMP,TEXTE_DE_FONCTION(ff));
    PUT(IMP," sur [");
    PUT(IMP,a,4,2,0);
    PUT(IMP,",");
    PUT(IMP,b,4,2,0);
    PUT(IMP,"] = ");
    PUT(IMP,R,6,4,0);
    NEW_LINE(IMP);
    CLOSE(IMP);
    PAUSE;
end DEMO_ROMBERG;
-- 
procedure DEMO_LEGENDRE is
a, b, R: FLOAT;
begin
    MODE_AFFICHAGE;
    DONNEES_INTEGRATION(a,b);
    R := Integration_Legendre(a,b);
    PUT(IMP,"  Integrale de f(x) = ");
    PUT(IMP,TEXTE_DE_FONCTION(ff));
    PUT(IMP," sur [");
    PUT(IMP,a,4,2,0);
    PUT(IMP,",");
    PUT(IMP,b,4,2,0);
    PUT(IMP,"] = ");
    PUT(IMP,R,6,4,0);
    NEW_LINE(IMP);
    CLOSE(IMP);
    PAUSE;
end DEMO_LEGENDRE;
-- 
procedure DEMO_LAGUERRE is
S: FLOAT;
begin
   MODE_AFFICHAGE;
   PUT_LINE(" CALCUL DE L'INTEGRALE IMPROPRE DE EXP(-x).f(x) SUR R+");
   NEW_LINE;
   PUT_LINE(" Utilisation du polynome de Laguerre Numero 12");
   NEW_LINE;
   GET_LINE(ff," Entrer la fonction a integrer f(x) = ");
   NEW_LINE;
   S := Integration_Laguerre;
   PUT(IMP," Valeur approchee de l'integrale, I = ");
   PUT(IMP,S,6,4,0);
   NEW_LINE(IMP);
   CLOSE(IMP);
   PAUSE;
end DEMO_LAGUERRE;
-- 
procedure DEMO_HERMITE is
S: FLOAT;
begin
   MODE_AFFICHAGE;
   PUT_LINE(" CALCUL DE L'INTEGRALE IMPROPRE DE EXP(-x**2).f(x) sur R");
   NEW_LINE;
   PUT_LINE(" Utilisation du polynome d'Hermite Numero 10");
   NEW_LINE;
   GET_LINE(ff," Entrer la fonction a integrer f(x) = ");
   NEW_LINE;
   S := INTEGRATION_HERMITE;
   PUT(IMP," Valeur approchee de l'integrale, I = ");
   PUT(IMP,S,6,4,0);
   NEW_LINE(IMP);
   CLOSE(IMP);
   PAUSE;
end DEMO_HERMITE;
-- 
procedure DEMO_TCHEBYCHEV is
S: FLOAT;
begin
   MODE_AFFICHAGE;
PUT_LINE(" CALCUL DE L'INTEGRALE IMPROPRE de f(x)/SQRT(1 - x*x) sur [-1,1]");
   NEW_LINE;
   PUT_LINE(" Utilisation du polynome de Tchebychev Numero 30");
   NEW_LINE;
   GET_LINE(ff," Entrer la fonction a integrer f(x) = ");
   NEW_LINE;
   S := INTEGRATION_TCHEBYCHEV;
   PUT(IMP," Valeur approchee de l'integrale, I = ");
   PUT(IMP,S,6,4,0);
   NEW_LINE(IMP);
   CLOSE(IMP);
   PAUSE;
end DEMO_TCHEBYCHEV;
-- 
procedure MENU_INTEGRATION(CHOIX: out NATURAL) is
begin
    CLRSCR;
    PUT_LINE("Calcul d'integrales");
    PUT_LINE("-0- FIN");
    PUT_LINE("-1- Methode des trapezes");
    PUT_LINE("-2- Methode de Simpson");
    PUT_LINE("-3- Methode de Romberg");
    PUT_LINE("-4- Methode de Legendre");
    PUT_LINE("-5- Methode de Tchebychev (sur [-1,1])");
    PUT_LINE("-6- Methode de Laguerre ( sur [0,+[)");
    PUT_LINE("-7- Methode d'Hermite (Sur R )");
    ENTRER_ENTIER_BORNE(0,7,CHOIX,"Votre choix: ");
    CLRSCR;
end MENU_INTEGRATION;
-- 
begin
    loop
      MENU_INTEGRATION(CHOIX);
      case CHOIX is
	when 0 => exit;
	when 1 => Demo_Trapezes;
	when 2 => Demo_Simpson;
	when 3 => Demo_Romberg;
	when 4 => Demo_Legendre;
	when 5 => Demo_Tchebychev;
	when 6 => Demo_Laguerre;
	when 7 => Demo_Hermite;
      end case;
    end loop;
end DEM_INT;



