with CRT, TEXT_IO, MATH0, COMMON_MATH1, MATH1, MATH2, MATH3,
     CURVE, COMMON_MATRIX, LAGRANGE, DONNEES_POINTS;
use CRT, TEXT_IO, MATH0, COMMON_MATH1, MATH1, MATH2, MATH3,
    CURVE, COMMON_MATRIX, LAGRANGE, DONNEES_POINTS;

procedure DEM_LAGR is

CHOIX: NATURAL range 0..2;
n: NATURAL;
f: FONCTION;

procedure MENU_LAGRANGE(CHOIX: out NATURAL) is
begin
    CLRSCR;
    PUT_LINE("         POLYNOME D'INTERPOLATION DE LAGRANGE");
    NEW_LINE(2);
    PUT_LINE("-0- FIN");
    PUT_LINE("-1- Interpolation d'une fonction connue en quelques points");
    PUT_LINE("-2- Interpolation d'une fonction donnee analytiquement");
    NEW_LINE;
    ENTRER_ENTIER_BORNE(0,2,CHOIX,"Votre choix: ");
    CLRSCR;
end MENU_LAGRANGE;
-- 

begin
   loop
      MENU_LAGRANGE(CHOIX);
      case CHOIX is
	when 0 => exit;
	when 1 =>
	      ENTRER_ENTIER_BORNE(3,DIM_MAX,n,
				  "Nombre de points du nuage (> 2): ");
	      declare
		x, y: VECTEUR(0..n);
		C: COURBE(300);
	      begin
		ENTRER_POINTS(x,y,TRUE);
		PUT_LINE("TRACE DE LA COURBE D'INTERPOLATION DE LAGRANGE");
		COURBE_INTERPOLATION_LAGRANGE(x, y, x(1), x(n), C);
		TRACE_UNE_COURBE(C);
		SORTIE_GRAPHIQUE;
	      end;
	when 2 =>
	      GET_LINE(f,"Fonction a interpoler, f(x) = ");
	      ENTRER_ENTIER_BORNE(3,DIM_MAX,n,
				  "Nombre de points du nuage (> 2): ");
	      n := n - 1;
	      declare
		x, y: VECTEUR(0..n);
		C: COURBE(300);
		Pas, a, b: FLOAT;
	      begin
		PUT_LINE("L'intervalle de definition de f est note [a,b]");
		ENTRER_REEL(a,"a = ");
		ENTRER_REEL_BORNE(a,1.0E+10,b,"b = ");
		if LIRE_REPONSE(
		    "Interpolation avec les abscisses de Tchebychev? ") then
		   for i in x'range loop
		     x(i) := 0.5*((b-a)*Cos(FLOAT(2*i+1)/FLOAT(2*n+2)*Pi)
			     + b + a);
		     y(i) := EVALUE(f,x(i));
		   end loop;
		else
		   Pas := (b - a)/FLOAT(n);
		   x(0) := a;
		   y(0) := EVALUE(f,a);
		   for i in 1..n loop
		     x(i) := x(i-1) + Pas;
		     y(i) := EVALUE(f,x(i));
		   end loop;
		end if;
		PUT_LINE("TRACE DE LA COURBE D'INTERPOLATION DE LAGRANGE");
		COURBE_INTERPOLATION_LAGRANGE(x, y, a, b, C);
		TRACE_UNE_COURBE(C);
		Pas := (b - a)/FLOAT(C.n);
		for i in 0..C.n loop
		   POINT(a,EVALUE(f,a));
		   a := a + Pas;
		end loop;
		SORTIE_GRAPHIQUE;
	      end;
      end case;
   end loop;
end DEM_LAGR;
