with TEXT_IO, IIO, FIO, CRT, COMMON_MATH0, MATH0, MATH1, MATH2,
     MATH3, COMMON_MATRIX, EQUADIFF_11_GENERIQUE;
use TEXT_IO, IIO, FIO, CRT, COMMON_MATH0, MATH0, MATH1, MATH2,
    MATH3, COMMON_MATRIX;

procedure DEM_RK11 is

N_MAX: constant INTEGER := 500;
n: INTEGER;
a, b, ya: FLOAT;
AFFICHER, CONTROLE_DU_PAS: BOOLEAN;
x, y: VECTEUR(0..N_MAX);
X_UNITE, Y_UNITE, X_FEN_MIN, X_FEN_MAX, Y_FEN_MIN, Y_FEN_MAX: FLOAT;
FF: FONCTION;

function f(x, y: in FLOAT) return FLOAT is
begin
    return EVALUE(FF,x,y);
end f;

package EQUADIFF_11_F is new EQUADIFF_11_GENERIQUE(f);
use EQUADIFF_11_F;

begin
    MODE_AFFICHAGE;
    PUT_LINE("      EQUATIONS DIFFERENTIELLES A 1 VARIABLE D'ORDRE 1");
    NEW_LINE;
    PUT_LINE("           METHODE DE RUNGE-KUTTA D'ORDRE 4");
    NEW_LINE;
    GET_LINE(FF,"Entrez l'equation:  y' = f(x,y) = ");
    NEW_LINE;
    ENTRER_REEL(a,"Valeur de a: ");
    ENTRER_REEL_BORNE(a,1.0E+6,b,"Valeur de b: ");
    ENTRER_REEL(ya,"Valeur initiale en a: ");
    NEW_LINE;
    NEW_LINE;
    AFFICHER := LIRE_REPONSE("Voulez-vous l'affichage des resultats? ");
    CONTROLE_DU_PAS := LIRE_REPONSE("Methode avec controle du pas? ");
    CLRSCR;
    if (CONTROLE_DU_PAS) then
       RESOLUTION_RK4_11_CONTROLE(a,b,ya,AFFICHER,x,y);
    else
       RESOLUTION_RK4_11(a,b,ya,AFFICHER,x,y);
    end if;
    PAUSE;
    CLRSCR;
    if LIRE_REPONSE("Voulez vous le trace de la solution trouvee? ") then
       n := x'LAST;
       X_UNITE := (b - a)/20.0;
       X_FEN_MIN := a - X_UNITE;
       X_FEN_MAX := b + X_UNITE;
       Y_FEN_MIN := 1.0E+38;
       Y_FEN_MAX := -1.0E+38;
       for i in y'range
       loop
	  Y_FEN_MIN := MIN(Y_FEN_MIN,y(i));
	  Y_FEN_MAX := MAX(Y_FEN_MAX,y(i));
	  if (x(i) > b) then
	     n := i - 1;
	     exit;
	  end if;
       end loop;
       Y_UNITE := (Y_FEN_MAX - Y_FEN_MIN)/20.0;
       Y_FEN_MIN := Y_FEN_MIN - Y_UNITE;
       Y_FEN_MAX := Y_FEN_MAX + Y_UNITE;
       INIT_GRAPHIQUE;
       FENETRE_GRAPHIQUE(X_FEN_MIN,X_FEN_MAX,Y_FEN_MIN,Y_FEN_MAX);
       XY_AXES(a,Y_FEN_MIN + Y_UNITE,X_UNITE,Y_UNITE,TRUE);
       DEPLACE(x(x'FIRST),y(y'FIRST));
       for i in x'FIRST + 1..n
       loop
	  TRACE(x(i),y(i));
       end loop;
       TITRE("Graphe de la solution approchee y = y(x)");
       SORTIE_GRAPHIQUE;
    end if;
    CLOSE(IMP);
end DEM_RK11;

