with TEXT_IO, IIO, CRT, COMMON_MATH0, MATH0, MATH1, MATH2,
     MATH3, COMMON_MATRIX, EQUADIFF_1Q_GENERIQUE;
use TEXT_IO, IIO, CRT, COMMON_MATH0, MATH0, MATH1, MATH2,
    MATH3, COMMON_MATRIX;

procedure DEM_RK1Q is
N_MAX: constant INTEGER := 500;
MAX_ORDRE: constant INTEGER := 10;
a, b: FLOAT;
q: INTEGER;
AFFICHER, CONTROLE_DU_PAS: BOOLEAN;
FF: FONCTION;
x, y: VECTEUR(0..N_MAX);
n: INTEGER := x'LAST;
X_UNITE, Y_UNITE, X_FEN_MIN, X_FEN_MAX, Y_FEN_MIN, Y_FEN_MAX: FLOAT;

function f(x: in FLOAT; y: in VARIABLE_2) return FLOAT is
begin
    return EVALUE(FF,x,y);
end f;

package EQUADIFF_1Q_F is new EQUADIFF_1Q_GENERIQUE(F);
use EQUADIFF_1Q_F;

begin
    MODE_AFFICHAGE;
    PUT_LINE("      EQUATIONS DIFFERENTIELLES A 1 VARIABLE D'ORDRE Q");
    NEW_LINE;
    PUT_LINE("           METHODE DE RUNGE-KUTTA D'ORDRE 4");
    NEW_LINE;
    PUT_LINE(" L'equation est ecrite sous la forme:");
    PUT_LINE("    (q)              (q-1)");
    PUT_LINE("   y    = f(x,y,...,y     )");
    PUT_LINE(" ");
    PUT_LINE("La derivee d'ordre i est notee yi, pour i = 0, ..., q - 1");
    NEW_LINE;
    ENTRER_ENTIER_BORNE(1,MAX_ORDRE,q,"Ordre de l'equation: ");
    NEW_LINE;
    declare
       ya: VARIABLE_2(0..q-1);
    begin
       PUT("Equation f(x,y0,");
       FOR k in 1..q - 2
       loop
	  PUT("y"); PUT(k,2); PUT(",");
       end loop;
       PUT("y"); PUT(q-1,2); PUT_LINE(") = ");
       GET_LINE(FF,"   ");
       NEW_LINE;
       ENTRER_REEL(a,"Valeur de a: ");
       ENTRER_REEL_BORNE(a,1.0E+6,b,"Valeur de b: ");
       for k in 0..q - 1
       loop
	  PUT("Valeur initiale de la derivee d'ordre "); PUT(k,2);
	  NEW_LINE;
	  ENTRER_REEL(ya(k),"   ");
       end loop;
       NEW_LINE;
       AFFICHER := LIRE_REPONSE("Voulez-vous l'affichage des resultats? ");
       CONTROLE_DU_PAS := LIRE_REPONSE("Methode avec controle du pas? ");
       CLRSCR;
       if (CONTROLE_DU_PAS) then
	  RESOLUTION_RK4_1Q_CONTROLE(a,b,ya,AFFICHER,x,y);
       else
	  RESOLUTION_RK4_1Q(a,b,ya,AFFICHER,x,y);
       end if;
       PAUSE;
       CLRSCR;
       if LIRE_REPONSE("Voulez vous le trace de la solution trouvee? ") then
	  X_UNITE := (b - a)/20.0;
	  X_FEN_MIN := a - X_UNITE;
	  X_FEN_MAX := b + X_UNITE;
	  Y_FEN_MIN := 1.0E+38;
	  Y_FEN_MAX := -1.0E+38;
	  for i in y'range
	  loop
	     Y_FEN_MIN := MIN(Y_FEN_MIN,y(i));
	     Y_FEN_MAX := MAX(Y_FEN_MAX,y(i));
	     if (x(i) > b) then
		n := i - 1;
		exit;
	     end if;
	  end loop;
	  Y_UNITE := (Y_FEN_MAX - Y_FEN_MIN)/20.0;
	  Y_FEN_MIN := Y_FEN_MIN - Y_UNITE;
	  Y_FEN_MAX := Y_FEN_MAX + Y_UNITE;
	  INIT_GRAPHIQUE;
	  FENETRE_GRAPHIQUE(X_FEN_MIN,X_FEN_MAX,Y_FEN_MIN,Y_FEN_MAX);
	  XY_AXES(a,Y_FEN_MIN + Y_UNITE,X_UNITE,Y_UNITE,TRUE);
	  DEPLACE(x(x'FIRST),y(y'FIRST));
	  for i in x'FIRST + 1..n
	  loop
	     TRACE(x(i),y(i));
	  end loop;
	  TITRE("Graphe de la solution approchee y = y(x)");
	  SORTIE_GRAPHIQUE;
       end if;
    end;
    CLOSE(IMP);
end DEM_RK1Q;

