with TEXT_IO, IIO, CRT, COMMON_MATH0, MATH0, MATH1, GRAPH,
     MATH2, MATH3, COMMON_MATRIX, EQUADIFF_P1_GENERIQUE;
use TEXT_IO, IIO, CRT, COMMON_MATH0, MATH0, MATH1, GRAPH,
    MATH2, MATH3, COMMON_MATRIX;

procedure DEM_RKP1 is
N_MAX: constant INTEGER := 500;
MAX_FONCTIONS: constant INTEGER := 10;
subtype INDICE_FCT is INTEGER range 1..MAX_FONCTIONS;
type SYSTEME_DIFF is array(INDICE_FCT range <>) of FONCTION;

a, b: FLOAT;
AFFICHER, CONTROLE_DU_PAS: BOOLEAN;
p: INTEGER;
X_UNITE, Y_UNITE, X_FEN_MIN, X_FEN_MAX, Y_FEN_MIN, Y_FEN_MAX: FLOAT;
x: VECTEUR(0..N_MAX);
n: INTEGER;
begin
    MODE_AFFICHAGE;
    PUT_LINE ("      SYSTEME DE P EQUATIONS DIFFERENTIELLES  D'ORDRE 1");
    NEW_LINE;
    PUT_LINE("           METHODE DE RUNGE-KUTTA D'ORDRE 4");
    NEW_LINE;
    PUT_LINE(" Le systeme d'equations est ecrit sous la forme:");
    NEW_LINE;
    PUT_LINE("   y' = f (x,y , ...,y   )");
    PUT_LINE("    j    j    1       p");
    NEW_LINE;
    PUT(" pour j = 1, ..., p, ou 1 <= p <= ");
    PUT(MAX_FONCTIONs);
    NEW_LINE;
    ENTRER_ENTIER_BORNE(1,MAX_FONCTIONS,p,"Nombre d'equations: ");
    NEW_LINE;
    declare
       FF: SYSTEME_DIFF(1..p);
       ya: VARIABLE_2(1..p);
       y: MATRICE(0..N_MAX,1..p);
       function f(j: in POSITIVE; x: in FLOAT; y: in VARIABLE_2) return FLOAT is
       begin
	   return EVALUE(FF(j),x,y);
       end f;

       package EQUADIFF_P1_F is new EQUADIFF_P1_GENERIQUE(F);
       use EQUADIFF_P1_F;

    begin
       for j in YA'range
       loop
	  PUT("Equation Numero "); PUT(j,2); NEW_LINE;
	  PUT("f(x,");
	  for k in 1..p - 1
	  loop
	     PUT("y"); PUT(k,2); PUT(",");
	  end loop;
	  PUT("y"); PUT(p,2); PUT_LINE(") = ");
	  GET_LINE(ff(j),"   ");
       end loop;
       NEW_LINE;
       PUT_LINE(" Bornes de l'intervalle");
       NEW_LINE;
       ENTRER_REEL(a,"Valeur de a: ");
       ENTRER_REEL_BORNE(a,1.0E+6,b,"Valeur de b: ");
       for j in ya'range
       loop
	  PUT("Valeur initiale y"); PUT(j,2); PUT_LINE("(a)");
	  ENTRER_REEL(ya(j),"  y = ");
       end loop;
       NEW_LINE;
       AFFICHER := LIRE_REPONSE("Voulez-vous l'affichage des resultats? ");
       CONTROLE_DU_PAS := LIRE_REPONSE("Methode avec controle du pas? ");
       CLRSCR;
       if (CONTROLE_DU_PAS) then
	  RESOLUTION_RK4_P1_CONTROLE(a,b,ya,AFFICHER,x,y);
       else
	  RESOLUTION_RK4_P1(a,b,ya,AFFICHER,x,y);
       end if;
       PAUSE;
       CLRSCR;
       if LIRE_REPONSE("Voulez vous le trace de la solution trouvee? ") then
	  n := x'LAST;
	  INIT_GRAPHIQUE;
	  X_UNITE := (b - a)/20.0;
	  X_FEN_MIN := a - X_UNITE;
	  X_FEN_MAX := b + X_UNITE;
	  for j in YA'range
	  loop
	    Y_FEN_MIN := 1.0E+38;
	    Y_FEN_MAX := -1.0E+38;
	    for i in y'range(1)
	    loop
	      Y_FEN_MIN := MIN(Y_FEN_MIN,y(i,j));
	      Y_FEN_MAX := MAX(Y_FEN_MAX,y(i,j));
	      if (x(i) > b) then
		 n := i - 1;
		 exit;
	       end if;
	    end loop;
	    Y_UNITE := (Y_FEN_MAX - Y_FEN_MIN)/20.0;
	    Y_FEN_MIN := Y_FEN_MIN - Y_UNITE;
	    Y_FEN_MAX := Y_FEN_MAX + Y_UNITE;
	    FENETRE_GRAPHIQUE(X_FEN_MIN,X_FEN_MAX,Y_FEN_MIN,Y_FEN_MAX);
	    XY_AXES(a,Y_FEN_MIN + Y_UNITE,X_UNITE,Y_UNITE,TRUE);
	    DEPLACE(x(x'FIRST),y(y'FIRST,j));
	    for i in x'FIRST + 1..n
	    loop
	       TRACE(x(i),y(i,j));
	     end loop;
	     if (j < p) then
		PAUSE_GRAPHIQUE;
		CLEAR_SCREEN;
	     else
		SORTIE_GRAPHIQUE;
	     end if;
	  end loop;
       end if;
    end;
    CLOSE(IMP);
end DEM_RKP1;

