with TEXT_IO, IIO, CRT, COMMON_MATH0, MATH0, MATH1, GRAPH,
     MATH2, MATH3, COMMON_MATRIX, EQUADIFF_PQ_GENERIQUE;
use TEXT_IO, IIO, CRT, COMMON_MATH0, MATH0, MATH1, GRAPH,
    MATH2, MATH3, COMMON_MATRIX;

procedure DEM_RKPQ is
N_MAX: constant INTEGER := 500;
MAX_FONCTIONS: constant INTEGER := 10;
subtype INDICE_FCT is INTEGER range 1..MAX_FONCTIONS;
type SYSTEME_DIFF is array(INDICE_FCT range <>) of FONCTION;
a, b: FLOAT;
AFFICHER, CONTROLE_DU_PAS: BOOLEAN;
p, q, n: INTEGER;
X_UNITE, Y_UNITE, X_FEN_MIN, X_FEN_MAX, Y_FEN_MIN, Y_FEN_MAX: FLOAT;
x: VECTEUR(0..N_MAX);
begin
    MODE_AFFICHAGE;
    PUT_LINE ("      SYSTEME DE P EQUATIONS DIFFERENTIELLES  D'ORDRE Q");
    NEW_LINE;
    PUT_LINE("           METHODE DE RUNGE-KUTTA D'ORDRE 4");
    NEW_LINE;
    PUT_LINE(" Le systeme d'equations est ecrit sous la forme:");
    NEW_LINE;
    PUT_LINE("    (q)                 (q-1)            (q-1) ");
    PUT_LINE("   y    = f (x,y , ...,y ,......,y ,...,y )");
    PUT_LINE("    j      j    1       1         p      p ");
    NEW_LINE;
    PUT_LINE(" Pour j = 1, ..., p et i = 0, ..., q - 1, ");
    PUT_LINE("la derivee d'ordre i de y(j) est notee y(10*j + i)");
    NEW_LINE;
    ENTRER_ENTIER_BORNE(1,MAX_FONCTIONS,p,"Nombre d'equations: ");
    NEW_LINE;
    ENTRER_ENTIER_BORNE(1,MAX_FONCTIONS,q,"Ordre du systeme: ");
    NEW_LINE;
    declare
       FF: SYSTEME_DIFF(1..p);

-- Pour p = q = 2, FF(j,x,y10,y11,y12,y20,y21) represente l'equation
-- y(j)''    = f(j)(x,y(1),y(1)',y(2),y(2)')

       ya: MATRICE(1..p,0..q-1);
       y: MATRICE(0..N_MAX,1..p);
       yy: VARIABLE_2(10..10*p + q - 1);
       function f(j: in POSITIVE; x: in FLOAT; y: in VARIABLE_2) return FLOAT is
       begin
	   for j in 1..p
	   loop
	      for i in 0..q-1
	      loop
		 yy(10*j + i) := y(q*(j - 1) + i + 1);
	      end loop;
	   end loop;
	   return EVALUE(FF(j),x,yy);
       end f;

       package EQUADIFF_PQ_F is new EQUADIFF_PQ_GENERIQUE(F);
       use EQUADIFF_PQ_F;

    begin
       for j in 1..p
       loop
	  PUT("Equation Numero "); PUT(j,2); NEW_LINE;
	  PUT("f(x,");
	  for k in 1..p
	  loop
	     for i in 0..q - 1
	     loop
		PUT("y"); PUT(10*k + i,2);
		if ((k /= p) or (i /= q - 1)) then
		   PUT(",");
		else
		   PUT_LINE(") = ");
		end if;
	     end loop;
	  end loop;
	  GET_LINE(ff(j),"   ");
       end loop;
       NEW_LINE;
       PUT_LINE(" Bornes de l'intervalle");
       NEW_LINE;
       ENTRER_REEL(a,"Valeur de a: ");
       ENTRER_REEL_BORNE(a,1.0E+6,b,"Valeur de b: ");
       for j in 1..p
       loop
	  for i in 0..q - 1
	  loop
	     PUT("Valeur initiale de la derivee d'ordre"); PUT(i,2);
	     PUT(" de y("); PUT(j,2); PUT_LINE(")");
	     ENTRER_REEL(ya(j,i),"  y = ");
	  end loop;
       end loop;
       NEW_LINE;
       AFFICHER := LIRE_REPONSE("Voulez-vous l'affichage des resultats? ");
       CONTROLE_DU_PAS := LIRE_REPONSE("Methode avec controle du pas? ");
       CLRSCR;
       if (CONTROLE_DU_PAS) then
	  RESOLUTION_RK4_PQ_CONTROLE(a,b,ya,AFFICHER,x,y);
       else
	  RESOLUTION_RK4_PQ(a,b,ya,AFFICHER,x,y);
       end if;
       PAUSE;
       CLRSCR;
       if LIRE_REPONSE("Voulez vous le trace de la solution trouvee? ") then
	  n := x'LAST;
	  INIT_GRAPHIQUE;
	  X_UNITE := (b - a)/20.0;
	  X_FEN_MIN := a - X_UNITE;
	  X_FEN_MAX := b + X_UNITE;
	  for j in 1..p
	  loop
	    Y_FEN_MIN := 1.0E+38;
	    Y_FEN_MAX := -1.0E+38;
	    for i in y'range(1)
	    loop
	      Y_FEN_MIN := MIN(Y_FEN_MIN,y(i,j));
	      Y_FEN_MAX := MAX(Y_FEN_MAX,y(i,j));
	      if (x(i) > b) then
		 n := i - 1;
		 exit;
	       end if;
	    end loop;
	    Y_UNITE := (Y_FEN_MAX - Y_FEN_MIN)/20.0;
	    Y_FEN_MIN := Y_FEN_MIN - Y_UNITE;
	    Y_FEN_MAX := Y_FEN_MAX + Y_UNITE;
	    FENETRE_GRAPHIQUE(X_FEN_MIN,X_FEN_MAX,Y_FEN_MIN,Y_FEN_MAX);
	    XY_AXES(a,Y_FEN_MIN + Y_UNITE,X_UNITE,Y_UNITE,TRUE);
	    DEPLACE(x(x'FIRST),y(y'FIRST,j));
	    for i in x'FIRST + 1..n
	    loop
	       TRACE(x(i),y(i,j));
	     end loop;
	     if (j < p) then
		PAUSE_GRAPHIQUE;
		CLEAR_SCREEN;
	     else
		SORTIE_GRAPHIQUE;
	     end if;
	  end loop;
       end if;
    end;
    CLOSE(IMP);
end DEM_RKPQ;

