package body EQUATIONS_GENERIQUE is

procedure DICHOTOMIE(a, b: in FLOAT;
		     x: out FLOAT; Eps: in FLOAT := 1.0E-6) is
aa: FLOAT := a;
bb: FLOAT := b;
c, z, y: FLOAT;
begin
    y := f(aa);
    loop
       c := 0.5*(aa + bb);
       z := f(c);
       if (y*z) <= 0.0 then
	  bb := c;
       else
	  aa := c;
	  y := z;
       end if;
       exit when (abs(bb - aa) < Eps) or (abs(z) < 1.0E-12);
    end loop;
    x := c;
end DICHOTOMIE;

procedure NEWTON_RAPHSON(x0: in FLOAT; x: out FLOAT; Eps: in FLOAT := 1.0E-6) is
MAX_ITER: constant INTEGER := 300;
k: INTEGER := 0;
h: FLOAT := 1.0E-3;
xx, df, e: FLOAT;
begin
    xx := x0;
    loop
       k := k + 1;
       df := (f(xx + h) - f(xx - h))/(2.0*h);
       e := f(xx)/df;
       xx := xx - e;
       exit when (k = MAX_ITER) or (abs(e) < Eps);
    end loop;
    if (k = MAX_ITER) then
       raise ERREUR_CONVERGENCE;
    end if;
    x := xx;
end NEWTON_RAPHSON;

end EQUATIONS_GENERIQUE;

