--             ͻ
--                             J. E. ROMBALDI               
--                      E.N.S.A.M. CHALONS SUR MARNE        
--                           COPYRIGHT (C) 1993             
--              SPECIFICATION DU PAQUETAGE FOURIER_GENERIQUE
--             ͼ

--ͻ
--                        Utilite du paquetage.                           
--                                                                        
-- Dans ce paquetage on trouvera des procedures de calcul d'un transformee
-- de Fourier discrete et des coefficients de Fourier d'une fonction.     
--ͼ
with COMMON_MATRIX, COMMON_FOURIER;
use COMMON_MATRIX, COMMON_FOURIER;

generic
    with function f(x: in FLOAT) return FLOAT;
package FOURIER_GENERIQUE is

procedure ECHANTILLONNAGE(tMax: in FLOAT;
			  x: out VECTEUR_COMPLEXE; D: out FLOAT); --  5.1
-- x = (x(0),...,x(n-1)), avec x(j) = f(j*D) et D = tMax/n
function SERIE_DE_FOURIER(a, b: in VECTEUR; x: in FLOAT) return FLOAT; --  5.5
procedure TRACE_UNE_SERIE_DE_FOURIER(tMax: in FLOAT; a, b: in VECTEUR;
				     NB_POINTS: in INTEGER := 300); --  5.5
procedure FFT(x: in VECTEUR_COMPLEXE; y: out VECTEUR_COMPLEXE); --  5.4
procedure CALCUL_COEFFICIENTS_DE_FOURIER(y: in VECTEUR_COMPLEXE;
					 a, b: out VECTEUR); --  5.5
-- Calcul des coefficients de Fourier trigonometrique a partir des
-- coefficients complexes.
function ENERGIE(x: in VECTEUR_COMPLEXE) return FLOAT; --  5.3

end FOURIER_GENERIQUE;
