with TEXT_IO, INTERRUPT, CRT, MATH0;
use  TEXT_IO, INTERRUPT, CRT, MATH0;

package body GRAPH is

R: INTERRUPT.REGISTERS;

procedure CLEAR_SCREEN is
begin
    case CARTE_GRAPHIQUE_UTILISATEUR is
      when CGA_C4_320x200 =>
	 R.AX := 16#0004#; -- Fonction 00h: Selection de la carte graphique
			   -- CGA, 4 couleurs, 320x200
      when CGA_GREY4_320x200 =>
	 R.AX := 16#0005#; -- Fonction 00h: Selection de la carte graphique
			   -- CGA, 4 tons de gris, 320x200
      when CGA_C2_640x200 =>
	 R.AX := 16#0006#; -- Fonction 00h: Selection de la carte graphique
			   -- CGA, 2 couleurs, 640x200
      when EGA_C16_320x200 =>
	 R.AX := 16#000D#; -- Fonction 00h: Selection de la carte graphique
			   -- EGA, 16 couleurs, 320x200
      when EGA_C16_640x200 =>
	 R.AX := 16#000E#; -- Fonction 00h: Selection de la carte graphique
			   -- EGA, 16 couleurs, 640x200
      when EGA_BW_640x350 =>
	 R.AX := 16#000F#; -- Fonction 00h: Selection de la carte graphique
			   -- EGA, monochrome, 640x350
      when EGA_VGA_C16_320x200 =>
	 R.AX := 16#000D#; -- Fonction 00h: Selection de la carte graphique
			   -- EGA, VGA, 16 couleurs, 320x200
      when EGA_VGA_C16_640x200 =>
	 R.AX := 16#000E#; -- Fonction 00h: Selection de la carte graphique
			   -- EGA, VGA, 16 couleurs, 640x200
      when EGA_VGA_C16_640x350 =>
	 R.AX := 16#0010#; -- Fonction 00h: Selection de la carte graphique
			   -- EGA, VGA, 4 ou 16 couleurs, 640x350
      when EGA_VGA_BW_640x350 =>
	 R.AX := 16#000F#; -- Fonction 00h: Selection de la carte graphique
			   -- EGA, VGA, monochrome, 640x350
      when MCGA_BW_640x480 =>
	 R.AX := 16#0011#; -- Fonction 00h: Selection de la carte graphique
			   -- MCGA, monochrome, 640x480
      when MCGA_C256_320x200 =>
	 R.AX := 16#0013#; -- Fonction 00h: Selection de la carte graphique
			   -- MCGA, 256 couleurs, 320x200
      when VGA_C16_640x480 =>
	 R.AX := 16#0012#; -- Fonction 00h: Selection de la carte graphique
			   -- VGA, 16 couleurs, 640x480
      when SVGA_C16_800x600 =>
	R.AX := 16#0029#; -- Fonction 00h: Selection de la carte graphique
			  -- SVGA, 16 couleurs, 800x600
      when SVGA_C16_1024x768 =>
	R.AX := 16#0037#; -- Fonction 00h: Selection de la carte graphique
			  -- SVGA, 16 couleurs, 1024x768
    end case;
    R.BX := 16#0000#;
    INTERRUPT.VECTOR(16#10#,R);
end CLEAR_SCREEN;
-- 
procedure CLOSE_GRAPH is
begin
    R.AX := 16#0003#; -- Fonction 00h: Mode texte 80x25, 16 couleurs.
    INTERRUPT.VECTOR(16#10#,R);
    CURSOR(TRUE);
end CLOSE_GRAPH;
-- 
procedure INIT_GRAPH (CHOIX : CARTE_GRAPHIQUE) is
begin
    CARTE_GRAPHIQUE_UTILISATEUR := CHOIX;
    case CHOIX is
      when CGA_C4_320x200 =>
	R.AX := 16#0004#; -- Fonction 00h: Selection de la carte graphique
			   -- CGA, 4 couleurs, 320x200
	R.BX := 16#0000#;
	INTERRUPT.VECTOR(16#10#,R);
	GET_MAX_X := 319;
	GET_MAX_Y := 199;
	MAX_LIGNE_TEXTE := 24;
	MAX_COLONNE_TEXTE := 39;
	LARGEUR_PIXEL := 8;
	HAUTEUR_PIXEL := 8;
      when CGA_GREY4_320x200 =>
	R.AX := 16#0005#; -- Fonction 00h: Selection de la carte graphique
			   -- CGA, 4 tons de gris, 320x200
	R.BX := 16#0000#;
	INTERRUPT.VECTOR(16#10#,R);
	GET_MAX_X := 319;
	GET_MAX_Y := 199;
	MAX_LIGNE_TEXTE := 24;
	MAX_COLONNE_TEXTE := 39;
	LARGEUR_PIXEL := 8;
	HAUTEUR_PIXEL := 8;
      when CGA_C2_640x200 =>
	R.AX := 16#0006#; -- Fonction 00h: Selection de la carte graphique
			   -- CGA, 2 couleurs, 640x200
	R.BX := 16#0000#;
	INTERRUPT.VECTOR(16#10#,R);
	GET_MAX_X := 639;
	GET_MAX_Y := 199;
	MAX_LIGNE_TEXTE := 24;
	MAX_COLONNE_TEXTE := 79;
	LARGEUR_PIXEL := 8;
	HAUTEUR_PIXEL := 8;
      when EGA_C16_320x200 =>
	R.AX := 16#000D#; -- Fonction 00h: Selection de la carte graphique
			   -- EGA, 16 couleurs, 320x200
	R.BX := 16#0000#;
	INTERRUPT.VECTOR(16#10#,R);
	GET_MAX_X := 319;
	GET_MAX_Y := 199;
	MAX_LIGNE_TEXTE := 24;
	MAX_COLONNE_TEXTE := 39;
	LARGEUR_PIXEL := 8;
	HAUTEUR_PIXEL := 8;
      when EGA_C16_640x200 =>
	R.AX := 16#000E#; -- Fonction 00h: Selection de la carte graphique
			   -- EGA, 16 couleurs, 640x200
	R.BX := 16#0000#;
	INTERRUPT.VECTOR(16#10#,R);
	GET_MAX_X := 639;
	GET_MAX_Y := 199;
	MAX_LIGNE_TEXTE := 24;
	MAX_COLONNE_TEXTE := 79;
	LARGEUR_PIXEL := 8;
	HAUTEUR_PIXEL := 8;
      when EGA_BW_640x350 =>
	R.AX := 16#000F#; -- Fonction 00h: Selection de la carte graphique
			   -- EGA, monochrome, 640x350
	R.BX := 16#0000#;
	INTERRUPT.VECTOR(16#10#,R);
	GET_MAX_X := 639;
	GET_MAX_Y := 349;
	MAX_LIGNE_TEXTE := 24;
	MAX_COLONNE_TEXTE := 79;
	LARGEUR_PIXEL := 8;
	HAUTEUR_PIXEL := 14;
      when EGA_VGA_C16_320x200 =>
	R.AX := 16#000D#; -- Fonction 00h: Selection de la carte graphique
			   -- EGA, VGA, 16 couleurs, 320x200
	R.BX := 16#0000#;
	INTERRUPT.VECTOR(16#10#,R);
	GET_MAX_X := 319;
	GET_MAX_Y := 199;
	MAX_LIGNE_TEXTE := 24;
	MAX_COLONNE_TEXTE := 39;
	LARGEUR_PIXEL := 8;
	HAUTEUR_PIXEL := 8;
      when EGA_VGA_C16_640x200 =>
	R.AX := 16#000E#; -- Fonction 00h: Selection de la carte graphique
			   -- EGA, VGA, 16 couleurs, 640x200
	R.BX := 16#0000#;
	INTERRUPT.VECTOR(16#10#,R);
	GET_MAX_X := 639;
	GET_MAX_Y := 199;
	MAX_LIGNE_TEXTE := 24;
	MAX_COLONNE_TEXTE := 79;
	LARGEUR_PIXEL := 8;
	HAUTEUR_PIXEL := 8;
      when EGA_VGA_C16_640x350 =>
	R.AX := 16#0010#; -- Fonction 00h: Selection de la carte graphique
			   -- EGA, VGA, 4 ou 16 couleurs, 640x350
	R.BX := 16#0000#;
	INTERRUPT.VECTOR(16#10#,R);
	GET_MAX_X := 639;
	GET_MAX_Y := 349;
	MAX_LIGNE_TEXTE := 24;
	MAX_COLONNE_TEXTE := 79;
	LARGEUR_PIXEL := 8;
	HAUTEUR_PIXEL := 14;
      when EGA_VGA_BW_640x350 =>
	R.AX := 16#000F#; -- Fonction 00h: Selection de la carte graphique
			   -- EGA, VGA, monochrome, 640x350
	R.BX := 16#0000#;
	INTERRUPT.VECTOR(16#10#,R);
	GET_MAX_X := 639;
	GET_MAX_Y := 349;
	MAX_LIGNE_TEXTE := 24;
	MAX_COLONNE_TEXTE := 79;
	LARGEUR_PIXEL := 8;
	HAUTEUR_PIXEL := 14;
      when MCGA_BW_640x480 =>
	R.AX := 16#0011#; -- Fonction 00h: Selection de la carte graphique
			   -- MCGA, monochrome, 640x480
	R.BX := 16#0000#;
	INTERRUPT.VECTOR(16#10#,R);
	GET_MAX_X := 639;
	GET_MAX_Y := 479;
	MAX_LIGNE_TEXTE := 29;
	MAX_COLONNE_TEXTE := 79;
	LARGEUR_PIXEL := 8;
	HAUTEUR_PIXEL := 16;
      when MCGA_C256_320x200 =>
	R.AX := 16#0013#; -- Fonction 00h: Selection de la carte graphique
			   -- MCGA, 256 couleurs, 320x200
	INTERRUPT.VECTOR(16#10#,R);
	GET_MAX_X := 319;
	GET_MAX_Y := 199;
	MAX_LIGNE_TEXTE := 24;
	MAX_COLONNE_TEXTE := 39;
	LARGEUR_PIXEL := 8;
	HAUTEUR_PIXEL := 8;
      when VGA_C16_640x480 =>
	R.AX := 16#0012#; -- Fonction 00h: Selection de la carte graphique
			   -- VGA, 16 couleurs, 640x480
	R.BX := 16#0000#;
	INTERRUPT.VECTOR(16#10#,R);
	GET_MAX_X := 639;
	GET_MAX_Y := 479;
	MAX_LIGNE_TEXTE := 29;
	MAX_COLONNE_TEXTE := 79;
	LARGEUR_PIXEL := 8;
	HAUTEUR_PIXEL := 16;
      when SVGA_C16_800x600 =>
	R.AX := 16#0029#; -- Fonction 00h: Selection de la carte graphique
			  -- SVGA, 16 couleurs, 800x600
	R.BX := 16#0000#;
	INTERRUPT.VECTOR(16#10#,R);
	GET_MAX_X := 799;
	GET_MAX_Y := 599;
	MAX_LIGNE_TEXTE := 36;
	MAX_COLONNE_TEXTE := 99;
	LARGEUR_PIXEL := 8;
	HAUTEUR_PIXEL := 16;
      when SVGA_C16_1024x768 =>
	R.AX := 16#0037#; -- Fonction 00h: Selection de la carte graphique
			  -- SVGA, 16 couleurs, 1024x768
	R.BX := 16#0000#;
	INTERRUPT.VECTOR(16#10#,R);
	GET_MAX_X := 1023;
	GET_MAX_Y := 767;
	MAX_LIGNE_TEXTE := 47;
	MAX_COLONNE_TEXTE := 127;
	LARGEUR_PIXEL := 8;
	HAUTEUR_PIXEL := 16;
    end case;
    GR_X_MIN := 0;
    GR_Y_MIN := 0;
    GR_X_MAX := GET_MAX_X;
    GR_Y_MAX := GET_MAX_Y;
    CLIP_ON := TRUE;
    X_POS := 0;
    Y_POS := 0;
end INIT_GRAPH;
-- 
procedure MOVE_TO(x: in INTEGER; y: in INTEGER) is
begin
    X_POS := x;
    Y_POS := y;
end MOVE_TO;
-- 
procedure PUT_PIXEL(x: in INTEGER; y: in INTEGER) is
R: INTERRUPT.REGISTERS;
begin
   X_POS := x;
   Y_POS := Y;
   if (CLIP_ON and then ( (x < GR_X_MIN) or (x > GR_X_MAX) or
			  (y < GR_Y_MIN) or (y > GR_Y_MAX) ) ) then
      null;
   else
      R.AX := 16#0C00# + COULEUR'POS(COULEUR_PIXEL);
      R.BX := 16#0000#;
      R.CX := x;
      R.DX := y;
      INTERRUPT.VECTOR(16#10#,R);
   end if;
end PUT_PIXEL;
-- 
procedure LINE(x, x1: in INTEGER;y, y1: in INTEGER) is
a, b, xx, yy: FLOAT;
k: INTEGER;
begin
    X_POS := x1;
    Y_POS := y1;
    if (x = x1) then
       if (y < y1) then
	  for i in y..y1 loop
	     PUT_PIXEL(x,i);
	  end loop;
       else
	  for i in y1..y loop
	     PUT_PIXEL(x,i);
	  end loop;
       end if;
       return;
    end if;
    if (y = y1) then
       if (x < x1) then
	  for i in x..x1 loop
	     PUT_PIXEL(i,y);
	  end loop;
       else
	  for i in x1..x loop
	     PUT_PIXEL(i,y);
	  end loop;
       end if;
       return;
    end if;
    a := FLOAT(y - y1)/FLOAT(x - x1);
    if (abs(a) <= 1.0) then
       b := FLOAT(y) - a*FLOAT(x);
       if (x < x1) then
	  for i in x..x1 loop
	    yy := a*FLOAT(i) + b;
	    k := INTEGER(yy);
	    PUT_PIXEL(i,k);
	  end loop;
       else
	  for i in x1..x loop
	    yy := a*FLOAT(i) + b;
	    k := INTEGER(yy);
	    PUT_PIXEL(i,k);
	  end loop;
       end if;
    else
       a := FLOAT(x - x1)/FLOAT(y - y1);
       b := FLOAT(x) - a*FLOAT(y);
       if (y < y1) then
	  for i in y..y1 loop
	    xx := a*FLOAT(i) + b;
	    k := INTEGER(xx);
	    PUT_PIXEL(k,i);
	  end loop;
       else
	  for i in y1..y loop
	    xx := a*FLOAT(i) + b;
	    k := INTEGER(xx);
	    PUT_PIXEL(k,i);
	  end loop;
       end if;
    end if;
end LINE;
-- 
procedure LINE_TO(x: in INTEGER;y: in INTEGER) is
xx: INTEGER;
yy: INTEGER;
begin
    xx := X_POS;
    yy := Y_POS;
    LINE(xx,x,yy,y);
    X_POS := x;
    Y_POS := y;
end LINE_TO;
-- 
procedure RECTANGLE(x, x1: in INTEGER;
		    y, y1: in INTEGER; CLIP: in BOOLEAN := FALSE) is
begin
    CLIP_ON := CLIP;
    LINE(x,x1,y,y);
    LINE(x1,x1,y,y1);
    LINE(x1,x,y1,y1);
    LINE(x,x,y1,y);
    CLIP_ON := TRUE;
end RECTANGLE;
-- 

end GRAPH;

