--             ͻ
--                             J. E. ROMBALDI               
--                      E.N.S.A.M. CHALONS SUR MARNE        
--                           COPYRIGHT (C) 1993             
--                    SPECIFICATION DU PAQUETAGE MATH0      
--             ͼ

--ͻ
--                        Utilite du paquetage.                           
--                                                                        
-- Dans ce paquetage, on trouve des procedures et fonctions destinees a   
-- faciliter la communication entre un programme et son utilisateur.      
--ͼ

with TEXT_IO, COMMON_MATH0;
use COMMON_MATH0;

package Math0 is

procedure RANDOMIZE;
function RANDOM return FLOAT;
function RANDOM(n: in INTEGER) return NATURAL;
function MAJUSCULE(C: in CHARACTER) return CHARACTER;
function CHAINE_ENTIERE(n: in INTEGER) return STRING;
function CHAINE_REELLE(x: in FLOAT) return STRING;
procedure GET_LINE(n: out INTEGER);
procedure GET_LINE(x: out FLOAT);
procedure GET_LINE(c: out CHARACTER);
procedure GET_LINE(Msg: out STRING);
procedure PAUSE;
procedure BIP;
function LIRE_REPONSE(Msg: in STRING) return BOOLEAN;
function TRUNC(x: in FLOAT) return INTEGER;
function FRAC(x: in FLOAT) return FLOAT;
procedure CHRONOMETRE(Top: in INTEGER);
procedure ENTRER_REEL(x: out FLOAT; Msg: in STRING := " ");
procedure ENTRER_ENTIER(n: out INTEGER; Msg: in STRING := " ");
procedure ENTRER_ENTIER_LONG(n: out LONG_INTEGER; Msg: in STRING := " ");
procedure ENTRER_REEL_BORNE(rMin, rMax: in FLOAT; x: out FLOAT;
			    Msg: in STRING := " ");
procedure ENTRER_ENTIER_BORNE(nMin, nMax: in INTEGER; n: out INTEGER;
			      Msg: in STRING := " ");
procedure ENTRER_ENTIER_LONG_BORNE(nMin, nMax: in LONG_INTEGER;
				   n: out LONG_INTEGER;
				   Msg: in STRING := " ");
procedure ECHANGER_REELS(x, y: in out FLOAT);
procedure ECHANGER_ENTIERS(p, q: in out INTEGER);
procedure LECTURE_REPERTOIRE(NOM_REPERTOIRE: in STRING);
procedure LIRE_FICHIER(FICHIER_DONNEES: in out TEXT_IO.FILE_TYPE;
		       NOM_DE_FICHIER: in out STRING;
		       NOM_DE_REPERTOIRE: in STRING := "A:\DONNEES");
function FICHIER_EXISTE(NOM_DE_FICHIER: in STRING) return BOOLEAN;
procedure CREER_FICHIER(FICHIER_DONNEES: in out TEXT_IO.FILE_TYPE;
			NOM_DE_FICHIER: in out STRING;
			NOM_DE_REPERTOIRE: in STRING := "A:\DONNEES");
procedure MODE_AFFICHAGE;
procedure VAL(Msg: in STRING; DEBUT, FIN: in NATURAL;
		i: in out NATURAL; Err: in out NATURAL);
procedure VAL(Msg: in STRING; DEBUT, FIN: in NATURAL;
		x: in out FLOAT; Err: in out NATURAL);
function LONGUEUR_CHAINE(Msg: STRING) return NATURAL;

end MATH0;
