-- ͻ
--                 Portabilite de ce corps de paquetage.                  
--  Ce corps de paquetage est utilisable avec OPEN_ADA.                   
--  Il utilise le paquetage MATH_LIB fourni avec OPEN_ADA.                
-- ͼ

with TEXT_IO, MATH_LIB, MATH0, COMMON_MATH1; use MATH0, COMMON_MATH1;

package body MATH1 is

MAX_REEL: constant FLOAT := FLOAT'LAST;
LOG_MAX_REEL: constant FLOAT := MATH_LIB.LN(MAX_REEL);
SQRT_SMALL: constant FLOAT := MATH_LIB.SQRT(FLOAT'SMALL);

type COEFF_GAMMA is array(INTEGER range 1..6) of FLOAT;
COEFF: constant COEFF_GAMMA := (76.18009173,-86.50532033,24.01409822,
				-1.231739516,0.120858003E-2,-0.536382E-5);
RACINE_2PI: constant FLOAT := MATH_LIB.SQRT(2.0*PI);
LN_RACINE_2PI: constant FLOAT := 0.5*MATH_LIB.LN(2.0*PI);

-- 
function SQRT(x: FLOAT) return FLOAT is
begin
    if x < 0.0 then
      TEXT_IO.PUT_LINE("Erreur dans SQRT: Racine d'un nombre negatif");
      raise ERREUR_ARGUMENT;
    elsif x = 0.0 then
      return X;
    elsif x = 1.0 then
      return 1.0;
    end if;
    return MATH_LIB.SQRT(x);
end SQRT;
-- 
function LN(x: FLOAT) return FLOAT is
begin
    if x <= 0.0 then
      TEXT_IO.PUT_LINE("Erreur dans LN: Logarithme d'un nombre negatif");
      raise ERREUR_ARGUMENT;
    elsif x = 1.0 then
      return 0.0;
    end if;
    return MATH_LIB.LN(x);
end LN;
-- 
function LOG(x: FLOAT; BASE: in FLOAT := 10.0) return FLOAT is
begin
    if x <= 0.0 then
      TEXT_IO.PUT_LINE("Erreur dans LOG: Logarithme d'un nombre negatif");
      raise ERREUR_ARGUMENT;
    elsif BASE <= 0.0 or else BASE = 1.0 then
      TEXT_IO.PUT_LINE("Erreur dans LOG: Base incorrecte");
      raise ERREUR_ARGUMENT;
    elsif x = 1.0 then
      return 0.0;
    end if;
    return MATH_LIB.LN(X)/MATH_LIB.LN(BASE);
end LOG;
-- 
function EXP(x: FLOAT) return FLOAT is
begin
    if (x >= LOG_MAX_REEL) then
      TEXT_IO.PUT_LINE("Erreur dans EXP: Argument trop grand");
      raise ERREUR_ARGUMENT;
    elsif (x = 0.0) then
      return 1.0;
    elsif (x = 1.0) then
      return E;
    end if;
    return MATH_LIB.EXP(x);
end EXP;
-- 
function "**"(x: FLOAT; n: INTEGER) return FLOAT is
Signe: BOOLEAN;
nn: NATURAL;
Aux: FLOAT := 1.0;
xx: FLOAT := x;
begin
    if (x = 0.0) and (n <= 0) then
       TEXT_IO.PUT_LINE("Erreur dans **: 0^n, avec n <= 0");
       raise ERREUR_ARGUMENT;
    end if;
    if (x = 0.0) then
       return 0.0;
    elsif (x = 1.0) then
       return 1.0;
    elsif (n = 0) then
       return 1.0;
    elsif (n = 1) then
       return x;
    elsif (n = -1) then
       return 1.0/x;
    end if;
    Signe := (n > 0);
    if Signe then
       nn := n;
    else
       nn := - n;
    end if;
    while (nn > 0) loop
       if ( (nn mod 2) = 1 ) then
	  Aux := Aux*x;
	  nn := nn - 1;
       else
	  xx := xx*xx;
	  nn := nn/2;
       end if;
    end loop;
    if (not Signe) then
       Aux := 1.0/Aux;
    end if;
    return Aux;
end "**";
-- 
function "**"(x, y: FLOAT ) return FLOAT is
begin
    if (x < 0.0) then
       TEXT_IO.PUT_LINE("Erreur dans **: Logarithme d'un nombre negatif");
       raise ERREUR_ARGUMENT;
    elsif (x = 0.0) and (y <= 0.0) then
       TEXT_IO.PUT_LINE("Erreur dans **: 0^y, avec y <= 0");
       raise ERREUR_ARGUMENT;
    elsif (x = 0.0) then
       return 0.0;
    elsif (x = 1.0) then
       return 1.0;
    elsif (y = 0.0) then
       return (1.0);
    elsif (y = 1.0) then
      return x;
    end if;
    return MATH_LIB.EXP(y*MATH_LIB.LN(x));
end "**";
-- 
function SIN(x: FLOAT) return FLOAT is
begin
    if x = 0.0 then
      return 0.0;
    end if;
    return MATH_LIB.SIN(x);
end SIN;
-- 
function COS(x: FLOAT) return FLOAT is
begin
    if X = 0.0 then
      return 1.0;
    end if;
    return MATH_LIB.COS(x);
end COS;
-- 
function TAN(x: FLOAT) return FLOAT is
begin
    if (MATH_LIB.COS(x) = 0.0) then
       TEXT_IO.PUT_LINE("Erreur dans TAN: Division par 0");
       raise ERREUR_ARGUMENT;
    elsif X = 0.0 then
      return 0.0;
    end if;
    return MATH_LIB.SIN(x)/MATH_LIB.COS(x);
end TAN;
-- 
function COT(x: FLOAT) return FLOAT is
begin
    if (MATH_LIB.SIN(x) = 0.0) then
	TEXT_IO.PUT_LINE("Erreur dans COT: Division par 0");
	raise ERREUR_ARGUMENT;
    end if;
    return MATH_LIB.COS(x)/MATH_LIB.SIN(x);
end COT;
-- 
function ARCTAN(x: FLOAT) return FLOAT is
begin
    if (abs(x) <= SQRT_SMALL) then
      return x;
    elsif (x = 1.0) then
      return PI_SUR_QUATRE;
    elsif (x = -1.0) then
      return -PI_SUR_QUATRE;
    elsif (abs(x) < 1.0) then
      if (x > 0.0) then
	return MATH_LIB.ATAN(x);
      else
	return -MATH_LIB.ATAN(x);
      end if;
    else
      if (x > 0.0) then
	return PI_SUR_DEUX - MATH_LIB.ATAN(1.0/x);
      else
	return MATH_LIB.ATAN(1.0/x) - PI_SUR_DEUX;
      end if;
    end if;
end ARCTAN;
-- 
function ARCSIN(x: FLOAT) return FLOAT is
begin
    if (abs(x) > 1.0) then
      TEXT_IO.PUT_LINE("Erreur dans ArcSin: Arcsinus d'un nombre > 1 ou < - 1");
      raise ERREUR_ARGUMENT;
    elsif x = 0.0 then
      return 0.0;
    elsif x = 1.0 then
      return PI/2.0;
    elsif x = -1.0 then
      return -PI/2.0;
    end if;
    return ARCTAN(x/MATH_LIB.SQRT(1.0 - x*x));
end ARCSIN;
-- 
function ARCCOS(x: FLOAT) return FLOAT is
begin
    if abs(x) > 1.0 then
      TEXT_IO.PUT_LINE("Erreur dans ArcCos: ArcCosinus d'un nombre > 1 ou < - 1");
      raise ERREUR_ARGUMENT;
    elsif x = 0.0 then
      return PI/2.0;
    elsif x = 1.0 then
      return 0.0;
    elsif x = -1.0 then
      return PI;
    end if;
    return PI_SUR_DEUX - ARCSIN(x);
end ARCCOS;
-- 
function SH(x: FLOAT) return FLOAT is
EXP_X: FLOAT;
begin
    if (x >= LOG_MAX_REEL) then
      TEXT_IO.PUT_LINE("Erreur dans SH: Argument trop grand");
      raise ERREUR_ARGUMENT;
    elsif x = 0.0 then
      return 0.0;
    end if;
    EXP_X := MATH_LIB.EXP(x);
    return 0.5*(EXP_X - 1.0/EXP_X);
end SH;
-- 
function CH(x: FLOAT) return FLOAT is
EXP_X : FLOAT;
begin
   if (x >= LOG_MAX_REEL) then
      TEXT_IO.PUT_LINE("Erreur dans CH: Argument trop grand");
      raise ERREUR_ARGUMENT;
   elsif x = 0.0 then
      return 1.0;
    end if;
    EXP_X := MATH_LIB.EXP(x);
    return 0.5*(EXP_X + 1.0/EXP_X);
end CH;
-- 
function TH(x: FLOAT ) return FLOAT is
EXP_2X : FLOAT;
begin
    if (x >= 0.0) then
      EXP_2X := MATH_LIB.EXP(-2.0*X);
      return (1.0 - EXP_2X)/(1.0 + EXP_2X);
     else
      EXP_2X := MATH_LIB.EXP(2.0*x);
      return (EXP_2X - 1.0)/(EXP_2X + 1.0);
     end if;
end TH;
-- 
function ARGSH(x: FLOAT) return FLOAT is
begin
      return MATH_LIB.LN(x + SQRT(x*x + 1.0));
end ARGSH;
-- 
function ARGCH(x: FLOAT) return FLOAT is
begin
    if x < 1.0 then
      TEXT_IO.PUT_LINE("Erreur dans ARGCH: Argument < 1");
      raise ERREUR_ARGUMENT;
    end if;
    return MATH_LIB.LN(x + SQRT(x*x - 1.0));
end ARGCH;
-- 
function ARGTH(x: FLOAT) return FLOAT is
begin
    if (abs x >= 1.0) then
      TEXT_IO.PUT_LINE("Erreur dans ARGTH: Argument >= 1 ou <= -1");
      raise ERREUR_ARGUMENT;
    elsif (x = 0.0) then
       return 0.0;
    end if;
    return 0.5*MATH_LIB.LN((1.0 + x)/(1.0 - x));
end ARGTH;
-- 
function FACT(n: INTEGER) return FLOAT is
AUX: FLOAT := 1.0;
begin
    for k in 1..n loop
       AUX := AUX*FLOAT(k);
    end loop;
    return AUX;
end FACT;
-- 
function LNGAMMA_1(x: FLOAT) return FLOAT is
S: FLOAT := 1.0;
xx: FLOAT := x;
begin
    for j in 1..6 loop
      S := S + COEFF(j)/xx;
      xx := xx + 1.0;
    end loop;
    xx := x + 4.5;
    S := MATH_LIB.LN(S) + LN_RACINE_2PI + (x - 0.5)*MATH_LIB.LN(xx) - xx;
    return S;
end LNGAMMA_1;
-- 
function LNGAMMA(x: FLOAT) return FLOAT is
begin
    if (x < 1.0E-5) then
       TEXT_IO.PUT_LINE("Erreur dans LNGAMMA: Valeur de x negative ou trop petite.");
       raise ERREUR_ARGUMENT;
    end if;
    if (x = 1.0) then
      return 0.0;
    elsif (x > 1.0) then
      return LNGAMMA_1(x);
    else
      return LNGAMMA_1(x + 1.0) - MATH_LIB.LN(x);
    end if;
end LNGAMMA;
-- 
function GAMMA(x: FLOAT) return FLOAT is
begin
    if (x < 1.0E-5) then
       TEXT_IO.PUT_LINE("Erreur dans GAMMA: Valeur de x negative ou trop petite.");
       raise ERREUR_ARGUMENT;
    else
       return MATH_LIB.EXP(LNGAMMA(x));
    end if;
end GAMMA;
-- 
function MIN(x, y: FLOAT) return FLOAT is
begin
    if (x > y) then
       return y;
    else
       return x;
    end if;
end MIN;
-- 
function MAX(x, y: FLOAT) return FLOAT is
begin
    if (x < y) then
       return y;
    else
       return x;
    end if;
end MAX;
-- 

end MATH1;
