--                  ͻ
--                             J. E. ROMBALDI             
--                      E.N.S.A.M. CHALONS SUR MARNE      
--                           COPYRIGHT (C) 1993           
--                    SPECIFICATION DU PAQUETAGE MATH1    
--                  ͼ
-- ͻ
--                          UTILITE DU PAQUETAGE                          
--                                                                        
--  Dans ce paquetage, on definit les fonctions usuellement utilisees     
--  en mathematiques. Ce sont les fonctions:                              
--        SQRT: pour la racine carree d'un reel positif;                  
--        LN: pour le logarithme neperien d'un reel positif;              
--        LOG: pour le logarithme dans une base quelconque;               
--        EXP: pour l'exponentielle;                                      
--        **: pour la fonction puissance;                                 
--        SIN: pour le sinus;                                             
--        COS: pour le cosinus;                                           
--        TAN: pour la tangente;                                          
--        COT: pour la cotangente;                                        
--        ARCSIN: pour l'arcsinus d'un reel entre - 1 et 1;               
--        ARCCOS: pour l'arccosinus d'un reel entre - 1 et 1;             
--        ARCTAN: pour l'arctangente d'un reel;                           
--        SH: pour le sinus hyperbolique;                                 
--        CH: pour le cosinus hyperbolique;                               
--        TH: pour la tangente hyperbolique;                              
--        ARGSH: pour l'argument sinus hyperbolique;                      
--        ARGCH: pour l'argument cosinus hyperbolique d'un reel >= 1;     
--        ARGTH: pour l'argument tangente hyperbolique d'un reel entre    
--               -1 et 1                                                  
--        FACT: pour la factorielle d'un entier.                          
--        GAMMA: pour la fonction Gamma d'Euler.                          
--        LNGAMMA: pour le logarithme neperien de Gamma.                  
--        MIN: pour le minimum de deux reels.                             
--        MAX: pour le maximum de deux reels.                             
--                                                                        
-- ͼ

package MATH1 is

   function SQRT(x: FLOAT) return FLOAT;
   function LN(x: FLOAT) return FLOAT;
   function LOG(x: FLOAT; BASE: in FLOAT := 10.0) return FLOAT;
   function EXP(x: FLOAT) return FLOAT;
   function "**"(x: FLOAT; n: INTEGER) return FLOAT;
   function "**"(x,y: FLOAT) return FLOAT;
   function SIN(x: FLOAT) return FLOAT;
   function COS(x: FLOAT) return FLOAT;
   function TAN(x: FLOAT) return FLOAT;
   function COT(x: FLOAT) return FLOAT;
   function ARCSIN(x: FLOAT) return FLOAT;
   function ARCCOS(x: FLOAT) return FLOAT;
   function ARCTAN(x: FLOAT) return FLOAT;
   function SH(x: FLOAT) return FLOAT;
   function CH(x: FLOAT) return FLOAT;
   function TH(x: FLOAT) return FLOAT;
   function ARGSH(x: FLOAT) return FLOAT;
   function ARGCH(x: FLOAT) return FLOAT;
   function ARGTH(x: FLOAT) return FLOAT;
   function FACT(n: INTEGER) return FLOAT;
   function LNGAMMA(x: FLOAT) return FLOAT;
   function GAMMA(x: FLOAT) return FLOAT;
   function MIN(x, y: FLOAT) return FLOAT;
   function MAX(x, y: FLOAT) return FLOAT;

end MATH1;
