with TEXT_IO, UNCHECKED_DEALLOCATION, CRT, COMMON_MATH0, MATH0,
     COMMON_MATH1, MATH1, LIRE_FONCTION;
use CRT, COMMON_MATH0, MATH0, COMMON_MATH1, MATH1;

package body MATH2 is

type TABLEAU_OPERATIONS_UNAIRES is array(UNE_OPERATION_UNAIRE)
				   of STRING(1..8);
OPERATIONS_UNAIRES: constant TABLEAU_OPERATIONS_UNAIRES
	      := ("-       ","+       ",
		  "SIN     ","COS     ","TG      ","ARCSIN  ","ARCCOS  ",
		  "ARCTAN  ","SH      ","CH      ","TH      ","ARGSH   ",
		  "ARGCH   ","ARGTH   ","ABS     ","FRAC    ","EXP     ",
		  "LN      ","GAMMA   ","LNGAMMA ","SQRT    ");
-- 
procedure LIBERER is new UNCHECKED_DEALLOCATION(NOEUD,POINTEUR_NOEUD);
-- 
function EVALUER_ARBRE(ARBRE: NOEUD; x: FLOAT; y: VARIABLE_2) return FLOAT is
r, s: FLOAT;
AUX: FLOAT;
begin
  AUX := 0.0;
  case ARBRE.TYPE_DU_NOEUD is
    when CONSTANTE => AUX := ARBRE.valeur;
    when VARIABLE => if (ARBRE.rang = -1) then
			AUX := x;
		     else
			AUX := Y(ARBRE.rang);
                     end if;
    when OPERATION_UNAIRE => r := EVALUER_ARBRE(ARBRE.GAUCHE.all,x,y);
			     case ARBRE.OPERATION_1 is
                                when FMOINS => AUX := - r;
                                when FPLUS => AUX := r;
                                when FABS => AUX := abs(r);
                                when FFRAC => AUX := FRAC(r);
				when FSQRT => AUX := SQRT(r);
                                when FEXP => AUX := EXP(r);
				when FLN => AUX := LN(r);
                                when FSIN => AUX := SIN(r);
                                when FCOS => AUX := COS(r);
				when FTG => AUX := TAN(r);
                                when FSH => AUX := SH(r);
                                when FCH => AUX := CH(r);
                                when FTH => AUX := TH(r);
                                when FARCSIN => AUX := ARCSIN(r);
                                when FARCCOS => AUX := ARCCOS(r);
                                when FARCTAN => AUX := ARCTAN(r);
                                when FARGSH => AUX := ARGSH(r);
                                when FARGCH => AUX := ARGCH(r);
				when FARGTH => AUX := ARGTH(r);
				when FGAMMA => AUX := GAMMA(r);
				when FLNGAMMA => AUX := LNGAMMA(r);
			     end case; -- Du case ARBRE.OPERATION_1
    when OPERATION_BINAIRE => r := EVALUER_ARBRE (ARBRE.GAUCHE.all,x,y);
			      s := EVALUER_ARBRE (ARBRE.DROITE.all,x,y);
			      case ARBRE.OPERATION_2 is
				when FSUM => AUX := r + s;
                                when FSUB => AUX := r - s;
                                when FMUL => AUX := r*s;
                                when FDIV => AUX := r/s;
				when FPUI => if (FRAC(s) = 0.0) then
						AUX := r**INTEGER(s);
					     else
						AUX := r**s;
					     end if;
			      end case; -- Du case ARBRE.OPERATION_2
  end case; -- Du case ARBRE.TYPE_DU_NOEUD
  return AUX;
end EVALUER_ARBRE;
-- 
function EVALUE(f: FONCTION; x: FLOAT; y: in VARIABLE_2)
	 return FLOAT is
begin
    return EVALUER_ARBRE(f.ARBRE,x,Y);
end EVALUE;
-- 
function EVALUE(f: FONCTION; x, y, z, t: FLOAT := 0.0) return FLOAT is
yy: VARIABLE_2(0..2) := (y,z,t);
begin
    return EVALUER_ARBRE(f.ARBRE,x,yy);
end EVALUE;
-- 
procedure DETRUIT_ARBRE(ARBRE: in out NOEUD) is
begin
    case ARBRE.TYPE_DU_NOEUD is
      when OPERATION_BINAIRE => DETRUIT_ARBRE(ARBRE.DROITE.all);
				LIBERER(ARBRE.DROITE);
				DETRUIT_ARBRE(ARBRE.GAUCHE.all);
				LIBERER(ARBRE.GAUCHE);
      when OPERATION_UNAIRE =>  DETRUIT_ARBRE(ARBRE.GAUCHE.all);
				LIBERER(ARBRE.GAUCHE);
      when others => null;
    end case;
end DETRUIT_ARBRE;
-- 
procedure DETRUIT_FONCTION(f: in out FONCTION) is
begin
    f.TEXTE_FONCTION := (others => ' ');
    DETRUIT_ARBRE(f.ARBRE);
end DETRUIT_FONCTION;
-- 
procedure CREE_ARBRE(Ch: in out STRING;
		     n: in out NOEUD; B: in out BOOLEAN) is
i, j, L: INTEGER;
np: INTEGER;
r: FLOAT;
k: UNE_OPERATION_UNAIRE;
p1, p2: POINTEUR_NOEUD;

function CREE_NOEUDS_BINAIRES(C1, C2: in CHARACTER;
			      Op1, Op2: in UNE_OPERATION_BINAIRE)
				return BOOLEAN is
--  Recherche des operations binaires (-, +), (/, *), Puissance.
--  En cas de succes, le NOEUD correspondant est cree.
Aux: BOOLEAN;
begin
  Aux := FALSE;
  i := L; -- Longueur effective de la chaine.
  loop
     if (Ch(i) = ')') then
	np := 0;
	loop
	   case Ch(i) is
	     when '(' => np := np + 1;
	     when ')' => np := np - 1;
	     when others => null;
	   end case;
	   i := i - 1;
	   exit when ( (np = 0) or (i < 1) );
	end loop;
	i := i + 1;
     end if;
     if (Ch(i) = C1) then
       if (i > 1) and (i < L) then
	   n.TYPE_DU_NOEUD := OPERATION_BINAIRE;
	   n.OPERATION_2 := Op1;
	   P1 := new NOEUD;
	   P2 := new NOEUD;
	   n.GAUCHE := P1;
	   n.DROITE := P2;
	   declare
	     BB: BOOLEAN;
	     Ch_GAUCHE: STRING(1..i - 1) := Ch(1..i - 1);
	   begin
	     CREE_ARBRE(Ch_GAUCHE,n.GAUCHE.all,BB);
	     if (not BB) then
	       return Aux;
	     end if;
	   end;
	   declare
	     BB: BOOLEAN;
	     Ch_DROITE: STRING(1..L - i) := Ch(i + 1..L);
	   begin
	     CREE_ARBRE(Ch_DROITE,n.DROITE.all,BB);
	     if (not BB) then
	       return Aux;
	     end if;
	   end;
	   B := TRUE;
	   Aux := TRUE;
	   return Aux;
       end if;
     end if;
     if (Ch(i) = C2) then
       if (i > 1) and (i < L) then
	   n.TYPE_DU_NOEUD := OPERATION_BINAIRE;
	   n.OPERATION_2 := Op2;
	   P1 := new NOEUD;
	   P2 := new NOEUD;
	   n.GAUCHE := P1;
	   n.DROITE := P2;
	   declare
	     BB: BOOLEAN;
	     Ch_GAUCHE: STRING(1..i - 1) := Ch(1..i - 1);
	   begin
	     CREE_ARBRE(Ch_GAUCHE,n.GAUCHE.all,BB);
	     if (not BB) then
	       return Aux;
	     end if;
	   end;
	   declare
	     BB: BOOLEAN;
	     Ch_DROITE: STRING(1..L - i) := Ch(i + 1..L);
	   begin
	     CREE_ARBRE(Ch_DROITE,n.DROITE.all,BB);
	     if (not BB) then
	       return Aux;
	     end if;
	   end;
	   B := TRUE;
	   Aux := TRUE;
	   return Aux;
       end if;
     end if;
     i := i - 1;
     exit when (i <= 1);
   end loop;
   return Aux;
end CREE_NOEUDS_BINAIRES;

function NOEUD_VARIABLE(Ch: in STRING) return BOOLEAN is
--  Recherche des variables
Aux: BOOLEAN;
begin
   Aux := FALSE;
   if (Ch = "X") then
      n.TYPE_DU_NOEUD := VARIABLE;
      n.rang:= -1;
      B := TRUE;
      Aux := TRUE;
   end if;
   if (Ch(1) = 'Y') then
     if (L = 1) then
       n.rang := 0;
     else
       VAL(Ch,2,L,i,j);
       if (j /= 0) then
	  Aux := TRUE;
       end if;
       n.rang := i;
     end if;
     n.TYPE_DU_NOEUD := VARIABLE;
     B := TRUE;
     Aux := TRUE;
   end if;
   if (Ch = "Z") then
      n.TYPE_DU_NOEUD := VARIABLE;
      n.rang:= 1;
      B := TRUE;
      Aux := TRUE;
   end if;
   if (Ch = "T") then
      n.TYPE_DU_NOEUD := VARIABLE;
      n.rang:= 2;
      B := TRUE;
      Aux := TRUE;
   end if;
   return Aux;
end NOEUD_VARIABLE;

begin
   B := FALSE;
   n.TYPE_DU_NOEUD := CONSTANTE;
   L := Ch'LENGTH;
   if (L = 0) then
     return;
   end if;
   if (CREE_NOEUDS_BINAIRES('-','+',FSUB,FSUM)) then
      return;
   end if;
   if (CREE_NOEUDS_BINAIRES('/','*',FDIV,FMUL)) then
      return;
   end if;
   if (Ch(1) = '-') then
      n.TYPE_DU_NOEUD := OPERATION_UNAIRE;
      n.OPERATION_1 := FMOINS;
      P1 := new NOEUD;
      n.Gauche := P1;
      declare
	Ch_AUX: STRING(1..L - 1) := Ch(2..L);
      begin
	CREE_ARBRE(Ch_AUX,n.GAUCHE.all,B);
      end;
      return;
   end if;
   IF (Ch(1) = '+') then
      n.TYPE_DU_NOEUD := OPERATION_UNAIRE;
      n.OPERATION_1 := FPLUS;
      P1 := new NOEUD;
      n.Gauche := P1;
      declare
	Ch_AUX: STRING(1..L - 1) := Ch(2..L);
      begin
	CREE_ARBRE(Ch_AUX,n.GAUCHE.all,B);
      end;
      return;
   end if;
   IF CREE_NOEUDS_BINAIRES(CHARACTER'VAL(94),CHARACTER'VAL(94),FPUI,FPUI) then
      return;
   end if;
   i := 1;
   IF (Ch (1) = '(') then
       np := 0;
       loop
	   case Ch(i) is
	     when '(' => np := np + 1;
	     when ')' => np := np - 1;
	     when others => null;
	   end case;
	   i := i + 1;
	   exit when (np = 0) or (i > L);
       end loop;
       i := i - 1;
       if (np = 0) then
	 if (i = L) then
	    declare
	       Ch_Aux: STRING(1..L - 2) := Ch(2..L - 1);
	    begin
	       CREE_ARBRE(Ch_AUX,n,B);
	    end;
	 end if;
       end if;
       return;
   end if;
   for k in FSIN..FSQRT loop
     j := LONGUEUR_CHAINE(OPERATIONS_UNAIRES(k));
     IF (OPERATIONS_UNAIRES(k)(1..j) = Ch(1..j)) then
	if (Ch(j + 1) = '(') then
	   n.TYPE_DU_NOEUD := OPERATION_UNAIRE;
	   n.OPERATION_1 := k;
	   P1 := new NOEUD;
	   n.GAUCHE := P1;
	   declare
	      Ch_AUX: STRING(1..L - j) := Ch(j + 1..L);
	   begin
	      CREE_ARBRE(Ch_AUX,n.GAUCHE.all,B);
	   end;
	end if;
	return;
     end if;
   end loop;
   declare
      Ch_AUX: STRING(1..L) := Ch(1..L);
   begin
      if NOEUD_VARIABLE(Ch_AUX) then
	 return;
      end if;
   end;
   if (Ch = "PI") then
     n.TYPE_DU_NOEUD := CONSTANTE;
     n.valeur := PI;
     B := TRUE;
     return;
   end if;
   if (Ch = "E") then
     n.TYPE_DU_NOEUD := CONSTANTE;
     n.valeur := E;
     B := TRUE;
     return;
   end if;
   VAL(Ch,1,L,r,i);
      if (i = 0) then
	 n.TYPE_DU_NOEUD := CONSTANTE;
	 n.valeur := r;
	 B := TRUE;
   end if;
end CREE_ARBRE;
-- 
procedure COMPILE_FONCTION(f: in out FONCTION; B: in out boolean) is
-- Cette routine cree la fonction f a partir de la chaine de caracteres
-- entree au clavier et verifie que le resultat est correct .
BB: BOOLEAN;
T: NATURAL;
begin
   T := LONGUEUR_CHAINE(f.TEXTE_FONCTION);
   declare
      Ch: STRING(1..T) := f.TEXTE_FONCTION(1..T);
   begin
      CREE_ARBRE(Ch,f.ARBRE,BB);
   end;
   if BB then
      B := TRUE;
   else
      DETRUIT_FONCTION(f);
      B := FALSE;
   end if;
end COMPILE_FONCTION;
-- 
procedure GET_LINE(f: in out FONCTION; Msg: in STRING := " ") is
T: NATURAL;
B: BOOLEAN;
begin
    PUT_STRING(Msg);
    loop
       f.TEXTE_FONCTION := (others => ' ');
       LIRE_FONCTION(f.TEXTE_FONCTION);
       COMPILE_FONCTION(f,B);
       if (not B) then
	  BIP;
	  TEXT_IO.PUT_LINE("Erreur de syntaxe: Recommencer");
       else
	  exit;
       end if;
    end loop;
    TEXT_IO.NEW_LINE;
end GET_LINE;
-- 
function TEXTE_DE_FONCTION(f: in FONCTION) return STRING is
L: NATURAL := LONGUEUR_CHAINE(f.TEXTE_FONCTION);
begin
    return f.TEXTE_FONCTION(1..L);
end TEXTE_DE_FONCTION;
-- 

end MATH2;
