--             ͻ
--                             J. E. ROMBALDI               
--                      E.N.S.A.M. CHALONS SUR MARNE        
--                           COPYRIGHT (C) 1993             
--                    SPECIFICATION DU PAQUETAGE MATH2      
--             ͼ

--ͻ
--                        Utilite du paquetage.                           
--                                                                        
-- Dans ce paquetage, on definit un type FONCTION avec des procedures qui 
-- permettent d'entrer au clavier une fonction de une ou plusieurs        
-- variables et de l'evaluer en fonction des parametres effectifs donnes. 
--ͼ

package MATH2 is

MAX_VARIABLES: constant INTEGER := 99;
subtype INDICE_VARIABLES is INTEGER range 0..MAX_VARIABLES;
type VARIABLE_2 is array(INDICE_VARIABLES range <>) of FLOAT;
type FONCTION(MAX_CHAINE: NATURAL := 80) is limited private;

function EVALUE(f: FONCTION; x: FLOAT; y: in VARIABLE_2) return FLOAT;
function EVALUE(f: FONCTION; x, y, z, t: FLOAT := 0.0) return FLOAT;
procedure DETRUIT_FONCTION(f: in out FONCTION);
procedure GET_LINE(f: in out FONCTION; Msg: in STRING := " ");
function TEXTE_DE_FONCTION(f: in FONCTION) return STRING;

private

type TYPE_NOEUD is (CONSTANTE, VARIABLE, OPERATION_UNAIRE, OPERATION_BINAIRE);
type UNE_OPERATION_UNAIRE is (FMOINS, FPLUS,
		      FSIN, FCOS, FTG, FARCSIN, FARCCOS,
		      FARCTAN, FSH,  FCH, FTH, FARGSH, FARGCH, FARGTH,
		      FABS, FFRAC, FEXP, FLN, FGAMMA, FLNGAMMA, FSQRT);
type UNE_OPERATION_BINAIRE is (FSUM, FSUB, FMUL, FDIV, FPUI);
type NOEUD;
type POINTEUR_NOEUD is access NOEUD;
type NOEUD is
     record
	  GAUCHE, DROITE : POINTEUR_NOEUD;
	  TYPE_DU_NOEUD: TYPE_NOEUD;
	  VALEUR: FLOAT;
	  RANG: INTEGER;
	  OPERATION_1: UNE_OPERATION_UNAIRE;
	  OPERATION_2: UNE_OPERATION_BINAIRE;
     end record;

type FONCTION(MAX_CHAINE: NATURAL := 80) is
     record
	  TEXTE_FONCTION: STRING(1..MAX_CHAINE) := (others => ' ');
	  ARBRE: NOEUD;
     end record;


end MATH2;
