with TEXT_IO, IIO, FIO, INTERRUPT, CRT, MATH0, COMMON_MATH1, MATH1,
     COMMON_GRAPH, GRAPH, COMMON_MATH3;
use TEXT_IO, IIO, FIO, CRT, MATH0, COMMON_MATH1, MATH1, COMMON_GRAPH, GRAPH,
    COMMON_MATH3;

package body MATH3 is

EPS: constant FLOAT := 1.0E-6;
MIN_REAL: constant FLOAT := 1.0E-38;
MAX_REAL: constant FLOAT := 1.0E+38;
CORRECT, TRACE_GRILLE: BOOLEAN;
-- 
procedure INIT_GRAPHIQUE is
begin
    INIT_GRAPH(CHOIX_CARTE_GRAPHIQUE);
    X_MINIMUM := 0;
    Y_MINIMUM := 0;
    INDIC_MODE := GRAPHIQUE;
    LARGEUR_CAR := LARGEUR_PIXEL;
    HAUTEUR_CAR := HAUTEUR_PIXEL;
    MARGE := HAUTEUR_CAR + 4;
    X_MAXIMUM := GET_MAX_X;
    Y_MAXIMUM := GET_MAX_Y;
end INIT_GRAPHIQUE;
-- 
procedure MODE_TEXTE is
begin
    CLRSCR;
    CURSOR(TRUE);
    INDIC_MODE := TEXTE;
end MODE_TEXTE;
-- 
procedure MESSAGE_ERREUR_GRAPHIQUE(Msg: in STRING) is
begin
    MODE_TEXTE;
    PUT_LINE("Erreur dans ");
    raise ERREUR_CONTRAINTES_GRAPHIQUES;
end MESSAGE_ERREUR_GRAPHIQUE;
-- 
procedure TEST_MODE_GRAPHIQUE(Msg: in STRING) is
begin
    if (INDIC_MODE = TEXTE) then
       BIP;
       PUT_LINE("*** Erreur graphique ***");
       PUT_LINE("Appeler INIT_GRAPHIQUE avant d'utiliser la procedure "
		 & Msg);
       raise ERREUR_MODE_ECRAN;
     end if;
end TEST_MODE_GRAPHIQUE;
-- 
procedure FENETRE(X_FEN_MIN,X_FEN_MAX,Y_FEN_MIN,Y_FEN_MAX: in FLOAT) is
begin
    TEST_MODE_GRAPHIQUE("FENETRE_GRAPHIQUE");
    if (abs(X_FEN_MAX - X_FEN_MIN) < EPS) then
       X_MIN := X_FEN_MIN - 1.0;
       X_MAX := X_FEN_MAX + 1.0;
    end if;
    if (abs(Y_FEN_MAX - Y_FEN_MIN) < EPS) then
       Y_MIN := Y_FEN_MIN - 1.0;
       Y_MAX := Y_FEN_MAX + 1.0;
    end if;
    CORRECT := ( (X_FEN_MAX > X_FEN_MIN + MIN_REAL) and
      (Y_FEN_MAX > Y_FEN_MIN + MIN_REAL) and (abs(X_FEN_MIN) < MAX_REAL) and
      (abs(X_FEN_MAX) < MAX_REAL) and (abs(Y_FEN_MIN) < MAX_REAL) and
      (abs(Y_FEN_MAX) < MAX_REAL) );
    if (not CORRECT) then
       MESSAGE_ERREUR_GRAPHIQUE("Fenetre: Taille fenetre incorrecte");
    end if;
    X_MIN := X_FEN_MIN;
    X_MAX := X_FEN_MAX;
    Y_MIN := Y_FEN_MIN;
    Y_MAX := Y_FEN_MAX;
    LARGEUR_ECRAN := X_MAX - X_MIN;
    HAUTEUR_ECRAN := Y_MAX - Y_MIN;
    GR_X_MIN := 0;
    GR_X_MAX := X_MAXIMUM;
    GR_Y_MIN := MARGE;
    GR_Y_MAX := Y_MAXIMUM - MARGE;
    X_POS := GR_X_MIN;
    Y_POS := GR_Y_MIN;
    GR_LARGEUR_ECRAN := GR_X_MAX - GR_X_MIN + 1;
    GR_HAUTEUR_ECRAN := GR_Y_MAX - GR_Y_MIN + 1;
    X_RAPPORT := FLOAT(GR_LARGEUR_ECRAN)/LARGEUR_ECRAN;
    Y_RAPPORT := FLOAT(GR_HAUTEUR_ECRAN)/HAUTEUR_ECRAN;
end FENETRE;
-- 
procedure CADRE_GRAPHIQUE(X_CADRE_MIN, X_CADRE_MAX,
			  Y_CADRE_MIN, Y_CADRE_MAX: in INTEGER) is
begin
    TEST_MODE_GRAPHIQUE("CADRE_GRAPHIQUE");
    CORRECT := (X_CADRE_MIN >= X_MINIMUM) and (X_CADRE_MAX <= X_MAXIMUM) and
	       (Y_CADRE_MIN >= Y_MINIMUM) and (Y_CADRE_MAX <= Y_MAXIMUM) and
	       (X_CADRE_MIN < X_CADRE_MAX) and (Y_CADRE_MIN < Y_CADRE_MAX);
    if (not CORRECT) then
       MESSAGE_ERREUR_GRAPHIQUE(
		    "CADRE_GRAPHIQUE: Taille des cadres incorrecte.");
    end if;
    GR_X_MIN := X_CADRE_MIN;
    GR_X_MAX := X_CADRE_MAX;
    GR_Y_MIN := Y_CADRE_MIN;
    GR_Y_MAX := Y_CADRE_MAX;
    GR_LARGEUR_ECRAN := GR_X_MAX - GR_X_MIN ;
    GR_HAUTEUR_ECRAN := GR_Y_MAX - GR_Y_MIN;
    X_RAPPORT := FLOAT(GR_LARGEUR_ECRAN)/LARGEUR_ECRAN;
    Y_RAPPORT := FLOAT(GR_HAUTEUR_ECRAN)/HAUTEUR_ECRAN;
    RECTANGLE(GR_X_MIN,GR_X_MAX,GR_Y_MIN,GR_Y_MAX,TRUE);
end CADRE_GRAPHIQUE;
-- 
procedure FENETRE_GRAPHIQUE(X_FEN_MIN,X_FEN_MAX,
			    Y_FEN_MIN,Y_FEN_MAX: in FLOAT) is
begin
    FENETRE(X_FEN_MIN,X_FEN_MAX,Y_FEN_MIN,Y_FEN_MAX);
    RECTANGLE(GR_X_MIN,GR_X_MAX,GR_Y_MIN,GR_Y_MAX,TRUE);
end FENETRE_GRAPHIQUE;
-- 
procedure CONVERSION(x, y: in FLOAT;
		     X_INFO: out INTEGER;
		     Y_INFO: out INTEGER) is
begin
    X_INFO := GR_X_MIN + INTEGER((X - X_MIN)*X_RAPPORT);
    Y_INFO := GR_Y_MIN + INTEGER((Y_MAX - Y)*Y_RAPPORT);
    exception
       when CONSTRAINT_ERROR =>
	  MESSAGE_ERREUR_GRAPHIQUE("CONVERSION: Coordonnees incorrectes");
end CONVERSION;
-- 
PROCEDURE TEXT_MOVE_TO(x: in INTEGER; y: in INTEGER) is
r1, c1: NATURAL;
L: TEXTE_VERTICAL;
c: TEXTE_HORIZONTAL;
R: INTERRUPT.REGISTERS;
begin
    c1 := x/LARGEUR_CAR;
    r1 := y/HAUTEUR_CAR;
    c := c1;
    L := r1;
    R.AX := 16#0200#;
    R.BX := 16#0000#;
    R.DX := L*256 + C;
    INTERRUPT.VECTOR(16#10#,R);
end TEXT_MOVE_TO;
-- 
procedure PAUSE_GRAPHIQUE is
C: CHARACTER;
begin
    TEXT_MOVE_TO(20,Y_MAXIMUM);
    PUT_STRING("Appuyer sur une touche pour continuer");
    C := READKEY;
end PAUSE_GRAPHIQUE;
-- 
procedure POINT(x, y: in FLOAT) is
X_INFO: INTEGER;
Y_INFO: INTEGER;
begin
    TEST_MODE_GRAPHIQUE("POINT");
    CORRECT := ((abs(x) < MAX_REAL) and (abs(y) < MAX_REAL));
    if (not CORRECT) then
      MESSAGE_ERREUR_GRAPHIQUE("POINT: Coordonnees trop grandes");
    end if;
    CONVERSION(x,y,X_INFO,Y_INFO);
    PUT_PIXEL(X_INFO,Y_INFO);
end POINT;
-- 
procedure TRACE_SEGMENT(x1, y1, x2, y2: in FLOAT) is
X1_INFO, X2_INFO: INTEGER;
Y1_INFO, Y2_INFO: INTEGER;
begin
    TEST_MODE_GRAPHIQUE("TRACE_SEGMENT");
    CORRECT := ((abs(x1) < MAX_REAL) and (abs(y1) < MAX_REAL) and
		(abs(x2) < MAX_REAL) and (abs(y2) < MAX_REAL));
    if (not CORRECT) then
      MESSAGE_ERREUR_GRAPHIQUE("TRACE_SEGMENT: Coordonnees trop grandes");
    end if;
    CONVERSION(x1,y1,X1_INFO,Y1_INFO);
    CONVERSION(x2,y2,X2_INFO,Y2_INFO);
    LINE(X1_INFO,X2_INFO,Y1_INFO,Y2_INFO);
end TRACE_SEGMENT;
-- 
procedure TRACE(x, y: in FLOAT) is
X_INFO: INTEGER;
Y_INFO: INTEGER;
begin
    TEST_MODE_GRAPHIQUE("TRACE");
    CORRECT := ((abs(x) < MAX_REAL) and (abs(y) < MAX_REAL));
    if (not CORRECT) then
      MESSAGE_ERREUR_GRAPHIQUE("TRACE: Coordonnees trop grandes");
    end if;
    CONVERSION(x,y,X_INFO,Y_INFO);
    LINE_TO(X_INFO,Y_INFO);
end TRACE;
-- 
procedure DEPLACE(x, y: in FLOAT) is
X_INFO: INTEGER;
Y_INFO: INTEGER;
begin
    TEST_MODE_GRAPHIQUE("DEPLACE");
    CORRECT := ((abs(x) < MAX_REAL) and (abs(y) < MAX_REAL));
    if (not CORRECT) then
      MESSAGE_ERREUR_GRAPHIQUE("DEPLACE: Coordonnees trop grandes");
    end if;
    CONVERSION(x,y,X_INFO,Y_INFO);
    X_POS := X_INFO;
    Y_POS := Y_INFO;
end DEPLACE;
-- 
procedure CROIX(x, y: in FLOAT) is
begin
    TEST_MODE_GRAPHIQUE("CROIX");
    CORRECT := ((abs(x) < MAX_REAL) and (abs(y) < MAX_REAL));
    if (not CORRECT) then
      MESSAGE_ERREUR_GRAPHIQUE("CROIX: Coordonnees trop grandes");
    end if;
    DEPLACE(x,y);
    LINE(X_POS - 4,X_POS + 4,Y_POS, Y_POS);
    LINE(X_POS - 4,X_POS - 4,Y_POS - 4, Y_POS + 4);
    DEPLACE(x,y);
end CROIX;
-- 
procedure SORTIE_GRAPHIQUE is
begin
    PAUSE_GRAPHIQUE;
    MODE_TEXTE;
end SORTIE_GRAPHIQUE;
-- 
procedure CERCLE(x, y, r: in FLOAT) is
c, s, xx, yy, Aux: FLOAT;
begin
    TEST_MODE_GRAPHIQUE("CERCLE");
    CORRECT := ((abs(x) < MAX_REAL) and (abs(y) < MAX_REAL) and
		(r > 0.0) and (r < MAX_REAL));
    if (not CORRECT) then
      MESSAGE_ERREUR_GRAPHIQUE("CERCLE: Donnees incorrectes");
    end if;
    s := SIN(PI/90.0);
    c := COS(PI/90.0);
    xx := x + r;
    yy := y;
    DEPLACE(xx,yy);
    for i in 1..180 loop
      Aux := x + (xx - x)*c - (yy - y)*s;
      yy := y + (xx - x)*s + (yy - y)*c;
      xx := Aux;
      TRACE(xx,yy);
    end loop;
end CERCLE;
-- 
procedure VERIFICATION_SYSTEME is
begin
    INIT_GRAPHIQUE;
    FENETRE(-1.0,1.0,-1.0,1.0);
    SORTIE_GRAPHIQUE;
    PUT("X_MINIMUM "); PUT(X_MINIMUM); PUT("  X_MAXIMUM "); PUT(X_MAXIMUM);
    NEW_LINE;
    PUT("Y_MINIMUM "); PUT(Y_MINIMUM); PUT("  Y_MAXIMUM "); PUT(Y_MAXIMUM);
    NEW_LINE;
    PUT("GR_X_MIN "); PUT(GR_X_MIN); PUT("  GR_X_MAX "); PUT(GR_X_MAX);
    NEW_LINE;
    PUT("GR_Y_MIN "); PUT(GR_Y_MIN); PUT("  GR_Y_MAX "); PUT(GR_Y_MAX);
    NEW_LINE;
    PUT("X_MIN "); PUT(X_MIN); PUT("  X_MAX "); PUT(X_MAX);
    NEW_LINE;
    PUT("Y_MIN "); PUT(Y_MIN); PUT("  Y_MAX "); PUT(Y_MAX);
    NEW_LINE;
    PUT("HAUTEUR_CAR "); PUT(HAUTEUR_CAR); PUT("  LARGEUR_CAR ");
    PUT(LARGEUR_CAR); NEW_LINE;
    PUT(" MARGE "); PUT(MARGE);
    NEW_LINE;
    PUT("MAX_LIGNE "); PUT(MAX_LIGNE_TEXTE); PUT("  MAX_COLONNE ");
    PUT(MAX_COLONNE_TEXTE); NEW_LINE;
end VERIFICATION_SYSTEME;
-- 
procedure X_AXE(X_ORIGINE, Y_ORIGINE, X_UNITE: in FLOAT) is
U: FLOAT;
p, q: INTEGER;

procedure TRACE_GRADUATION_X is
begin
    if (X_GRD > (X_MAX - X_MIN)/2.0) or (X_GRD < (X_MAX - X_MIN)/100.0) then
       return;
    end if;
    if (abs((X_MAX - X_MIN)/X_GRD) <= FLOAT(GR_LARGEUR_ECRAN/2)) then
       u := X_ORIGINE + X_GRD;
       while (u < (X_MAX - EPS)) loop
	  if (u > X_MIN) then
	     DEPLACE(u,Y_ORIGINE);
	     CONVERSION(u,Y_ORIGINE,p,q);
	     LINE(p,p,q - 3,q + 3);
	     if TRACE_GRILLE then
	       for k in 1..(GR_Y_MAX/3) loop
		  PUT_PIXEL(p,3*k);
	       end loop;
	     end if;
	  end if;
	  u := u + X_GRD;
       end loop;
       u := X_ORIGINE - X_GRD;
       while (u > (X_MIN + EPS)) loop
	  if (u < X_MAX) then
	     DEPLACE(u,Y_ORIGINE);
	     CONVERSION(u,Y_ORIGINE,p,q);
	     LINE(p,p,q - 3,q + 3);
	     if TRACE_GRILLE then
	       for k in 1..(GR_Y_MAX/3) loop
		  PUT_PIXEL(p,3*k);
	       end loop;
	     end if;
	  end if;
	  u := u - X_GRD;
       end loop;
    end if;
end TRACE_GRADUATION_X;

procedure TRACE_AXE_X is
begin
    DEPLACE(X_MIN,Y_ORIGINE);
    TRACE(X_MAX,Y_ORIGINE);
    DEPLACE(X_MAX,Y_ORIGINE);
    CONVERSION(X_MAX,Y_ORIGINE,p,q);
    LINE(p,p - 8,q,q - 8);
    LINE(p,p - 8,q,q + 8);
end TRACE_AXE_X;

begin
    TEST_MODE_GRAPHIQUE("X_AXE");
    X_GRD := X_UNITE;
    if ((Y_ORIGINE <= Y_MAX) and (Y_ORIGINE >= Y_MIN)) then
       TRACE_AXE_X;
       TRACE_GRADUATION_X;
    end if;
end X_AXE;
-- 
procedure Y_AXE(X_ORIGINE, Y_ORIGINE, Y_UNITE: in FLOAT) is
U: FLOAT;
p, q: INTEGER;

procedure TRACE_GRADUATION_Y is
begin
    if (Y_GRD > (Y_MAX - Y_MIN)/2.0) or (Y_GRD < (Y_MAX - Y_MIN)/100.0) then
       return;
    end if;
    if (abs((Y_MAX - Y_MIN)/Y_GRD) <= FLOAT(GR_HAUTEUR_ECRAN/2)) then
       u := Y_ORIGINE + Y_GRD;
       while (u < (Y_MAX - EPS)) loop
	  if (u > Y_MIN) then
	     DEPLACE(X_ORIGINE,u);
	     CONVERSION(X_ORIGINE,u,p,q);
	     LINE(p - 3,p + 3,q,q);
	     if TRACE_GRILLE then
	       for k in 1..(GR_X_MAX/3) loop
		  PUT_PIXEL(3*k,q);
	       end loop;
	     end if;
	  end if;
	  u := u + Y_GRD;
       end loop;
       u := Y_ORIGINE - Y_GRD;
       while (u > (Y_MIN + EPS)) loop
	  if (u < Y_MAX) then
	     DEPLACE(X_ORIGINE,u);
	     CONVERSION(X_ORIGINE,u,p,q);
	     LINE(p - 3,p + 3,q,q);
	     if TRACE_GRILLE then
	       for k in 1..(GR_X_MAX/3) loop
		  PUT_PIXEL(3*k,q);
	       end loop;
	     end if;
	  end if;
	  u := u - Y_GRD;
       end loop;
    end if;
end TRACE_GRADUATION_Y;

procedure TRACE_AXE_Y is
begin
    DEPLACE(X_ORIGINE,Y_MIN);
    TRACE(X_ORIGINE,Y_MAX);
    DEPLACE(X_ORIGINE,Y_MAX);
    CONVERSION(X_ORIGINE,Y_MAX,p,q);
    LINE(p,p - 8,q,q + 8);
    LINE(p,p + 8,q,q + 8);
end TRACE_AXE_Y;

begin
    TEST_MODE_GRAPHIQUE("Y_AXE");
    Y_GRD := Y_UNITE;
    if ((X_ORIGINE <= X_MAX) and (X_ORIGINE >= X_MIN)) then
       TRACE_AXE_Y;
       TRACE_GRADUATION_Y;
    end if;
end Y_AXE;
-- 
procedure XY_AXES(X_ORIGINE, Y_ORIGINE, X_UNITE, Y_UNITE: in FLOAT;
		 XY_GRILLE: in BOOLEAN := TRUE) is
begin
   TRACE_GRILLE := XY_GRILLE;
   TEST_MODE_GRAPHIQUE("XY_AXES");
   X_AXE(X_ORIGINE,Y_ORIGINE,X_UNITE);
   Y_AXE(X_ORIGINE,Y_ORIGINE,Y_UNITE);
end XY_AXES;
-- 
procedure TITRE(Msg: in STRING) is
Efface: STRING(1..79) := (others => ' ');
begin
    TEXT_MOVE_TO(0,0);
    PUT_STRING(Efface);
    TEXT_MOVE_TO(0,0);
    PUT_STRING(Msg);
end TITRE;
-- 

end MATH3;
