with TEXT_IO, IIO, FIO, MATH_LIB, COMMON_MATH0, MATH0, COMMON_MATRIX;
use TEXT_IO, COMMON_MATH0, MATH0, COMMON_MATRIX;

package body  MATRIX is

procedure GET(A : out MATRICE) is
begin
      if A'LENGTH(1) /= A'LENGTH(2) then
	PUT_LINE("Erreur dans GET: Matrice non carree");
	raise ERREUR_DIMENSIONS;
      end if;
      for i in A'range(1)
      loop
	TEXT_IO.PUT("Entrer les elements de la ligne Numero"); IIO.PUT(i);
	TEXT_IO.PUT_LINE(": "); NEW_LINE;
	for j in A'range(2)
	loop
	   ENTRER_REEL(A(i,j),"A(" & INTEGER'IMAGE(i) & ","
			       & INTEGER'IMAGE(j) & ") = ");
	end loop;
	TEXT_IO.NEW_LINE;
      end loop;
end GET;
-- 
procedure MATRICE_ALEATOIRE(A : out MATRICE) is
begin
      if A'LENGTH(1) /= A'LENGTH(2) then
	PUT_LINE("Erreur dans GET: Matrice non carree");
	raise ERREUR_DIMENSIONS;
      end if;
      RANDOMIZE;
      for i in A'range(1)
      loop
	for j in A'range(2)
	loop
	   A(i,j) := -20.0 + RANDOM*40.0;
	end loop;
      end loop;
end MATRICE_ALEATOIRE;
-- 
procedure MATRICE_DU_FICHIER(A: out MATRICE;
			     NOM_DE_REPERTOIRE: in STRING := "A:\DONNEES") is
FICHIER: TEXT_IO.FILE_TYPE;
NOM_DE_FICHIER: STRING(1..50);
i, j: NATURAL;
begin
   if A'LENGTH(1) /= A'LENGTH(2) then
      PUT_LINE("Erreur dans MATRICE_DU_FICHIER: Matrice non carree");
      raise ERREUR_DIMENSIONS;
    end if;
    A := (others => (others => 0.0));
    LIRE_FICHIER(FICHIER,NOM_DE_FICHIER,NOM_DE_REPERTOIRE);
    i := A'FIRST(1);
    loop
       j := A'FIRST(2);
       loop
	  FIO.GET(FICHIER,A(i,j));
	  j := j + 1;
	  exit when (END_OF_LINE(FICHIER)) or (j > A'LAST(2));
       end loop;
       TEXT_IO.SKIP_LINE(FICHIER);
       i := i + 1;
       exit when (END_OF_FILE(FICHIER)) or (i > A'LAST(1));
    end loop;
    CLOSE(FICHIER);
end MATRICE_DU_FICHIER;
-- 
procedure MATRICE_HILBERT(A: out MATRICE) is
begin
   if A'LENGTH(1) /= A'LENGTH(2) then
      PUT_LINE("Erreur dans MATRICE_HILBERT: Matrice non carree");
      raise ERREUR_DIMENSIONS;
    end if;
    for i in A'range(1)
    loop
       for j in A'range(2)
       loop
	  A(i,j) := 1.0/FLOAT(i + j - 1);
       end loop;
    end loop;
end MATRICE_HILBERT;
-- 
procedure MATRICE_TEST(A: in out MATRICE) is
begin
   if A'LENGTH(1) /= A'LENGTH(2) then
      PUT_LINE("Erreur dans MATRICE_TEST: Matrice non carree");
      raise ERREUR_DIMENSIONS;
    end if;
    for i in A'range(1)
    loop
       for j in i..A'LAST(2)
       loop
	  A(i,j) := FLOAT(A'LAST(2) - j + 1);
       end loop;
    end loop;
    for i in 2..A'LAST(1)
    loop
       for j in A'FIRST(1)..i - 1
       loop
	  A(i,j) := A(j,i);
       end loop;
    end loop;
end MATRICE_TEST;
-- 
procedure MATRICE_VAN_DER_MONDE(v: in VECTEUR; A: in out MATRICE) is
begin
   if A'LENGTH(1) /= A'LENGTH(2) then
      PUT_LINE("Erreur dans MATRICE_VAN_DER_MONDE: Matrice non carree");
      raise ERREUR_DIMENSIONS;
    end if;
    if (A'LENGTH(1) /= v'LENGTH(1)) then
       PUT_LINE("Erreur dans MATRICE_VAN_DER_MONDE: Dimension de la matrice et du vecteur incompatibles");
       raise ERREUR_DIMENSIONS;
     end if;
    for j in A'range(2)
    loop
       A(1,j) := 1.0;
    end loop;
    for i in 2..A'LAST(1)
    loop
       for j in A'range(2)
       loop
	  A(i,j) := A(i - 1,j)*v(j);
       end loop;
    end loop;
end MATRICE_VAN_DER_MONDE;
-- 
procedure GET(A: out MATRICE_TRIDIAGONALE) is
begin
    TEXT_IO.PUT_LINE("Elements de la diagonale inferieure: A(i,i - 1)");
    for i in 2..A'LAST
    loop
       ENTRER_REEL(A(i)(1));
    end loop;
    TEXT_IO.PUT_LINE("Elements de la diagonale principale: A(i,i)");
    for i in A'range
    loop
       ENTRER_REEL(A(i)(2));
    end loop;
    TEXT_IO.PUT_LINE("Elements de la diagonale superieure: A(i,i + 1)");
    for i in 1..A'LAST - 1
    loop
       ENTRER_REEL(A(i)(3));
    end loop;
end GET;
-- 
procedure MATRICE_TRIDIAG_ALEATOIRE(A: out MATRICE_TRIDIAGONALE) is
begin
    for i in A'range
    loop
       for j in 1..3
       loop
	  A(i)(j) := -20.0 + RANDOM*40.0;
       end loop;
    end loop;
end MATRICE_TRIDIAG_ALEATOIRE;
-- 
procedure MATRICE_TRIDIAG_DU_FICHIER(A: out MATRICE_TRIDIAGONALE;
			     NOM_DE_REPERTOIRE: in STRING := "A:\DONNEES") is
FICHIER: TEXT_IO.FILE_TYPE;
NOM_DE_FICHIER: STRING(1..50);
i: NATURAL;
begin
    A := (others => (others => 0.0));
    LIRE_FICHIER(FICHIER,NOM_DE_FICHIER,NOM_DE_REPERTOIRE);
    i := A'FIRST;
    loop
       for j in 1..3 loop
	  FIO.GET(FICHIER,A(i)(j));
       end loop;
       SKIP_LINE(FICHIER);
       i := i + 1;
       exit when (END_OF_FILE(FICHIER)) or (i > A'LAST);
    end loop;
    CLOSE(FICHIER);
end MATRICE_TRIDIAG_DU_FICHIER;
-- 
procedure MATRICE_SYMETRIQUE(A: in out MATRICE) is
begin
    if A'LENGTH(1) /= A'LENGTH(2) then
	PUT_LINE("Erreur dans MATRICE_SYMETRIQUE: Matrice non carree");
	raise ERREUR_DIMENSIONS;
    end if;
    for i in A'range(1)
    loop
      TEXT_IO.PUT("Entrer les elements de la ligne Numero"); IIO.PUT(i);
      TEXT_IO.PUT_LINE(" du triangle superieur: ");
      for j in i..A'LAST(2)
      loop
	ENTRER_REEL(A(i,j),"A(" & INTEGER'IMAGE(i) & ","
			    & INTEGER'IMAGE(j) & ") = ");
      end loop;
      for j in A'FIRST(1)..i - 1
      loop
	 A(i,j) := A(j,i);
      end loop;
      NEW_LINE;
    end loop;
end MATRICE_SYMETRIQUE;
-- 
procedure MATRICE_SYM_ALEATOIRE(A: in out MATRICE) is
begin
    if A'LENGTH(1) /= A'LENGTH(2) then
	PUT_LINE("Erreur dans MATRICE_SYM_ALEATOIRE: Matrice non carree");
	raise ERREUR_DIMENSIONS;
    end if;
    RANDOMIZE;
    for i in A'range(1)
    loop
       for j in i..A'LAST(2)
       loop
	  A(i,j) := -20.0 + RANDOM*40.0;
       end loop;
       for j in A'FIRST(2)..i - 1
       loop
	  A(i,j) := A(j,i);
       end loop;
    end loop;
end MATRICE_SYM_ALEATOIRE;
-- 
procedure MATRICE_SYM_DU_FICHIER(A: in out MATRICE;
			     NOM_DE_REPERTOIRE: in STRING := "A:\DONNEES") is
FICHIER: TEXT_IO.FILE_TYPE;
NOM_DE_FICHIER: STRING(1..50);
i, j: NATURAL;
begin
   if A'LENGTH(1) /= A'LENGTH(2) then
      PUT_LINE("Erreur dans MATRICE_DU_FICHIER: Matrice non carree");
      raise ERREUR_DIMENSIONS;
    end if;
    A := (others => (others => 0.0));
    LIRE_FICHIER(FICHIER,NOM_DE_FICHIER,NOM_DE_REPERTOIRE);
    i := A'FIRST(1);
    loop
       j := i;
       loop
	  FIO.GET(FICHIER,A(i,j));
	  j := j + 1;
	  exit when (END_OF_LINE(FICHIER)) or (j > A'LAST(2));
       end loop;
       SKIP_LINE(FICHIER);
       for j in A'FIRST(2)..i - 1
       loop
	  A(i,j) := A(j,i);
       end loop;
       i := i + 1;
       exit when (END_OF_FILE(FICHIER)) or (i > A'LAST(1));
    end loop;
    CLOSE(FICHIER);
end MATRICE_SYM_DU_FICHIER;
-- 
procedure PUT_LINE(A: in MATRICE; FORE: in TEXT_IO.FIELD := 6;
				  AFT: in TEXT_IO.FIELD := 4;
				  EXP: in TEXT_IO.FIELD := 0) is
begin
    for i in A'range(1)
    loop
      TEXT_IO.PUT(IMP,"Ligne Numero"); IIO.PUT(IMP,i); TEXT_IO.PUT_LINE(IMP," ");
      for j in A'range(2)
      loop
	FIO.PUT(IMP,A(i,j),FORE,AFT,EXP);
	TEXT_IO.PUT(IMP," ");
      end loop;
      TEXT_IO.NEW_LINE(IMP);
      if (i /= A'LAST(1)) and (i mod 5 = 0) then
	PAUSE;
      end if;
    end loop;
end PUT_LINE;
-- 
procedure PUT_LINE(A: in MATRICE_TRIDIAGONALE;
				  FORE: in TEXT_IO.FIELD := 6;
				  AFT: in TEXT_IO.FIELD := 4;
				  EXP: in TEXT_IO.FIELD := 0) is
begin
    for i in A'range
    loop
       TEXT_IO.PUT(IMP,"Ligne Numero"); IIO.PUT(IMP,i);
       TEXT_IO.NEW_LINE(IMP);
       for j in A'FIRST..i - 2
       loop
	  IIO.PUT(IMP,0,FORE + AFT);
       end loop;
       if (i > 1) then
	  FIO.PUT(IMP,A(i)(1),FORE,AFT,EXP);
       end if;
       FIO.PUT(IMP,A(i)(2),FORE,AFT,EXP);
       if (i < A'LAST) then
	   FIO.PUT(IMP,A(i)(3),FORE,AFT,EXP);
       end if;
       for j in i + 2..A'LAST
       loop
	  IIO.PUT(IMP,0,FORE + AFT);
       end loop;
       TEXT_IO.NEW_LINE(IMP);
       if (i /= A'LAST) and (i mod 5 = 0) then
	  PAUSE;
       end if;
    end loop;
    NEW_LINE(IMP);
end PUT_LINE;
-- 
procedure GET(v : out VECTEUR) is
  begin
      for i in v'range(1)
      loop
	 ENTRER_REEL(v(i),"Coordonnee Numero" & INTEGER'IMAGE(i) & " = ");
      end loop;
end GET;
-- 
procedure VECTEUR_ALEATOIRE(v: out VECTEUR) is
begin
    RANDOMIZE;
    for i in v'range
    loop
       v(i) := -20.0 + RANDOM*20.0;
    end loop;
end VECTEUR_ALEATOIRE;
-- 
procedure VECTEUR_DU_FICHIER(v: out VECTEUR;
			     NOM_DE_REPERTOIRE: in STRING := "A:\DONNEES") is
FICHIER: TEXT_IO.FILE_TYPE;
NOM_DE_FICHIER: STRING(1..50);
i: NATURAL;
begin
    v := (others => 0.0);
    LIRE_FICHIER(FICHIER,NOM_DE_FICHIER,NOM_DE_REPERTOIRE);
    i := v'FIRST;
    loop
       FIO.GET(FICHIER,v(i));
       SKIP_LINE(FICHIER);
       i := i + 1;
       exit when (END_OF_FILE(FICHIER)) or (i > v'LAST);
    end loop;
    CLOSE(FICHIER);
end VECTEUR_DU_FICHIER;
-- 
procedure PUT_LINE(v: in VECTEUR; FORE: in TEXT_IO.FIELD := 6;
				  AFT: in TEXT_IO.FIELD := 4;
				  EXP: in TEXT_IO.FIELD := 0) is
begin
    TEXT_IO.PUT(IMP,"(");
    for i in v'FIRST..v'LAST - 1
    loop
       FIO.PUT(IMP,v(i),FORE,AFT,EXP);
       TEXT_IO.PUT(IMP,",");
    end loop;
    FIO.PUT(IMP,v(v'LAST),FORE,AFT,EXP);
    TEXT_IO.PUT_LINE(IMP,")");
end PUT_LINE;
-- 
function TRACE(A: in MATRICE) return FLOAT is
Aux: FLOAT := 0.0;
begin
    if (A'LENGTH(1) /= A'LENGTH(2)) then
       PUT_LINE("Erreur dans TRACE: Matrice non carre");
       raise ERREUR_DIMENSIONS;
    end if;
    for i in A'range(1)
    loop
       Aux := Aux + A(i,i);
    end loop;
    return Aux;
end TRACE;
-- 
function TRANSPOSE(A: in MATRICE) return MATRICE is
begin
    declare
      TA: MATRICE(A'range(1),A'range(2));
    begin
       for i in A'range(1)
       loop
	  for j in A'range(2)
	  loop
	     TA(i,j) := A(j,i);
	  end loop;
	end loop;
	return TA;
    end;
end TRANSPOSE;
-- 
function "+"(A, B: in  MATRICE) return  MATRICE is
begin
    if (A'LENGTH(1) /= B'LENGTH(1)) or else (A'LENGTH(2) /= B'LENGTH(2)) then
       PUT_LINE("Erreur dans +: Dimension des matrices incompatibles");
       raise ERREUR_DIMENSIONS;
     end if;
     declare
	C: MATRICE(A'range(1),A'range(2));
     begin
	for i in A'range(1)
	loop
	   for j in A'range (2)
	   loop
	      C(i,j) := A(i,j) + B(i,j);
	   end loop;
	end loop;
	return C;
     end;
end "+";
-- 
function "-"(A, B: in  MATRICE) return  MATRICE is
begin
    if (A'LENGTH(1) /= B'LENGTH(1)) or else (A'LENGTH(2) /= B'LENGTH(2)) then
       PUT_LINE("Erreur dans -: Dimension des matrices incompatibles");
       raise ERREUR_DIMENSIONS;
     end if;
     declare
	C: MATRICE(A'range(1),A'range(2));
     begin
	for i in A'range(1)
	loop
	   for j in A'range (2)
	   loop
	      C(i,j) := A(i,j) - B(i,j);
	   end loop;
	end loop;
	return C;
     end;
end "-";
-- 
function "*"(A, B: in  MATRICE) return  MATRICE is
begin
    if (A'LENGTH(1) /= B'LENGTH(1)) or else (A'LENGTH(2) /= B'LENGTH(2)) then
       PUT_LINE("Erreur dans *: Dimension des matrices incompatibles");
       raise ERREUR_DIMENSIONS;
     end if;
     declare
	C: MATRICE(A'range(1),A'range(2)) := (others => (others => 0.0));
     begin
	for i in A'range(1)
	loop
	   for j in A'range (2)
	   loop
	      for k in A'range(1)
	      loop
		 C(i,j) := C(i,j) + A(i,k)*B(k,j);
	      end loop;
	   end loop;
	end loop;
	return C;
     end;
end "*";
-- 
function "*"(x: in FLOAT; A: in  MATRICE) return  MATRICE is
C: MATRICE(A'range(1),A'range(2)) := (others => (others => 0.0));
begin
    for i in A'range(1)
    loop
       for j in A'range (2)
       loop
	  C(i,j) := x*A(i,j);
	end loop;
    end loop;
    return C;
end "*";
-- 
function "*"(A: in  MATRICE; v: in VECTEUR) return  VECTEUR is
begin
    if (A'LENGTH(2) /= v'LENGTH(1)) then
       PUT_LINE("Erreur dans *: Dimension de la matrice et du vecteur incompatibles");
       raise ERREUR_DIMENSIONS;
     end if;
     declare
	w: VECTEUR(v'range(1)) := (others => 0.0);
     begin
	for i in A'range(1)
	loop
	   for j in A'range (2)
	   loop
	      w(i) := w(i) + A(i,j)*v(j);
	   end loop;
	end loop;
	return w;
     end;
end "*";
-- 
function "*"(A: in  MATRICE_TRIDIAGONALE; v: in VECTEUR) return  VECTEUR is
begin
    if (A'LENGTH /= v'LENGTH) then
       PUT_LINE("Erreur dans *: Dimension de la matrice et du vecteur incompatibles");
       raise ERREUR_DIMENSIONS;
     end if;
     declare
	w: VECTEUR(v'range) := (others => 0.0);
     begin
	w(v'FIRST) := A(v'FIRST)(2)*v(v'FIRST) + A(v'FIRST)(3)*v(v'FIRST + 1);
	w(v'LAST) := A(v'LAST)(1)*v(v'LAST - 1) + A(v'LAST)(2)*v(v'LAST);
	for i in v'FIRST + 1..v'LAST - 1
	loop
	   for j in 1..3
	   loop
	      w(i) := w(i) + A(i)(j)*v(i - 2 + j);
	   end loop;
	end loop;
	return w;
     end;
end "*";
-- 
function "+"(u, v: in  VECTEUR) return  VECTEUR is
begin
    if (u'LENGTH /= v'LENGTH) then
       PUT_LINE("Erreur dans +: Dimension des vecteurs incompatibles");
       raise ERREUR_DIMENSIONS;
     end if;
     declare
	w: VECTEUR(u'range);
     begin
	for i in u'range
	loop
	   w(i) := u(i) + v(i);
	end loop;
	return w;
     end;
end "+";
-- 
function "-"(u, v: in  VECTEUR) return  VECTEUR is
begin
    if (u'LENGTH /= v'LENGTH) then
       PUT_LINE("Erreur dans -: Dimension des vecteurs incompatibles");
       raise ERREUR_DIMENSIONS;
     end if;
     declare
	w: VECTEUR(u'range);
     begin
	for i in u'range
	loop
	   w(i) := u(i) - v(i);
	end loop;
	return w;
     end;
end "-";
-- 
function "*"(x: in FLOAT; u: in  VECTEUR) return  VECTEUR is
w: VECTEUR(u'range);
begin
    for i in u'range
    loop
       w(i) := x*u(i);
    end loop;
    return w;
end "*";
-- 
function NORME_DU_SUP(v: in VECTEUR) return FLOAT is
Aux: FLOAT := abs(v(v'FIRST));
begin
    for i in v'FIRST + 1..v'LAST
    loop
       if abs(v(i)) > Aux then
	  Aux := abs(v(i));
       end if;
    end loop;
    return Aux;
end NORME_DU_SUP;
-- 
function NORME_EUCLIDIENNE(v: in VECTEUR) return FLOAT is
Aux: FLOAT := 0.0;
begin
    for i in v'range
    loop
       Aux := Aux + v(i)*v(i);
    end loop;
    return MATH_LIB.SQRT(Aux);
end NORME_EUCLIDIENNE;
-- 
function PRODUIT_SCALAIRE(u, v: in VECTEUR) return FLOAT is
Aux: FLOAT := 0.0;
begin
    for i in v'range
    loop
       Aux := Aux + u(i)*v(i);
    end loop;
    return Aux;
end PRODUIT_SCALAIRE;
-- 

end MATRIX;
