--             ͻ
--                             J. E. ROMBALDI               
--                      E.N.S.A.M. CHALONS SUR MARNE        
--                           COPYRIGHT (C) 1993             
--                    SPECIFICATION DU PAQUETAGE MATRIX     
--             ͼ

--ͻ
--                        Utilite du paquetage.                           
--                                                                        
-- Dans ce paquetage, on trouvera des procedures et fonctions destinees a 
-- faciliter la gestion de matrices carrees et de vecteurs de dimensions  
-- au plus DIM_MAX declaree en constante.                                 
--ͼ

with TEXT_IO, COMMON_MATRIX;
use COMMON_MATRIX;

package MATRIX is

procedure GET(A: out MATRICE);
procedure MATRICE_ALEATOIRE(A: out MATRICE);
procedure MATRICE_DU_FICHIER(A: out MATRICE;
			     NOM_DE_REPERTOIRE: in STRING := "A:\DONNEES");
procedure MATRICE_HILBERT(A: out MATRICE);
procedure MATRICE_TEST(A: in out MATRICE);
procedure MATRICE_VAN_DER_MONDE(v: in VECTEUR; A: in out MATRICE);
procedure GET(A: out MATRICE_TRIDIAGONALE);
procedure MATRICE_TRIDIAG_ALEATOIRE(A: out MATRICE_TRIDIAGONALE);
procedure MATRICE_TRIDIAG_DU_FICHIER(A: out MATRICE_TRIDIAGONALE;
			     NOM_DE_REPERTOIRE: in STRING := "A:\DONNEES");
procedure MATRICE_SYMETRIQUE(A: in out MATRICE);
procedure MATRICE_SYM_ALEATOIRE(A: in out MATRICE);
procedure MATRICE_SYM_DU_FICHIER(A: in out MATRICE;
			     NOM_DE_REPERTOIRE: in STRING := "A:\DONNEES");
procedure PUT_LINE(A: in MATRICE; FORE: in TEXT_IO.FIELD := 6;
				  AFT: in TEXT_IO.FIELD := 4;
				  EXP: in TEXT_IO.FIELD := 0);
procedure PUT_LINE(A: in MATRICE_TRIDIAGONALE;
				  FORE: in TEXT_IO.FIELD := 6;
				  AFT: in TEXT_IO.FIELD := 4;
				  EXP: in TEXT_IO.FIELD := 0);
procedure GET(v: out VECTEUR);
procedure VECTEUR_ALEATOIRE(v: out VECTEUR);
procedure VECTEUR_DU_FICHIER(v: out VECTEUR;
			     NOM_DE_REPERTOIRE: in STRING := "A:\DONNEES");
procedure PUT_LINE(v: in VECTEUR; FORE: in TEXT_IO.FIELD := 6;
				  AFT: in TEXT_IO.FIELD := 4;
				  EXP: in TEXT_IO.FIELD := 0);
function TRACE(A: in MATRICE) return FLOAT;
function TRANSPOSE(A: in MATRICE) return MATRICE;
function "+"(A, B: in  MATRICE) return  MATRICE;
function "-"(A, B: in  MATRICE) return  MATRICE;
function "*"(A, B: in MATRICE) return MATRICE;
function "*"(x: in FLOAT; A: in MATRICE) return MATRICE;
function "*"(A: in MATRICE; v: in VECTEUR) return VECTEUR;
function "*"(A: in MATRICE_TRIDIAGONALE; v: in VECTEUR) return VECTEUR;
function "+"(u, v: in  VECTEUR) return  VECTEUR;
function "-"(u, v: in  VECTEUR) return  VECTEUR;
function "*"(x: in FLOAT;u: in  VECTEUR) return  VECTEUR;
function NORME_DU_SUP(v: in VECTEUR) return FLOAT;
function NORME_EUCLIDIENNE(v: in VECTEUR) return FLOAT;
function PRODUIT_SCALAIRE(u, v: in VECTEUR) return FLOAT;

end MATRIX;

