--             ͻ
--                             J. E. ROMBALDI               
--                      E.N.S.A.M. CHALONS SUR MARNE        
--                           COPYRIGHT (C) 1993             
--                 SPECIFICATION DU PAQUETAGE POLY          
--             ͼ

--ͻ
--                        Utilite du paquetage.                           
--                                                                        
-- Dans ce paquetage, on trouvera des procedures permettant de manipuler  
-- des polynomes a coefficients reels et de resoudre des equations        
-- algebriques.                                                           
--ͼ
with TEXT_IO, COMMON_POLY, COMMON_MATRIX, NOMBRES_COMPLEXES;
use COMMON_POLY, COMMON_MATRIX, NOMBRES_COMPLEXES;
package POLY is

type VECTEUR_COMPLEXE is array(INDICE_COEFFICIENTS range <>) of COMPLEXE;

procedure GET(P: out POLYNOME);
procedure POLYNOME_ALEATOIRE(P: out POLYNOME);
procedure PUT_LINE(P: in POLYNOME; FORE: in TEXT_IO.FIELD := 6;
                                   AFT: in TEXT_IO.FIELD := 4;
                                   EXP: in TEXT_IO.FIELD := 0);
function EVALUE(P: in POLYNOME; x: in FLOAT) return FLOAT;
function EVALUE_DERIVEE(P: in POLYNOME; x: in FLOAT) return FLOAT;
procedure TRACE_POLYNOME(P: in POLYNOME; xMin, xMax: in FLOAT);
procedure NEWTON_MAEHLY(P: in POLYNOME; x: in out VECTEUR);
procedure BAIRSTOW(P: in POLYNOME; x: out VECTEUR_COMPLEXE);
ERREUR_CONVERGENCE: exception;
end POLY;