with TEXT_IO, IIO, CRT, MATH0, MATH1, COMMON_GRAPH, GRAPH, MATH3;
use TEXT_IO, IIO, CRT, MATH0, MATH1, COMMON_GRAPH, GRAPH, MATH3;

procedure POLYGO is
MAX_SOMMETS: constant INTEGER := 30;
type INDICE is (REEL, IMAGINAIRE);
type COMPLEXE is array(INDICE) of FLOAT;
type POLYGONE is array(INTEGER range <>) of COMPLEXE;

xFenMin, xFenMax, yFenMin, yFenMax, RHO, Rho1, x, y, THETA: FLOAT;
n, k, d: INTEGER;

procedure DEFINIT_POLYGONE(x , y , THETA: in FLOAT;
			   M : in out POLYGONE) is
begin
    M(M'FIRST)(REEL) := x;
    M(M'FIRST)(IMAGINAIRE) := y;
    for i in M'FIRST + 1..M'LAST
    loop
	M(i)(REEL) := M(i-1)(REEL)*COS(THETA) -
		      M(i-1)(IMAGINAIRE)*SIN(THETA);
	M(i)(IMAGINAIRE) := M(i-1)(REEL)*SIN(THETA) +
			    M(i-1)(IMAGINAIRE)*COS(THETA);
    end loop;
end DEFINIT_POLYGONE;

procedure TRACE_POLYGONE(M: in POLYGONE) is
begin
    DEPLACE(M(M'FIRST)(REEL),M(M'FIRST)(IMAGINAIRE));
    for i in M'FIRST + 1..M'LAST
    loop
       COULEUR_PIXEL := COULEUR'VAL(i mod 15);
       TRACE(M(i)(REEL),M(i)(IMAGINAIRE));
    end loop;
end TRACE_POLYGONE;

procedure INSECTE_PLUS(k , d: in INTEGER; M: in out POLYGONE) is
Mk: POLYGONE(M'range) := M;
p, j: INTEGER;
begin
    for p in M'FIRST..k
    loop
	for j in M'FIRST..M'LAST - 1
	loop
	    Mk(j)(REEL) := Mk(j)(REEL) +
			   ((Mk(j+1)(REEL) - Mk(j)(REEL))/FLOAT(d));
	    Mk(j)(IMAGINAIRE) := Mk(j)(IMAGINAIRE) +
			   ((Mk(j+1)(IMAGINAIRE) - Mk(j)(IMAGINAIRE))/FLOAT(d));
	end loop;
	Mk(M'LAST)(REEL) := Mk(M'FIRST)(REEL);
	Mk(M'LAST)(IMAGINAIRE) := Mk(M'FIRST)(IMAGINAIRE);
	TRACE_POLYGONE(Mk);
    end loop;
end INSECTE_PLUS;

procedure INSECTE_MOINS(k, d: in INTEGER; M: in POLYGONE) is
Mk: POLYGONE(M'range) := M;
p, j: INTEGER;
begin
    for p in M'FIRST..k
    loop
	for j in reverse M'FIRST + 1..M'LAST
	loop
	    Mk(j)(REEL) := Mk(j)(REEL) +
			  (Mk(j-1)(REEL) - Mk(j)(REEL))/FLOAT(d);
	    Mk(j)(IMAGINAIRE) := Mk(j)(IMAGINAIRE) +
			  (Mk(j-1)(IMAGINAIRE) - Mk(j)(IMAGINAIRE))/FLOAT(d);
	end loop;
	Mk(M'FIRST)(REEL) := Mk(M''LAST)(REEL);
	Mk(M'FIRST)(IMAGINAIRE) := Mk(M'LAST)(IMAGINAIRE);
	TRACE_POLYGONE(Mk);
    end loop;
end INSECTE_MOINS;

begin
  CLRSCR;
  PUT_LINE("    Considerations artistiques sur des polygones.");
  NEW_LINE;
  ENTRER_ENTIER_BORNE(2,MAX_SOMMETS,n," Nombre de cotes du polygone: ");
  Theta := 6.28318530718/FLOAT(n);
  x := 1.0;
  y := 0.0;
  d := 20;
  k := 40;
  declare
     M: POLYGONE(0..n);
     Ms: POLYGONE(0..3);
  begin
     DEFINIT_POLYGONE(x,y,Theta,M);
     xFenMin := x;
     xFenMax := x;
     yFenMin := y;
     yFenMax := y;
     for i in M'FIRST + 1..M'LAST
     loop
	xFenMin := MIN(xFenMin,M(i)(Reel));
	xFenMax := MAX(xFenMax,M(i)(Reel));
	yFenMin := MIN(yFenMin,M(i)(Imaginaire));
	yFenMax := MAX(yFenMax,M(i)(Imaginaire));
     end loop;
     Rho := (xFenMax - xFenMin)/20.0;
     Rho1 := (yFenMax - yFenMin)/20.0;
     xFenMin := xFenMin - Rho;
     xFenMax := xFenMax + Rho;
     yFenMin := yFenMin - Rho1;
     yFenMax := yFenMax + Rho1;
     INIT_GRAPHIQUE;
     FENETRE_GRAPHIQUE(xFenMin,xFenMax,yFenMin,yFenMax);
     TRACE_POLYGONE(M);
     PAUSE_GRAPHIQUE;
     CLEAR_SCREEN;
     TRACE_POLYGONE(M);
     INSECTE_PLUS(k,d,M);
     PAUSE_GRAPHIQUE;
     CLEAR_SCREEN;
     for  s in M'FIRST + 1..M'LAST
     loop
	for Ind in REEL..IMAGINAIRE
	loop
	   Ms(0)(Ind) := 0.0;
	   Ms(3)(Ind) := 0.0;
	   Ms(1)(Ind) := M(s-1)(Ind);
	   Ms(2)(Ind) := M(s)(Ind);
	end loop;
	TRACE_POLYGONE(Ms);
	if (s mod 2 = 1) then
	   INSECTE_PLUS(k , d , Ms);
	else
	  INSECTE_MOINS(k, d, Ms);
	end if;
     end loop;
     PAUSE_GRAPHIQUE;
     CLEAR_SCREEN;
     for i in M'FIRST..M'LAST - 1
     loop
	for j in i + 1..M'LAST - 1
	loop
	   DEPLACE(M(i)(Reel),M(i)(Imaginaire));
	   TRACE(M(j)(Reel),M(j)(Imaginaire));
	end loop;
     end loop;
  end;
  PAUSE_GRAPHIQUE;
  MODE_TEXTE;
end POLYGO;






