with TEXT_IO, IIO, FIO, COMMON_MATH0, MATH0, MATH1, MATH2;
use TEXT_IO, IIO, FIO, COMMON_MATH0, MATH0, MATH1, MATH2;

package body EQUADIFF_11_GENERIQUE is

Eps0: constant FLOAT := 1.0E-6;
NB_PAS: constant INTEGER := 400;

-- RESOLUTION D'UNE EQUATION DIFFERENTIELLE Y' = F(X,Y)

procedure RK4_11(X_INITIAL, Y_INITIAL, h: in FLOAT;
		 X_FINAL, Y_FINAL: in out FLOAT) is
k1, k2, k3, k4: FLOAT;
begin
    k1 := h*f11(X_INITIAL,Y_INITIAL);
    X_FINAL := X_INITIAL + h/2.0;
    k2 := h*f11(X_FINAL,Y_INITIAL + 0.5*k1);
    k3 := h*f11(X_FINAL,Y_INITIAL + 0.5*k2);
    X_FINAL := X_INITIAL + h;
    k4 := h*f11(X_FINAL,Y_INITIAL + k3);
    Y_FINAL := Y_INITIAL + (k1 + 2.0*(k2 + k3) + k4)/6.0;
end RK4_11;

procedure RK4_11_CONTROLE(X_INITIAL, Y_INITIAL, h0: in FLOAT;
			  X_FINAL, Y_FINAL, H_INITIAL: in out FLOAT) is
y_Temporaire1, y_Temporaire2: FLOAT;
Eps: FLOAT;
begin
    loop
	RK4_11(X_INITIAL,Y_INITIAL,H_INITIAL/2.0,X_FINAL,y_Temporaire1);
	RK4_11(X_INITIAL + H_INITIAL*0.5,y_Temporaire1,H_INITIAL*0.5,
	       X_FINAL, y_Temporaire2);
	RK4_11(X_INITIAL,Y_INITIAL,H_INITIAL,X_FINAL,y_Temporaire1);
	Eps := abs(y_Temporaire2 - y_Temporaire1);
	Eps := Eps/Eps0;
	exit when (Eps < 1.0);
	if (Eps > 1.0) then
	   H_INITIAL := H_INITIAL*Eps**(-0.2);
	elsif H_INITIAL < h0/2.0 then
	   H_INITIAL := H_INITIAL*2.0;
	end if;
    end loop;
    Y_FINAL := (16.0*y_Temporaire2 - y_Temporaire1)/15.0;
end RK4_11_CONTROLE;

procedure RESOLUTION_RK4_11(a, b, ya: in FLOAT;
			    AFFICHER: in BOOLEAN; x, y: in out VECTEUR) is
h0: FLOAT;
begin
  x(x'FIRST) := a;
  h0 := (b - a)/FLOAT(x'LENGTH - 1);
  y(y'FIRST) := ya;
  if AFFICHER then
     PUT(IMP,"x(0) = ");
     PUT(IMP,x(x'FIRST),6,3,0);
     PUT(IMP,"  y(0) = ");
     PUT(IMP,y(y'FIRST),6,6,0);
     NEW_LINE(IMP);
  end if;
  for i in x'FIRST + 1..x'LAST
  loop
    RK4_11(x(i-1),y(i-1),h0,x(i),y(i));
    if AFFICHER then
      PUT(IMP,"x(");
      PUT(IMP,i,3);
      PUT(IMP,") = ");
      PUT(IMP,x(i),6,3,0);
      PUT(IMP,"  y(");
      PUT(IMP,i,3);
      PUT(IMP,") = ");
      PUT(IMP,y(i),6,6,0);
      NEW_LINE(IMP);
      if (i mod 20 = 0) then
	 PAUSE;
      end if;
    end if;
  end loop;
end RESOLUTION_RK4_11;

procedure RESOLUTION_RK4_11_CONTROLE(a, b, ya: in FLOAT;
				     AFFICHER: in BOOLEAN;
				     x, y: in out VECTEUR) is
h0, H_INITIAL: FLOAT;
CONTINUER: BOOLEAN := TRUE;
i: INTEGER;
begin
  i := x'FIRST;
  y(i) := ya;
  x(i) := a;
  if AFFICHER then
     PUT(IMP,"x(0) = ");
     PUT(IMP,x(i),6,3,0);
     PUT(IMP,"  y(0) = ");
     PUT(IMP,y(i),6,6,0);
     NEW_LINE(IMP);
  end if;
  h0 := (b - a)/FLOAT(NB_PAS);
  H_INITIAL := h0;
  while CONTINUER
  loop
      RK4_11_CONTROLE(x(i),y(i),h0,x(i+1),y(i+1),H_INITIAL);
      i := i + 1;
      if AFFICHER then
	 PUT(IMP,"x(");
	 PUT(IMP,i,3);
	 PUT(IMP,") = ");
	 PUT(IMP,x(i),6,3,0);
	 PUT(IMP,"  y(");
	 PUT(IMP,i,3);
	 PUT(IMP,") = ");
	 PUT(IMP,y(i),6,6,0);
	 NEW_LINE(IMP);
	 if (i mod 20 = 0) then
	    PAUSE;
	 end if;
      end if;
      CONTINUER := (x(i) + H_INITIAL <= b) and (i < x'LAST - 1);
   end loop;
   h0 := MIN(h0,b - x(i));
   RK4_11(x(i),y(i),h0,x(i+1),y(i+1));
   i := i + 1;
   if AFFICHER then
       PUT(IMP,"x(");
       PUT(IMP,i,3);
       PUT(IMP,") = ");
       PUT(IMP,x(i),6,3,0);
       PUT(IMP,"  y(");
       PUT(IMP,i,3);
       PUT(IMP,") = ");
       PUT(IMP,y(i),6,6,0);
       NEW_LINE(IMP);
    end if;
    for j in i + 1..x'LAST loop
       x(j) := b + h0;
       y(j) := y(i);
    end loop;
end RESOLUTION_RK4_11_CONTROLE;

end EQUADIFF_11_GENERIQUE;
