--             ͻ
--                             J. E. ROMBALDI               
--                      E.N.S.A.M. CHALONS SUR MARNE        
--                           COPYRIGHT (C) 1993             
--                        SPECIFICATION DU PAQUETAGE        
--                          EQUADIFF_1Q_GENERIQUE           
--             ͼ

--ͻ
--                        Utilite du paquetage.                           
--                                                                        
-- Dans ce paquetage, on trouvera des procedures de resolution d'une      
-- equation differentielle d'ordre Q                                      
--ͼ
with COMMON_MATRIX, MATH2;
use COMMON_MATRIX, MATH2;

generic
  with function f1Q(x: in FLOAT; y: VARIABLE_2) return FLOAT;

package EQUADIFF_1Q_GENERIQUE is

-- Une equation differentielle d'ordre q s'ecrit sous la forme:
--               (q)
--              y    = f(x,y(0),y(1),...,y(q-1))   x dans (a,b)
--              y(0)(a), ..., y(q-1)(a) donnes dans R
-- ou y(j) represente la derivee d'ordre j de y pour j = 0, ..., q - 1.

procedure RESOLUTION_RK4_1Q(a, b: in FLOAT;
			    Y_INITIAL: in VARIABLE_2; AFFICHER: in BOOLEAN;
			    x, y: in out VECTEUR);
procedure RESOLUTION_RK4_1Q_CONTROLE(a, b: in FLOAT;
				     Y_INITIAL: in VARIABLE_2;
				     AFFICHER: in BOOLEAN;
				     x, y: in out VECTEUR);
end EQUADIFF_1Q_GENERIQUE;
