--             ͻ
--                             J. E. ROMBALDI               
--                      E.N.S.A.M. CHALONS SUR MARNE        
--                           COPYRIGHT (C) 1993             
--                        SPECIFICATION DU PAQUETAGE        
--                          EQUADIFF_P1_GENERIQUE           
--             ͼ

--ͻ
--                        Utilite du paquetage.                           
--                                                                        
-- Dans ce paquetage, on trouvera des procedures de resolution d'un       
-- systeme differentiel d'ordre 1                                         
--ͼ
with COMMON_MATRIX, MATH2;
use COMMON_MATRIX, MATH2;

generic
  with function fp1(j: in POSITIVE; x: in FLOAT; y: VARIABLE_2) return FLOAT;

package EQUADIFF_P1_GENERIQUE is

-- Un systeme de p equations differentielles d'ordre 1 s'ecrit sous la forme:
--              y(1)' = f(1)(x,y(1),...,y(p))
--              ............................   x dans (a,b)
--              y(p)' = f(p)(x,y(1),...,y(p))
--              y(1)(a), ..., y(p)(a) donnes dans R

procedure RESOLUTION_RK4_P1(a, b: in FLOAT;
			    Y_INITIAL: in VARIABLE_2; AFFICHER: in BOOLEAN;
			    x: in out VECTEUR; y: in out MATRICE);
procedure RESOLUTION_RK4_P1_CONTROLE(a, b: in FLOAT;
			    Y_INITIAL: in VARIABLE_2; AFFICHER: in BOOLEAN;
			    x: in out VECTEUR; y: in out MATRICE);
end EQUADIFF_P1_GENERIQUE;
