--             ͻ
--                             J. E. ROMBALDI               
--                      E.N.S.A.M. CHALONS SUR MARNE        
--                           COPYRIGHT (C) 1993             
--                        SPECIFICATION DU PAQUETAGE        
--                          EQUADIFF_PQ_GENERIQUE           
--             ͼ

--ͻ
--                        Utilite du paquetage.                           
--                                                                        
-- Dans ce paquetage, on trouvera des procedures de resolution d'un       
-- systeme differentiel d'ordre q.                                        
--ͼ
with COMMON_MATRIX, MATH2;
use COMMON_MATRIX, MATH2;

generic
  with function FPQ(j: in POSITIVE; x: in FLOAT; y: VARIABLE_2) return FLOAT;

package EQUADIFF_PQ_GENERIQUE is

-- Un systeme differentielle de p equations d'ordre q s'ecrit sous la forme:
--       (q)
--    y(1)    = f(1)(x,y(1,0),...,y(1, q -1),y(2,0),...,y(2, q - 1),...,
--                     y(p,0),...,y(p,q - 1))
--    ...............................................           x dans (a,b)
--       (q)
--    y(p)    = f(p)(x,y(1,0),...,y(1,q -1),y(2,0),...,y(2,q - 1),...,
--                     y(p,0),...,y(p,q - 1))
-- Ou y(j,i) represente la derivee d'ordre i de y(j).
-- FPQ(j,x,y) represente l'equation N j avec:
-- y(q*(j - 1) + i + 1) representant la derivee d'ordre i de y(j).

procedure RESOLUTION_RK4_PQ(a, b: in FLOAT;
			    Y_INITIAL: in MATRICE;
			    AFFICHER: in BOOLEAN;
			    x: in out VECTEUR; y: in out MATRICE);
procedure RESOLUTION_RK4_PQ_CONTROLE(a, b: in FLOAT;
			    Y_INITIAL: in MATRICE; AFFICHER: in BOOLEAN;
			    x: in out VECTEUR; y: in out MATRICE);
end EQUADIFF_PQ_GENERIQUE;
