with MATRIX, ALGEBLIN;
use MATRIX, ALGEBLIN;

package body SYSTEME_EQUATIONS_GENERIQUE is

procedure MATRICE_JACOBIENNE(x: in VARIABLE_2; df: out MATRICE) is
h: FLOAT := 1.0E-3;
xx: VARIABLE_2(x'range) := x;
a, b: FLOAT;
begin
    for i in df'range(1)
    loop
       for j in df'range(2)
       loop
	  xx(j) := x(j) + h;
	  a := f(i,xx);
	  xx(j) := x(j) - h;
	  b := f(i,xx);
	  df(i,j) := (a - b)/(2.0*h);
	  xx(j) := x(j);
       end loop;
    end loop;
end MATRICE_JACOBIENNE;

procedure NEWTON_RAPHSON(x: in out VARIABLE_2) is
MAX_ITER: constant INTEGER := 200;
Eps: constant FLOAT := 1.0E-6;
k: INTEGER := 0;
b: VECTEUR(x'range);
df: MATRICE(x'range,x'range);
begin
    loop
       k := k + 1;
       MATRICE_JACOBIENNE(x,df);
       for i in x'range
       loop
	  b(i) := f(i,x);
       end loop;
       GAUSS_JORDAN(df,b);
       for i in x'range
       loop
	  x(i) := x(i) - b(i);
       end loop;
       exit when (k = MAX_ITER) or (NORME_DU_SUP(b) < Eps);
    end loop;
    if (k = MAX_ITER) then
       raise ERREUR_CONVERGENCE;
    end if;
end NEWTON_RAPHSON;

end SYSTEME_EQUATIONS_GENERIQUE;
