--ͻ
--                  Portabilite de ce corps de paquetage.                  
-- Ce corps de paquetage est utilisable avec OPEN_ADA.                     
-- On utilise les paquetages INTERRUPT, ERRORS, FILE_IO fournis avec       
-- OPEN_ADA.                                                               
--ͼ

with TEXT_IO, IIO, LIO, FIO, INTERRUPT, ERRORS, FILE_IO, COMMON_CRT, CRT;

-- Le paquetage LIO a ete defini dans LIO.ADS par:
-- with TEXT_IO; use TEXT_IO;
-- package LIO is new TEXT_IO.INTEGER_IO(LONG_INTEGER);

use TEXT_IO, ERRORS, COMMON_CRT, CRT;

package body Math0 is

CHRONO: FLOAT := 0.0;
RANDOM_SEED: LONG_INTEGER := 99;
a_RANDOM: constant := 125; -- = 5^3

procedure GET_TIME(T: out TIME) is
R: INTERRUPT.REGISTERS;
begin
    R.AX := 16#2C00#; -- Fonction 2Ch: Donne l'heure du systeme
		      -- d'exploitation.
    INTERRUPT.VECTOR(16#21#,R); -- Interruption 21 du DOS
    T.H := R.CX/256;    -- Octet de poids fort de CX
    T.M := R.CX MOD 256;  -- Octet de poids faible de CX
    T.S := R.DX/256; -- Octet de poids fort de DX
    T.C := R.DX MOD 256; -- Octet de poids faible de DX
end GET_TIME;
--  
procedure RANDOMIZE is
T: TIME;
begin
    GET_TIME(T);
    RANDOM_SEED := LONG_INTEGER(2*T.C + 1);
end RANDOMIZE;
--  
function RANDOM return FLOAT is
begin
    RANDOM_SEED := a_RANDOM*RANDOM_SEED mod LONG_INTEGER(32_768);
    return FLOAT(RANDOM_SEED)/32_767.0;
end RANDOM;
--  
function RANDOM(n: in INTEGER) return NATURAL is
begin
    if (n <= 1) then
      return 0;
    end if;
    return INTEGER(FLOAT(n)*RANDOM);
end RANDOM;
--  
function MAJUSCULE(C: in CHARACTER) return CHARACTER is
begin
    if (C in 'a'..'z') then
      return CHARACTER'VAL(CHARACTER'POS(c) - 32);
    else
      return C;
    end if;
end MAJUSCULE;
--  
function CHAINE_ENTIERE(n: in INTEGER) return STRING is
begin
    return INTEGER'IMAGE(n);
end CHAINE_ENTIERE;
--  
function CHAINE_REELLE(x: in FLOAT) return STRING is
NBRE_DECIMALS: constant POSITIVE := 3;
n: LONG_INTEGER;
Msg: STRING(1..12) := (others => ' ');
k: INTEGER;
begin
    n := LONG_INTEGER(1.0E3*x);
    k := LONG_INTEGER'IMAGE(n)'LENGTH;
    Msg(1..k) := LONG_INTEGER'IMAGE(n);
    k := k + 1;
    for i in 0..NBRE_DECIMALS loop
      Msg(k - i) := Msg(k - i - 1);
    end loop;
    Msg(k - NBRE_DECIMALS) := '.';
    return Msg(1..k);
end CHAINE_REELLE;
--  
procedure GET_LINE(n: out INTEGER) is
begin
    IIO.GET(n);
    TEXT_IO.SKIP_LINE;
end GET_LINE;
--  
procedure GET_LINE(x: out FLOAT) is
begin
    FIO.GET(x);
    TEXT_IO.SKIP_LINE;
end GET_LINE;
--  
procedure GET_LINE(c: out CHARACTER) is
begin
    GET(c);
    SKIP_LINE;
end GET_LINE;
--  
procedure GET_LINE(Msg: out STRING) is
TAILLE: NATURAL;
begin
    Msg := (others => ' ');
    GET_LINE(Msg,TAILLE);
    if (TAILLE = Msg'LENGTH) then
       SKIP_LINE;
    end if;
end GET_LINE;
--  
procedure PAUSE is
Ch: CHARACTER;
Ligne: LIGNE_TEXTE;
begin
   if (CHOIX_AFFICHAGE = ECRAN) then
     TEXT_IO.NEW_LINE;
     Ligne := WHERE_Y;
     PUT_STRING("Appuyer sur une touche pour continuer ");
     Ch := READKEY;
     GOTOXY(0,Ligne);
     CLREOL;
   end if;
end PAUSE;
--  
procedure BIP is
begin
      PUT_CHAR(ASCII.BEL);
end BIP;
--  
function LIRE_REPONSE(Msg: in STRING) return BOOLEAN is
C: CHARACTER;
Rep: BOOLEAN;
begin
    PUT_STRING(Msg & " (O/N): ");
    loop
       C := READKEY;
       C := MAJUSCULE(C);
       if (c /= 'O') and (c /= 'N') then
	 BIP;
       else
	 exit;
       end if;
    end loop;
    PUT_CHAR(C);
    TEXT_IO.NEW_LINE;
    Rep := (c = 'O');
    return Rep;
end LIRE_REPONSE;
--  
function TRUNC(x: in FLOAT) return INTEGER is
i: INTEGER;
begin
    i := INTEGER(x);
    if ((x - FLOAT(i)) < 0.0) then
      i := i - 1;
    end if;
    return i;
end TRUNC;
--  
function FRAC(x: in FLOAT) return FLOAT is
i: INTEGER;
Aux: FLOAT;
begin
    i := TRUNC(x);
    Aux := x - FLOAT(i);
    return AUX;
end FRAC;
--  
procedure CHRONOMETRE(Top: in INTEGER) is
-- Top = 0, pour le depart du chronometre.
-- Top = 1, pour l'arret du chronometre.
T: TIME;
tt: FLOAT;
si, mi: INTEGER;
begin
    if (Top = 0) then
      GET_TIME(T);
      CHRONO := FLOAT(T.c)/100.0 + FLOAT(T.s) + 60.0*FLOAT(T.m) +
		3600.0*FLOAT(T.h);
    else
      GET_TIME(T);
      tt := FLOAT(T.c)/100.0 + FLOAT(T.s) + 60.0*FLOAT(T.m) + 3600.0*FLOAT(T.h)
	   - CHRONO;
      si := TRUNC(tt);
      tt := 100.0*FRAC(tt);
      mi := si/60;
      T.s := si mod 60;
      T.h := mi/60;
      T.m := mi mod 60;
      TEXT_IO.PUT(IMP,"Temps ecoule: ");
      IIO.PUT(IMP,T.h,2); TEXT_IO.PUT(IMP," h. ");
      IIO.PUT(IMP,T.m,2); TEXT_IO.PUT(IMP," min. ");
      IIO.PUT(IMP,T.s,2); TEXT_IO.PUT(IMP," sec. et ");
      IIO.PUT(IMP,INTEGER(tt),2); TEXT_IO.PUT_LINE(IMP," centiemes.");
    end if;
end CHRONOMETRE;
--  
generic
  type VAR is private;
  with procedure GET(v: out VAR; WIDTH: in FIELD := 0);
procedure ENTRER_VARIABLE(n: out VAR; Msg: in STRING := " ");

procedure ENTRER_VARIABLE(n: out VAR; Msg: in STRING := " ") is
Ligne: LIGNE_TEXTE;
Colonne: COLONNE_TEXTE;
Ch: CHARACTER;
begin
  PUT_STRING(Msg);
  Ligne := WHERE_Y;
  if (Ligne = 24) then
     Ligne := Ligne - 1;
  end if;
  Colonne := WHERE_X;
  loop
    begin
      GET(n);
      TEXT_IO.SKIP_LINE;
      exit;
    exception
      when DATA_ERROR | CONSTRAINT_ERROR =>
	TEXT_IO.SKIP_LINE;
	BIP;
	PUT_STRING(
	  " Donnee incorrecte, appuyer sur une touche pour recommencer: ");
	Ch := READKEY;
	GOTOXY(0,Ligne + 1); CLREOL;
	GOTOXY(Colonne,Ligne); CLREOL;
    end;
  end loop;
end ENTRER_VARIABLE;
--  
procedure ENTRER_R is new ENTRER_VARIABLE(FLOAT,FIO.GET);
procedure ENTRER_REEL(x: out FLOAT; Msg: in STRING := " ") is
begin
    ENTRER_R(x,Msg);
end ENTRER_REEL;
--  
procedure ENTRER_E is new ENTRER_VARIABLE(INTEGER,IIO.GET);
procedure ENTRER_ENTIER(n: out INTEGER; Msg: in STRING := " ") is
begin
    ENTRER_E(n,Msg);
end ENTRER_ENTIER;
--  
procedure ENTRER_EL is new ENTRER_VARIABLE(LONG_INTEGER,LIO.GET);
procedure ENTRER_ENTIER_LONG(n: out LONG_INTEGER; Msg: in STRING := " ") is
begin
    ENTRER_EL(n,Msg);
end ENTRER_ENTIER_LONG;
--  
procedure ENTRER_REEL_BORNE(rMin, rMax: in FLOAT; x: out FLOAT;
			    Msg: in STRING := " ") is
subtype REEL_BORNE is FLOAT range rMin..rMax;
procedure ENTRER_RB is new ENTRER_VARIABLE(REEL_BORNE,FIO.GET);
begin
    ENTRER_RB(x,Msg);
end ENTRER_REEL_BORNE;
--  
procedure ENTRER_ENTIER_BORNE(nMin, nMax: in INTEGER; n: out INTEGER;
			      Msg: in STRING := " ") is
subtype ENTIER_BORNE is INTEGER range nMin..nMax;
procedure ENTRER_EB is new ENTRER_VARIABLE(ENTIER_BORNE,IIO.GET);
begin
    ENTRER_EB(n,Msg);
end ENTRER_ENTIER_BORNE;
--  
procedure ENTRER_ENTIER_LONG_BORNE(nMin, nMax: in LONG_INTEGER;
				   n: out LONG_INTEGER;
				   Msg: in STRING := " ") is
subtype ENTIER_LONG_BORNE is LONG_INTEGER range nMin..nMax;
procedure ENTRER_ELB is new ENTRER_VARIABLE(ENTIER_LONG_BORNE,LIO.GET);
begin
    ENTRER_ELB(n,Msg);
end ENTRER_ENTIER_LONG_BORNE;
--  
generic
  type VARIABLE is private;
procedure ECHANGER_VARIABLES(u, v: in out VARIABLE);

procedure ECHANGER_VARIABLES(u, v: in out VARIABLE) is
Aux: Variable := u;
begin
   u := v;
   v := Aux;
end ECHANGER_VARIABLES;
--  
procedure ECHANGER_R is new ECHANGER_VARIABLES(FLOAT);
procedure ECHANGER_REELS(x, y: in out FLOAT) is
begin
    ECHANGER_R(x,y);
end ECHANGER_REELS;
--  
procedure ECHANGER_E is new ECHANGER_VARIABLES(INTEGER);
procedure ECHANGER_ENTIERS(p, q: in out INTEGER) is
begin
    ECHANGER_E(p,q);
end ECHANGER_ENTIERS;
--  
procedure LECTURE_REPERTOIRE(NOM_REPERTOIRE: in STRING) is
Archive: FILE_IO.TRANSFER_DATA;
Fichiers: FILE_IO.FILE_DATA;
DosErreur: ERRORS.EXTENDED_ERRORS;
Msg: STRING(1..15) := (others => ' ');
i: INTEGER;
begin
    FILE_IO.FIND_FIRST(NOM_REPERTOIRE,Archive,Fichiers,DosErreur);
    if (DosErreur = ERRORS.ok) then
      Msg(1..Fichiers.NAME'LENGTH) := Fichiers.NAME;
      TEXT_IO.PUT(Msg);
      Msg := (others => ' ');
      i := 1;
      loop
	i := i + 1;
	FILE_IO.FIND_NEXT(Archive,Fichiers,DosErreur);
	if (DosErreur = ERRORS.ok) then
	  Msg(1..Fichiers.NAME'LENGTH) := Fichiers.NAME;
	  TEXT_IO.PUT(Msg);
	  Msg := (others => ' ');
	  if ((i mod 5) = 0) then
	    TEXT_IO.NEW_LINE;
	  end if;
	else
	  exit;
	end if;
      end loop;
      i := i - 1;
      if ( (i mod 5) /= 0) then
	TEXT_IO.NEW_LINE;
      end if;
      TEXT_IO.NEW_LINE;
    end if;
end LECTURE_REPERTOIRE;
--  
procedure LIRE_FICHIER(FICHIER_DONNEES: in out TEXT_IO.FILE_TYPE;
		       NOM_DE_FICHIER: in out STRING;
		       NOM_DE_REPERTOIRE: in STRING := "A:\DONNEES")  is
Ligne: LIGNE_TEXTE;
Colonne: COLONNE_TEXTE;
TAILLE: NATURAL;
Ch: CHARACTER;
begin
  TEXT_IO.PUT("             Fichiers de ");
  TEXT_IO.PUT_LINE(NOM_DE_REPERTOIRE);
  TEXT_IO.NEW_LINE;
  LECTURE_REPERTOIRE (NOM_DE_REPERTOIRE & "\*.*" );
  PUT_STRING("Nom du fichier de donnees: ");
  Colonne := Where_X;
  Ligne := Where_Y;
  if (LIGNE = 24) then
     LIGNE := LIGNE - 1;
  end if;
  loop
    begin
      NOM_DE_FICHIER := (others => ' ');
      TEXT_IO.GET_LINE(NOM_DE_FICHIER,TAILLE);
      if (TAILLE = NOM_DE_FICHIER'LENGTH) then
	 TEXT_IO.SKIP_LINE;
      end if;
      TEXT_IO.OPEN(FICHIER_DONNEES,IN_FILE,
	   NOM_DE_REPERTOIRE & "\" & NOM_DE_FICHIER(1..Taille));
      exit;
      exception
	when NAME_ERROR | USE_ERROR =>
	  if (TAILLE = NOM_DE_FICHIER'LENGTH) then
	     TEXT_IO.SKIP_LINE;
	  end if;
	  Bip;
	  PUT_STRING(
     "Nom de fichier incorrect, appuyer sur une touche pour recommencer: ");
	  Ch := READKEY;
	  GOTOXY(0,Ligne + 1); CLREOL;
	  GOTOXY(Colonne,Ligne); CLREOL;
    end;
  end loop;
end LIRE_FICHIER ;
--  
function FICHIER_EXISTE(NOM_DE_FICHIER: in STRING) return BOOLEAN is
FICHIER: FILE_TYPE;
EXISTE: BOOLEAN := TRUE;
begin
    begin
       OPEN(FICHIER,IN_FILE,NOM_DE_FICHIER);
       CLOSE(FICHIER);
    exception
       when NAME_ERROR =>
	EXISTE := FALSE;
    end;
    return EXISTE;
end FICHIER_EXISTE;
--  
procedure CREER_FICHIER(FICHIER_DONNEES: in out TEXT_IO.FILE_TYPE;
			NOM_DE_FICHIER: in out STRING;
			NOM_DE_REPERTOIRE: in STRING := "A:\DONNEES")  is
TAILLE: NATURAL;
L, Ligne: LIGNE_TEXTE;
C, Colonne: COLONNE_TEXTE;
Ch: CHARACTER;
begin
    PUT_STRING("Nom de fichier a creer: ");
    Ligne := WHERE_Y;
    Colonne := WHERE_X;
    loop
       L := LIGNE;
       C := COLONNE;
       NOM_DE_FICHIER := (others => ' ');
       TEXT_IO.GET_LINE(NOM_DE_FICHIER,TAILLE);
       if (TAILLE = NOM_DE_FICHIER'LENGTH) then
	  TEXT_IO.SKIP_LINE;
       end if;
       if FICHIER_EXISTE(NOM_DE_REPERTOIRE & "\" & NOM_DE_FICHIER(1..TAILLE))
       then
	 BIP;
	 TEXT_IO.PUT_LINE("*** Attention *** Ce fichier existe deja");
	 if LIRE_REPONSE("Voulez vous l'ecraser? ") then
	   TEXT_IO.OPEN(FICHIER_DONNEES,OUT_FILE,
		NOM_DE_REPERTOIRE & "\" & NOM_DE_FICHIER(1..TAILLE));
	   TEXT_IO.NEW_LINE;
	   exit;
	 else
	   if (L >= 22) then
	     L := 21;
	   end if;
	   GOTOXY(0,L + 2); CLREOL;
	   GOTOXY(0,L + 1); CLREOL;
	   GOTOXY(C,L); CLREOL;
	 end if;
       else
	 begin
	   TEXT_IO.CREATE(FICHIER_DONNEES,OUT_FILE,
		  NOM_DE_REPERTOIRE & "\" & NOM_DE_FICHIER(1..Taille));
	   TEXT_IO.NEW_LINE;
	   exit;
	 exception
	   when USE_ERROR | DEVICE_ERROR | STATUS_ERROR | NAME_ERROR =>
	     Bip;
	     if (L = 24) then
		L := L - 1;
	     end if;
	     PUT_STRING(
      "Nom de fichier incorrect, appuyer sur une touche pour recommencer: ");
	     Ch := READKEY;
	     GOTOXY(0,L + 1); CLREOL;
	     GOTOXY(L,C); CLREOL;
	 end;
       end if;
    end loop;
end CREER_FICHIER;
--  
procedure MODE_AFFICHAGE is
NOM_DE_FICHIER: STRING(1..13);
CHOIX: INTEGER range 0..2;
begin
    CLRSCR;
    TEXT_IO.PUT_LINE("Sortie des resultats");
    TEXT_IO.NEW_LINE;
    TEXT_IO.PUT_LINE("-0- A l'ecran");
    TEXT_IO.PUT_LINE("-1- Sur l'imprimante");
    TEXT_IO.PUT_LINE("-2- Dans un fichier");
    TEXT_IO.NEW_LINE;
    ENTRER_ENTIER_BORNE(0,2,CHOIX,"Votre choix: ");
    CHOIX_AFFICHAGE := PERIPHERIQUE_DE_SORTIE'VAL(CHOIX);
    case CHOIX_AFFICHAGE is
      when ECRAN =>
	TEXT_IO.OPEN(IMP,OUT_FILE,"CON");
      when IMPRIMANTE =>
	TEXT_IO.OPEN(IMP,OUT_FILE,"PRN");
      when FICHIER =>
	CREER_FICHIER(IMP,NOM_DE_FICHIER);
    end case;
    CLRSCR;
end MODE_AFFICHAGE;
--  
-- Recherche d'un entier dans une chaine de caracteres.
-- i est l'entier trouve.
-- Si tout ce passe bien Err vaut 0, sinon il indique la position du premier
-- caractere non entier de la chaine.

procedure VAL(Msg: in STRING; DEBUT, FIN: in NATURAL;
		i: in out NATURAL; Err: in out NATURAL) is
ASCII_0: constant NATURAL := CHARACTER'POS('0'); -- = 48
type Entier is array(0..4) of NATURAL;
c: Entier;
p: NATURAL;
begin
    Err := 0; p := 0; i := 0;
    if (DEBUT > FIN) then
       PUT_LINE("Erreur dans VAL");
       PUT("DEBUT = "); IIO.PUT(DEBUT);
       PUT("  FIN = "); IIO.PUT(FIN); NEW_LINE;
       return;
    end if;
    for k in DEBUT..FIN loop
    begin
      if (Msg(k) in '0'..'9') then
	 c(p) := CHARACTER'POS(Msg(k)) - ASCII_0;
	 p := p + 1;
      else
	 Err := p + DEBUT;
	 exit;
      end if;
    exception
       when CONSTRAINT_ERROR =>
	 Err := p + DEBUT;
	 exit;
    end;
    end loop;
    if (Msg(DEBUT) in '0'..'9') then
       p := p - 1;
       i := c(p);
       for k in reverse 0..p - 1 loop
       begin
	  i := i + (10**(p - k))*c(k);
       exception
	  when NUMERIC_ERROR =>
	     Err := 5; -- Debordment du type 99_999 > 32_767
	     exit;
       end;
       end loop;
    end if;
end VAL;
--  
-- Recherche d'un reel dans une chaine de caracteres.
-- x est le reel trouve.
-- Si tout ce passe bien Err vaut 0, sinon il indique la position du premier
-- caractere non entier de la chaine.

procedure VAL(Msg: in STRING; DEBUT, FIN: in NATURAL;
		x: in out FLOAT; Err: in out NATURAL) is
ASCII_0: constant NATURAL := CHARACTER'POS('0'); -- = 48
type Reel is array(0..14) of NATURAL;
c: Reel;
p, q: NATURAL;
r, s: FLOAT;
begin
    Err := 0; p := 0; x := 0.0;
    if (DEBUT > FIN) then
       PUT_LINE("Erreur dans VAL");
       PUT("DEBUT = "); IIO.PUT(DEBUT);
       PUT("  FIN = "); IIO.PUT(FIN); NEW_LINE;
       return;
    end if;
    for k in DEBUT..FIN loop
    begin
      if (Msg(k) in '0'..'9') then
	 c(p) := CHARACTER'POS(Msg(k)) - ASCII_0;
	 p := p + 1;
      else
	 Err := p + DEBUT;
	 exit;
      end if;
    exception
       when CONSTRAINT_ERROR =>
	 Err := p + DEBUT;
	 exit;
    end;
    end loop;
    if (Msg(DEBUT) in '0'..'9') then
       p := p - 1;
       x := FLOAT(c(p));
       r := 1.0;
       for k in reverse 0..p - 1 loop
       begin
	  r := r*10.0; -- r = 10**(p - k);
	  x := x + r*FLOAT(c(k));
       end;
       end loop;
    end if;
    if (p + 2 <= Msg'LENGTH) and then (Msg(p + 2) = '.') then
       q := 0;
       Err := 0;
       for k in p + 3..FIN loop
       begin
	  if (Msg(k) in '0'..'9') then
	     c(q) := CHARACTER'POS(Msg(k)) - ASCII_0;
	     q := q + 1;
	  else
	     Err := q + p + 3;
	     exit;
	  end if;
       exception
	  when CONSTRAINT_ERROR =>
	  Err := q + p + 3;
	  exit;
       end;
       end loop;
       r := FLOAT(c(0))/10.0;
       s := 0.1;
       q := q - 1;
       for k in 1..q loop
	 s := s/10.0;
	 r := r + FLOAT(c(k))*s;
       end loop;
       x := x + r;
    end if;
end VAL;
--  
function LONGUEUR_CHAINE(Msg: STRING) return NATURAL is
Aux: NATURAL := Msg'LENGTH;
begin
    for i in reverse Msg'range
    loop
       if (Msg(i) = ' ') then
	  Aux := Aux - 1;
       end if;
    end loop;
    return Aux;
end LONGUEUR_CHAINE;
-- 

end MATH0;
